DECLARE SUB Load.Bmp (bmpfile AS STRING)
DECLARE FUNCTION opt$ (akey AS STRING)
DECLARE SUB Save.Bsv (outfile AS STRING)
TYPE BMPHeaderType
	id AS STRING * 2        'Should be "BM"
	size AS LONG            'Size of the data
	rr1 AS INTEGER
	rr2 AS INTEGER '
	offset AS LONG          'Position of start of pixel data
	horz AS LONG            '
	wid AS LONG             'Image width
	hei AS LONG             'Image height
	planes AS INTEGER       '
	bpp AS INTEGER  'Should read 8 for a 256 colour image
	pakbyte AS LONG '
	imagebytes AS LONG      'Width*Height
	xres AS LONG            '
	yres AS LONG            '
	colch AS LONG           '
	ic AS LONG
	pal AS STRING * 1024    'Stored as &amp;lt;Blue, Green, Red, 0&amp;gt;
END TYPE

ON ERROR GOTO gestionerreur
DIM infile AS STRING
DIM outfile AS STRING
infile = opt$("infile")
outfile = opt$("outfile")
IF infile = "" THEN
       INPUT "enter the input file :", infile
	IF infile = "" THEN
		PRINT "aborted"
		END
	END IF
END IF
IF LCASE$(RIGHT$(infile, 4)) <> ".bmp" THEN infile = infile + ".bmp"
IF outfile = "" THEN
	outfile = LEFT$(infile, LEN(infile) - 3) + "bsv"
END IF
IF LCASE$(RIGHT$(outfile, 4)) <> ".bsv" THEN outfile = outfile + ".bsv"

	
infile = LCASE$(infile)
outfile = LCASE$(outfile)

PRINT infile
PRINT outfile

rep = -1
fic = FREEFILE
OPEN infile FOR INPUT AS fic
CLOSE fic
IF rep = 0 THEN
	PRINT "the file dont exist"
END IF

OPEN outfile FOR INPUT AS fic
IF rep = -1 THEN
	INPUT "Enter yes to overwrite the file : ", yesno$
	IF LCASE$(yesno$) <> "yes" THEN
		PRINT "aborted"
		END
	END IF
END IF
SCREEN 13
Load.Bmp infile
   

Save.Bsv outfile
SLEEP
SCREEN 0
WIDTH 80, 25
PRINT "File converted"
END
gestionerreur:
	rep = 0
	RESUME NEXT

SUB Load.Bmp (bmpfile AS STRING)
       DIM BmpHeader AS BMPHeaderType
       fic = FREEFILE
       OPEN bmpfile FOR BINARY AS #fic
       GET #fic, , BmpHeader

	DIM pixel AS STRING * 1
	iHeight% = BmpHeader.hei
	iWidth% = BmpHeader.wid
	
	FOR y% = iHeight% - 1 TO 0 STEP -1
		FOR x% = 0 TO iWidth% - 1' TO 0 STEP -1
			GET #fic, , pixel
			PSET (x%, y%), ASC(pixel)
		NEXT x%
	NEXT y%
	CLOSE fic
END SUB

FUNCTION opt$ (akey AS STRING)
	t$ = ""
	i = INSTR(UCASE$(COMMAND$), UCASE$(akey) + "=")
	IF (i > 0) AND (i + LEN(akey) + 1) < LEN(COMMAND$) THEN
	  t$ = MID$(COMMAND$, i + LEN(akey) + 1)
	  IF LEFT$(t$, 1) = CHR$(34) THEN
		FOR i = 2 TO LEN(t$)
		  IF MID$(t$, i, 1) = CHR$(34) THEN
			t$ = MID$(LEFT$(t$, i - 1), 2)
			EXIT FOR
		  END IF
		NEXT i
	  ELSE
		  FOR i = 1 TO LEN(t$)
			IF MID$(t$, i, 1) = " " THEN
			  t$ = LEFT$(t$, i - 1)
			  EXIT FOR
			END IF
		  NEXT i
	  END IF
	END IF
	opt$ = LTRIM$(RTRIM$(t$))

END FUNCTION

SUB Save.Bsv (outfile AS STRING)

	DEF SEG = &HA000
	BSAVE outfile, 0, &HFA00
	DEF SEG

END SUB

