DECLARE SUB Encrypte (filename AS STRING, akey AS STRING)
DECLARE FUNCTION mix$ (intext AS STRING, akey AS STRING)
'$INCLUDE: 'lib\guilib.bi'
infile$ = opt$("file")
cypherkey$ = opt$("key")


IF infile$ <> "" AND cypherkey$ <> "" THEN
	Encrypte infile$, cypherkey$
	END
END IF

SUB Encrypte (filename AS STRING, akey AS STRING)
	fic = FREEFILE
	BlockSize = 512
	OPEN filename FOR BINARY AS fic
		taille = LOF(fic)
		nbrBlock = taille \ BlockSize
		FOR i = 1 TO nbrBlock
			mydata$ = STRING$(BlockSize, " ")
			GET #fic, , mydata$
			mydata$ = mix(mydata$, akey)
			SEEK #fic, SEEK(fic) - LEN(mydata$)
			PUT #fic, , mydata$
		NEXT i
		IF (taille MOD BlockSize) > 0 THEN
			mydata$ = STRING$(taille MOD BlockSize, " ")
			GET #fic, , mydata$
			mydata$ = mix(mydata$, akey)
			SEEK #fic, SEEK(fic) - LEN(mydata$)
			PUT #fic, , mydata$
		END IF
	CLOSE fic
END SUB

FUNCTION mix$ (intext AS STRING, akey AS STRING)
	outText$ = ""
	index = 1
	FOR i = 1 TO LEN(intext)
		character$ = CHR$(ASC(MID$(intext, i, 1)) XOR ASC(MID$(akey, index, 1)))
		outText$ = outText$ + character$
		index = index + 1
		IF index > LEN(akey) THEN index = 1
	NEXT i
	mix = outText$
END FUNCTION

