DECLARE FUNCTION IsFileName! (text AS STRING)
DECLARE FUNCTION GetPrevDir$ ()
DECLARE SUB LoadDir ()
'$INCLUDE: 'lib\guilib.bi'
'$INCLUDE: 'lib\mouse.bi'
'$INCLUDE: 'lib\modules.bi'
'$INCLUDE: 'lib\itemlist.bi'
'$INCLUDE: 'lib\textbox.bi'
'$INCLUDE: 'lib\shelf.bi'
'$INCLUDE: 'lib\app.bi'
'$INCLUDE: 'lib\reg.bi'
'$INCLUDE: 'srcs\fmanager.str'

'$DYNAMIC
ON ERROR GOTO catch

DIM SHARED wx1 AS INTEGER, wy1 AS INTEGER, wx2 AS INTEGER, wy2 AS INTEGER
DIM SHARED CurrDir AS STRING
DIM SHARED DirsList AS ItemList
DIM SHARED FilesLIst AS ItemList
DIM SHARED DirsData(1) AS ListItem
DIM SHARED FilesData(1) AS ListItem
DIM SHARED NbrDir AS INTEGER
DIM SHARED NbrFiles AS INTEGER
DIM SHARED DelButton AS button
DIM SHARED RenameButton AS button
DIM SHARED CypherButton AS button
DIM SHARED MkdirButton AS button
rep = -1
ON ERROR GOTO catch
CurrDir = ""
OPEN "cmdline" FOR INPUT AS 1
IF rep THEN
	INPUT #1, CurrDir
	CurrDir = LTRIM$(RTRIM$(CurrDir))
	IF LEN(CurrDir) < 3 THEN CurrDir = CurrDir + "\"
	CLOSE 1
	KILL "cmdline"
END IF

IF CurrDir = "" THEN
	CurrDir = CurrentDir
END IF

wx = 400
wy = 305
wx1 = (640 - wx) / 2
wy1 = (495 - wy) / 2
wx2 = wx1 + wx - 1
wy2 = wy1 + wy - 1

App.SetTitle (txtTitle)
App.AddMenuItem (txtMenuExit)

	Init.ItemLIst DirsList, wx1 + 5, wy1 + 35, 1, 25
	Init.ItemLIst FilesLIst, wx1 + 90, wy1 + 35, 3, 25
	Initx.Button DelButton, txtButtonDelete, wx1 + 5, wy1 + 5, wx1 + 55, wy1 + 20
	Initx.Button RenameButton, txtButtonRename, wx1 + 60, wy1 + 5, wx1 + 115, wy1 + 20
	Initx.Button CypherButton, txtButtonEncrypt, wx1 + 120, wy1 + 5, wx1 + 175, wy1 + 20
	Initx.Button MkdirButton, txtButtonMkdir, wx2 - 55, wy1 + 5, wx2 - 5, wy1 + 20
	FilesLIst.Dragable = -1
	DirsList.MaxWidth = 9
	DirsList.MinWIdth = 9



GUI.Init
Shelf.Load

App.DrawGui
Draw.Window wx1, wy1 - 15, wx2, wy2, txtTitle
debut:
LoadDir
MouseShow
Shelf.Draw

MouseShow

DO
     IF Shelf.Drag THEN
	IF MouseZOne(wx1 + 90, wy1 + 40, wx2 - 5, wy2 - 5) THEN
	       
		IF Confirm(txtCopyQuestion1 + LTRIM$(RTRIM$(Shelf.Selected)) + txtCopyQuestion2 + CurrDir + txtCopyQuestion3) THEN
			SHELL "copy " + LTRIM$(RTRIM$(Shelf.Selected)) + " " + CurrDir + ">nul"
			LoadDir
		END IF
	END IF
     END IF
     IF selectedFile$ <> "" THEN
	     IF Click.Button(DelButton) THEN
		IF Confirm("Delete " + selectedFile$ + "?") THEN
			KILL selectedFile$
			selectedFile$ = ""
			LoadDir
		 END IF
	     END IF
	     IF Click.Button(RenameButton) THEN
		   a$ = xInput(txtRenameQuestion)
		   IF a$ <> "" THEN
		   nfile$ = CurrDir + "\" + a$
		   IF INSTR(nfile$, "\\") > 0 THEN nfile$ = CurrDir + a$
		   NAME selectedFile$ AS nfile$
		   selectedFile$ = ""

		   LoadDir
		   END IF
	     END IF
	     IF Click.Button(CypherButton) THEN
		a$ = xInput(txtEncryptQuestion)
		IF a$ <> "" THEN SHELL "bin\cypher.exe file=" + selectedFile$ + " key=" + CHR$(34) + a$ + CHR$(34)
	     END IF
     END IF

     IF Click.Button(MkdirButton) THEN
	a$ = xInput("New folder name")
	IF a$ <> "" THEN
		IF LEN(a$) > 8 THEN a$ = LEFT$(a$, 8)
		d$ = CurrentDir
		IF RIGHT$(d$, 1) <> "\" THEN d$ = d$ + "\"
		d$ = d$ + a$
		MKDIR d$
		LoadDir
	END IF
     END IF
     a$ = INKEY$
     ScreenCapture a$
    

	App.Manage
	SELECT CASE SelectedMenu
		CASE txtMenuExit:
			app.Exit
	END SELECT
    
     IF NbrDir > 0 THEN Manage.ItemList DirsList, DirsData()
     IF NbrFiles > 0 THEN Manage.ItemList FilesLIst, FilesData()
     IF DirsList.SelectionChanged THEN GOSUB ChangeDIr
     IF FilesLIst.SelectionChanged THEN
		IF LEN(CurrDir) > 3 THEN
			selectedFile$ = CurrDir + "\" + LTRIM$(RTRIM$(FilesLIst.SelectedText))
		ELSE
			selectedFile$ = CurrDir + LTRIM$(RTRIM$(FilesLIst.SelectedText))
		END IF
     END IF
     IF FilesLIst.Draged THEN
	IF FilesLIst.DragY >= 470 THEN
		IF LEN(CurrDir) > 3 THEN
			selectedFile$ = CurrDir + "\" + LTRIM$(RTRIM$(FilesLIst.DragedText))
		ELSE
			selectedFile$ = CurrDir + LTRIM$(RTRIM$(FilesLIst.DragedText))
		END IF
		Shelf.AddItem selectedFile$, FilesLIst.DragedText
	END IF
     END IF
LOOP
END

ChangeDIr:
			IF LTRIM$(RTRIM$(DirsList.SelectedText)) = ".." THEN
				CurrDir = GetPrevDir
			ELSEIF LTRIM$(RTRIM$(DirsList.SelectedText)) = "." THEN
				CurrDir = CurrDir
			ELSE
				IF RIGHT$(CurrDir, 1) = "\" THEN
					CurrDir = CurrDir + LTRIM$(RTRIM$(DirsList.SelectedText))
				ELSE
					CurrDir = CurrDir + "\" + LTRIM$(RTRIM$(DirsList.SelectedText))
				END IF
			END IF
			LoadDir
			RETURN
			
RETURN

catch:
	rep = 0
	RESUME NEXT

REM $STATIC
FUNCTION GetPrevDir$
	IF LEN(CurrDir) = 3 THEN
		GetPrevDir$ = CurrDir
	ELSE
	  FOR i = LEN(CurrDir) TO 3 STEP -1
		IF MID$(CurrDir, i, 1) = "\" THEN
			GetPrevDir$ = LEFT$(CurrDir, i - 1)
			IF i = 3 THEN GetPrevDir = LEFT$(CurrDir, 3)
			EXIT FUNCTION
		END IF
	  NEXT i
	END IF
END FUNCTION

FUNCTION IsFileName (text AS STRING)
	IF LEN(LTRIM$(RTRIM$(text))) > 12 THEN
		IsFileName = 0
		EXIT FUNCTION
	ELSEIF LEN(LTRIM$(RTRIM$(text))) < 1 THEN
		IsFileName = 0
		EXIT FUNCTION
	ELSEIF LEN(LTRIM$(RTRIM$(text))) > 8 AND INSTR(text, ".") > 9 THEN
		 IsFileName = 0
		 EXIT FUNCTION
	END IF
	IsFileName = -1
END FUNCTION

SUB LoadDir
	SHELL "dir " + CurrDir + " /b /ad >dirs.tmp"
	SHELL "dir " + CurrDir + " /b >files.tmp"

	DirsList.firstitem = 0
	FilesLIst.firstitem = 0

	fic = FREEFILE
	NbrDir = 0
	OPEN "dirs.tmp" FOR INPUT AS fic
		WHILE NOT EOF(fic)
			NbrDir = NbrDir + 1
			LINE INPUT #fic, ligne$
		WEND
	CLOSE fic

	
		IF LEN(CurrDir) = 3 THEN
			min = 1
			REDIM DirsData(1 TO NbrDir) AS ListItem
		ELSE
			NbrDir = NbrDir + 1
			REDIM DirsData(1 TO NbrDir) AS ListItem
			min = 2
			DirsData(1).text = ".."
			DirsData(1).selected = 0
		END IF
       
	
	OPEN "dirs.tmp" FOR INPUT AS fic
		FOR i = min TO NbrDir
			LINE INPUT #fic, ligne$
			DirsData(i).text = LTRIM$(RTRIM$(ligne$))
			DirsData(i).selected = 0
		NEXT i
	CLOSE fic
	
	KILL "dirs.tmp"
	
	fic = FREEFILE
	NbrFiles = 0
	OPEN "files.tmp" FOR INPUT AS fic
		WHILE NOT EOF(fic)
			
			LINE INPUT #fic, ligne$
			ok = 1
			FOR z = 1 TO NbrDir
				IF LCASE$(LTRIM$(RTRIM$(ligne$))) = LCASE$(LTRIM$(RTRIM$(DirsData(z).text))) THEN ok = 0: EXIT FOR
			NEXT z
			IF LCASE$(RIGHT$(LTRIM$(RTRIM$(ligne$)), 4)) = ".tmp" THEN ok = 0
			IF LCASE$(RIGHT$(LTRIM$(RTRIM$(ligne$)), 3)) = ".sc" THEN ok = 0

			NbrFiles = NbrFiles + ok
		WEND
	CLOSE fic
	IF NbrFiles > 0 THEN
	i = 1
	REDIM FilesData(1 TO NbrFiles)   AS ListItem
	OPEN "files.tmp" FOR INPUT AS fic
		WHILE NOT EOF(fic)
			LINE INPUT #fic, ligne$
			ok = 1
			FOR z = 1 TO NbrDir
				IF LCASE$(LTRIM$(RTRIM$(ligne$))) = LCASE$(LTRIM$(RTRIM$(DirsData(z).text))) THEN ok = 0: EXIT FOR
			NEXT z
			IF LCASE$(RIGHT$(LTRIM$(RTRIM$(ligne$)), 4)) = ".tmp" THEN ok = 0
			IF LCASE$(RIGHT$(LTRIM$(RTRIM$(ligne$)), 3)) = ".sc" THEN ok = 0
		       
			IF ok = 1 THEN
				FilesData(i).text = LTRIM$(RTRIM$(ligne$))
				FilesData(i).selected = 0
				i = i + 1
			END IF
		WEND
	CLOSE fic
	END IF
	KILL "files.tmp"


	MouseHide
	Draw.Window wx1, wy1 - 15, wx2, wy2, txtTitle
	IF NbrDir > 0 THEN Draw.ItemList DirsList, DirsData()
	IF NbrFiles > 0 THEN Draw.ItemList FilesLIst, FilesData()
	LINE (wx1 + 85, wy1 + 35)-(wx1 + 85, wy2 - 10), 0, B
	Draw.Button DelButton
	Draw.Button RenameButton
	Draw.Button CypherButton
	Draw.Button MkdirButton
	MouseShow
END SUB

