'$INCLUDE: 'lib\mouse.bi'
'$INCLUDE: 'lib\guilib.bi'
'$INCLUDE: 'lib\app.bi'
'$INCLUDE: 'lib\modules.bi'
'$INCLUDE: 'srcs\pacman.str'

DECLARE SUB NextLevel ()
DECLARE SUB NewGame ()
DECLARE SUB Manage.PacMan ()
DECLARE SUB Draw.grille ()
DECLARE SUB Create.grille ()
DECLARE SUB Manage.Mechant ()
DECLARE SUB Draw.PacMan (direction AS STRING)
DECLARE SUB Draw.Case (x AS INTEGER, y AS INTEGER)
DECLARE SUB DrawPacMan (direction AS STRING)
DECLARE SUB DrawCase (x AS INTEGER, y AS INTEGER)


TYPE bonhomme
	x AS INTEGER
	y AS INTEGER
END TYPE
DIM SHARED CurrentLevel AS INTEGER
DIM SHARED pacman AS bonhomme
DIM SHARED GameStop AS INTEGER
DIM SHARED itimer AS STRING
DIM SHARED NbrDiamonds AS INTEGER
DIM SHARED points AS INTEGER
DIM SHARED maxlevel AS INTEGER
DIM SHARED NbrMechants
CONST MaxMechants = 10
CONST largeur = 19
CONST hauteur = 12
DIM SHARED Mechant(1 TO MaxMechants) AS bonhomme
DIM SHARED grille(0 TO largeur - 1, 0 TO hauteur - 1) AS INTEGER
RANDOMIZE TIMER
fic = FREEFILE
maxlevel = 4


App.SetTitle txtTitle
App.AddMenuItem txtMenuNew
App.AddMenuItem txtMenuExit

GUI.Init
App.DrawGui
NewGame
MouseShow
DO
    
	IF NOT GameStop THEN
		Manage.Mechant
		Manage.PacMan
		App.ManageKey ""
       ELSE
		a$ = INKEY$
		App.ManageKey (a$)
		IF a$ = CHR$(13) THEN NewGame
       END IF
     SELECT CASE SelectedMenu
	CASE txtMenuExit
		app.Exit
	CASE txtMenuNew
		NewGame
     END SELECT
LOOP

END

SUB Create.grille

	NbrDiamonds = 0
	fic = FREEFILE
	 fichier$ = "system\PACM" + CHR$(CurrentLevel + 48) + ".LEV"
	 DEF SEG = VARSEG(grille(0, 0))
	 BLOAD fichier$, VARPTR(grille(0, 0))
	 DEF SEG

		FOR y = 0 TO hauteur - 1
		FOR x = 0 TO largeur - 1
		IF grille(x, y) = 0 THEN
			grille(x, y) = 2
			NbrDiamonds = NbrDiamonds + 1
		END IF
		NEXT x
		NEXT y
FOR i = 1 TO NbrMechants
cherchemechan:
	Mechant(i).x = INT(RND * 17) + 2
	Mechant(i).y = INT(RND * 7) + 2
	IF Mechant(i).x < 6 OR Mechant(i).y < 6 THEN GOTO cherchemechan
	IF grille(Mechant(i).x, Mechant(i).y) = 1 THEN GOTO cherchemechan
	NEXT i
END SUB

SUB Draw.Case (x AS INTEGER, y AS INTEGER)
 MouseHide
	IF grille(x, y) = 0 THEN Draw.Xpm "xpm\dalle.xpm", (10 + (x * 32)), (40 + (y * 32))
	IF (CurrentLevel MOD 4) = 0 THEN briques$ = "xpm\bric1.xpm"
	IF (CurrentLevel MOD 4) = 1 THEN briques$ = "xpm\bric2.xpm"
	IF (CurrentLevel MOD 4) = 2 THEN briques$ = "xpm\bric3.xpm"
	IF (CurrentLevel MOD 4) = 3 THEN briques$ = "xpm\bric4.xpm"
	IF grille(x, y) = 1 THEN Draw.Xpm briques$, (10 + (x * 32)), (40 + (y * 32))
	IF grille(x, y) = 2 THEN
	 Draw.Xpm "xpm\dalle.xpm", (10 + (x * 32)), (40 + (y * 32))
	 Draw.Xpm "xpm\Diamond.xpm", (10 + (x * 32)), (40 + (y * 32))
	END IF
 MouseShow
END SUB

SUB Draw.grille
DIM x AS INTEGER
DIM y AS INTEGER
MouseHide
	FOR x = 0 TO largeur - 1
	FOR y = 0 TO hauteur - 1
	 Draw.Case x, y
	NEXT y
	NEXT x
MouseShow
END SUB

SUB Draw.PacMan (direction AS STRING)
DrawPacMan:
	SELECT CASE direction
		CASE "4"
			Draw.Case pacman.x, pacman.y
			Draw.Xpm "xpm\PacMan2.xpm", (10 + (pacman.x * 32)), (40 + (pacman.y * 32))
		CASE "8"
			Draw.Case pacman.x, pacman.y
			Draw.Xpm "xpm\PacMan3.xpm", (10 + (pacman.x * 32)), (40 + (pacman.y * 32))
		CASE "6"
			Draw.Case pacman.x, pacman.y
			Draw.Xpm "xpm\PacMan1.xpm", (10 + (pacman.x * 32)), (40 + (pacman.y * 32))
		CASE "2"
			Draw.Case pacman.x, pacman.y
			Draw.Xpm "xpm\PacMan4.xpm", (10 + (pacman.x * 32)), (40 + (pacman.y * 32))
	END SELECT
END SUB

SUB Manage.Mechant
	IF itimer = LEFT$(LTRIM$(RTRIM$(STR$(TIMER))), 5) THEN EXIT SUB
	itimer = LEFT$(LTRIM$(RTRIM$(STR$(TIMER))), 5)
	DIM dirtest1 AS INTEGER, dirtest2 AS INTEGER, dirtest3 AS INTEGER, dirtest4 AS INTEGER
	


	FOR i = 1 TO NbrMechants
	dirtest1 = 0: dirtest2 = 0: dirtest3 = 0: dirtest4 = 0
	Draw.Case Mechant(i).x, Mechant(i).y


	istep = 0
nouvelledirection:
	IF pacman.x < Mechant(i).x AND dirtest1 = 0 THEN
		direction = 1
		dirtest1 = 1
		GOTO dirtest
	END IF
	IF pacman.x > Mechant(i).x AND dirtest3 = 0 THEN
		direction = 3
		dirtest3 = 1
		GOTO dirtest
	END IF
	IF pacman.y < Mechant(i).y AND dirtest2 = 0 THEN
		direction = 2
		dirtest2 = 1
		GOTO dirtest
	END IF
	IF pacman.y > Mechant(i).y AND dirtest4 = 0 THEN
		direction = 4
		dirtest4 = 1
		GOTO dirtest
	END IF
	direction = INT(RND * 4) + 1
		'GOTO dirtest
	'END IF
dirtest:
	SELECT CASE direction
		CASE 1
			IF Mechant(i).x < 1 OR grille(Mechant(i).x - 1, Mechant(i).y) = 1 THEN GOTO nouvelledirection
			Mechant(i).x = Mechant(i).x - 1
		CASE 2
			IF Mechant(i).y < 1 OR grille(Mechant(i).x, Mechant(i).y - 1) = 1 THEN GOTO nouvelledirection
			Mechant(i).y = Mechant(i).y - 1
		CASE 3
			IF Mechant(i).x > largeur - 2 OR grille(Mechant(i).x + 1, Mechant(i).y) = 1 THEN GOTO nouvelledirection
			Mechant(i).x = Mechant(i).x + 1
		CASE 4
			IF Mechant(i).y > hauteur - 2 OR grille(Mechant(i).x, Mechant(i).y + 1) = 1 THEN GOTO nouvelledirection
			Mechant(i).y = Mechant(i).y + 1
	END SELECT
	istep = istep + 1
	IF istep < 1 THEN GOTO nouvelledirection
	Draw.Xpm "xpm\mines2.xpm", (10 + (Mechant(i).x * 32)), (40 + (Mechant(i).y * 32))
	NEXT i
END SUB

SUB Manage.PacMan
	haut$ = CHR$(0) + CHR$(&H48)
	gauche$ = CHR$(0) + CHR$(&H4B)
	droite$ = CHR$(0) + CHR$(&H4D)
	bas$ = CHR$(0) + CHR$(&H50)

	a$ = INKEY$
	IF a$ <> "" THEN
	IF a$ = gauche$ THEN a$ = "4"
	IF a$ = haut$ THEN a$ = "8"
	IF a$ = droite$ THEN a$ = "6"
	IF a$ = bas$ THEN a$ = "2"

       
	SELECT CASE a$
		CASE "4"
			IF pacman.x > 1 AND NOT (grille(pacman.x - 1, pacman.y) = 1) THEN
			 Draw.Case pacman.x, pacman.y
			 pacman.x = pacman.x - 1
			 Draw.PacMan a$
			END IF
		CASE "8"
			IF pacman.y > 1 AND NOT (grille(pacman.x, pacman.y - 1) = 1) THEN
			 Draw.Case pacman.x, pacman.y
			 pacman.y = pacman.y - 1
			 Draw.PacMan a$
			END IF
		CASE "6"
			IF pacman.x < largeur - 2 AND NOT (grille(pacman.x + 1, pacman.y) = 1) THEN
			 Draw.Case pacman.x, pacman.y
			 pacman.x = pacman.x + 1
			 Draw.PacMan a$
			END IF
		CASE "2"
			IF pacman.y < hauteur - 2 AND NOT (grille(pacman.x, pacman.y + 1) = 1) THEN
			 Draw.Case pacman.x, pacman.y
			 pacman.y = pacman.y + 1
			 Draw.PacMan a$
			END IF
	END SELECT

	IF grille(pacman.x, pacman.y) = 2 THEN
		grille(pacman.x, pacman.y) = 0
		NbrDiamonds = NbrDiamonds - 1
		points = points + 1
	       
		IF NbrDiamonds = 0 THEN
			IF CurrentLevel = maxlevel THEN
				CurrentLevel = 0
				NbrMechants = NbrMechants + 1
				IF NbrMechants = MaxMechants THEN
					LOCATE 12, 15: COLOR 12: PRINT "PERDU !!!"
					GameStop = -1

				END IF
				NextLevel
			ELSE
				NextLevel
			END IF
		END IF
	END IF
	
	END IF
	FOR i = 1 TO NbrMechants
	IF Mechant(i).x = pacman.x AND Mechant(i).y = pacman.y THEN
	 alert (txtDeath)
	 MouseShow
	 GameStop = -1
	END IF
	NEXT i
END SUB

SUB NewGame

	points = 0
	NbrMechants = 1
	CurrentLevel = 4
	pacman.x = 1
	pacman.y = 1
	GameStop = 0
	Draw.Frame 5, 35, 625, 430
	Create.grille
	Draw.grille
	Manage.Mechant
	Draw.PacMan "6"
END SUB

SUB NextLevel
	CurrentLevel = CurrentLevel + 1
	pacman.x = 1
	pacman.y = 1
	GameStop = 0
	Create.grille
	Draw.grille
	Manage.Mechant
	Draw.PacMan "6"
END SUB

