'$INCLUDE: 'lib\mouse.bi'
'$INCLUDE: 'lib\guilib.bi'
'$INCLUDE: 'lib\modules.bi'

SUB alert (message AS STRING)
	Exec.Module "dialog.exe message=" + CHR$(34) + message + CHR$(34) + " mode=alert"
	KILL "out.tmp"
END SUB

FUNCTION Confirm (message AS STRING)
	Exec.Module "dialog.exe message=" + CHR$(34) + message + CHR$(34) + " mode=question"
	fic = FREEFILE
	OPEN "out.tmp" FOR INPUT AS fic
		INPUT #fic, reponse
	CLOSE fic
	KILL "out.tmp"
	Confirm = reponse

END FUNCTION

SUB Exec.Module (fichier AS STRING)

	num$ = LEFT$(fichier, INSTR(fichier, ".") - 1)
	IF LEN(num$) > 5 THEN num$ = LEFT$(num$, 5)
	MouseHide
	SaveScreen num$
	SHELL "bin\" + fichier
	RestoreScreen num$
	MouseShow
END SUB

FUNCTION FileSelect$ (mode AS STRING, path AS STRING, ext AS STRING)
	param$ = "mode=" + mode
	IF path <> "" THEN
		param$ = param$ + " currdir=" + path
	ELSE
		param$ = param$ + " currdir=" + CurrentDir
	END IF
	IF ext <> "" THEN param$ = param$ + " ext=" + ext
	Exec.Module "fselect.exe " + param$
	fic = FREEFILE
	OPEN "out.tmp" FOR INPUT AS fic
		INPUT #fic, reponse
		IF reponse = 1 THEN INPUT #fic, fichier$
	CLOSE fic
	KILL "out.tmp"
	FileSelect$ = fichier$
END FUNCTION

FUNCTION NetFileSelect$ (mode AS STRING)
	param$ = "mode=" + mode
	Exec.Module "sfselect.exe " + param$
	fic = FREEFILE
	OPEN "out.tmp" FOR INPUT AS fic
		INPUT #fic, reponse
		IF reponse = 1 THEN INPUT #fic, fichier$
	CLOSE fic
	KILL "out.tmp"
	NetFileSelect$ = fichier$
END FUNCTION

SUB RestoreScreen (num AS STRING)
'        MouseHide
'        DEF SEG = &HA000
'        BLOAD num
'        DEF SEG
'        KILL num
'        MouseShow
	MouseHide
	total! = 38400
	cycle = 3
	DEF SEG = &HA000
	FOR i = 0 TO cycle
	      OUT &H3C4, 2
	      OUT &H3C5, 2 ^ i
	      f$ = num + CHR$(i + 48) + ".sc"
	      BLOAD f$, 0
	      KILL f$
	NEXT i
	DEF SEG
	MouseShow

END SUB

SUB SaveScreen (num AS STRING)
	MouseHide
	total! = 38400
	cycle = 3
	DEF SEG = &HA000
	FOR i = 0 TO cycle
	      OUT &H3CE, 4
	      OUT &H3CF, i
	      f$ = num + CHR$(i + 48) + ".sc"
	      BSAVE f$, 0, total!
	NEXT i
	DEF SEG
	MouseShow

END SUB

FUNCTION SelectColor
	Exec.Module "Color.exe"
	fic = FREEFILE
	OPEN "out.tmp" FOR INPUT AS fic
		INPUT #fic, reponse
		IF reponse = -1 THEN INPUT #fic, couleur
		IF reponse = 0 THEN couleur = -1
	CLOSE fic
	KILL "out.tmp"
	SelectColor = couleur
	
END FUNCTION

FUNCTION SelectDate$
	Exec.Module "datesel.exe"
	fic = FREEFILE
	day$ = "00"
	month$ = "00"
	year$ = "0000"
	OPEN "out.tmp" FOR INPUT AS fic
		INPUT #fic, reponse
		IF reponse <> 0 THEN
			INPUT #fic, day$
			INPUT #fic, month$
			INPUT #fic, year$
		END IF
	CLOSE fic

	KILL "out.tmp"
	day$ = LTRIM$(RTRIM$(day$))
	month$ = LTRIM$(RTRIM$(month$))
	year$ = LTRIM$(RTRIM$(year$))
	IF LEN(day$) < 2 THEN day$ = "0" + day$
	IF LEN(month$) < 2 THEN month$ = "0" + month$
	SelectDate$ = day$ + "-" + month$ + "-" + year$
END FUNCTION

FUNCTION xInput$ (message AS STRING)
	Exec.Module "dialog.exe message=" + CHR$(34) + message + CHR$(34) + " mode=input"
	fic = FREEFILE
	retval$ = ""
	OPEN "out.tmp" FOR INPUT AS fic
		INPUT #fic, reponse
		IF reponse THEN INPUT #fic, retval$
	CLOSE fic
	KILL "out.tmp"
	xInput$ = retval$


END FUNCTION

