'$INCLUDE: 'lib\reg.bi'

FUNCTION RegRead$ (akey AS STRING)
        retval$ = ""
        fic = FREEFILE
        DIM areg AS RegKey
        OPEN "system\reg.dat" FOR BINARY AS fic
                ok = 0
               WHILE (NOT (EOF(fic))) AND (NOT ok)
                    GET #fic, , areg
                    IF LCASE$(LTRIM$(RTRIM$(areg.RegKey))) = LCASE$(LTRIM$(RTRIM$(akey))) THEN
                         ok = -1
                         retval$ = LTRIM$(RTRIM$(areg.RegValue))
                    END IF
               WEND
        CLOSE fic
        RegRead$ = retval$
END FUNCTION

SUB RegRemove (akey AS STRING)
        fic = FREEFILE
        DIM areg AS RegKey
        OPEN "system\reg.dat" FOR BINARY AS fic
        fic2 = FREEFILE
        OPEN "system\reg.tmp" FOR BINARY AS fic2
               cpt = 0
               n = LOF(fic) \ LEN(areg)
               FOR i = 1 TO n
                    GET #fic, , areg
                    IF LCASE$(LTRIM$(RTRIM$(areg.RegKey))) <> LCASE$(LTRIM$(RTRIM$(akey))) THEN
                        PUT #fic2, , areg
                    END IF
               NEXT i
        CLOSE fic
        CLOSE fic2
        KILL "system\reg.dat"
        NAME "system\reg.tmp" AS "system\reg.dat"
END SUB

SUB RegRename (oldkey AS STRING, newkey AS STRING)
        fic = FREEFILE
        DIM areg AS RegKey
        OPEN "system\reg.dat" FOR BINARY AS fic
                ok = 0
               WHILE (NOT (EOF(fic))) AND (NOT ok)
                    GET #fic, , areg
                    IF LCASE$(LTRIM$(RTRIM$(areg.RegKey))) = LCASE$(LTRIM$(RTRIM$(oldkey))) THEN
                         ok = -1
                         areg.RegKey = LTRIM$(RTRIM$(newkey))
                         SEEK #fic, SEEK(fic) - LEN(areg)
                         PUT #fic, , areg
                    END IF
               WEND
        CLOSE fic

END SUB

SUB RegWrite (akey AS STRING, avalue AS STRING)
        fic = FREEFILE
        DIM areg AS RegKey
        OPEN "system\reg.dat" FOR BINARY AS fic
                ok = 0
               WHILE (NOT (EOF(fic))) AND (NOT ok)
                    GET #fic, , areg
                    IF LCASE$(LTRIM$(RTRIM$(areg.RegKey))) = LCASE$(LTRIM$(RTRIM$(akey))) THEN
                         ok = -1
                         areg.RegValue = LTRIM$(RTRIM$(avalue))
                         SEEK #fic, SEEK(fic) - LEN(areg)
                         PUT #fic, , areg
                    END IF
               WEND
               IF NOT ok THEN
                areg.RegKey = akey
                areg.RegValue = LTRIM$(RTRIM$(avalue))
                PUT #fic, , areg
               END IF
        CLOSE fic
END SUB

