'$INCLUDE: 'lib\mouse.bi'
'$INCLUDE: 'lib\guilib.bi'
'$INCLUDE: 'lib\reg.bi'
'$INCLUDE: 'lib\shelf.bi'
CONST MaxSHelf = 10
DIM SHARED ShelfItems(1 TO MaxSHelf) AS ShelfItem
DIM SHARED NbrShelf AS INTEGER
DIM SHARED ShelfSelectedIndex    AS INTEGER

SUB Shelf.AddItem (path AS STRING, text AS STRING)
	IF NbrShelf = MaxSHelf THEN
		FOR i = 1 TO MaxSHelf - 1
		   ShelfItems(i) = ShelfItems(i + 1)
		   RegWrite "Shelf:Item" + LTRIM$(RTRIM$(STR$(i))) + ":path", ShelfItems(i).path
		   RegWrite "Shelf:Item" + LTRIM$(RTRIM$(STR$(i))) + ":text", ShelfItems(i).text
		NEXT i
		NbrShelf = NbrShelf - 1

	END IF
	NbrShelf = NbrShelf + 1
	ShelfItems(NbrShelf).path = path
	ShelfItems(NbrShelf).text = text
	RegWrite "Shelf:Item" + LTRIM$(RTRIM$(STR$(NbrShelf))) + ":path", ShelfItems(NbrShelf).path
	RegWrite "Shelf:Item" + LTRIM$(RTRIM$(STR$(NbrShelf))) + ":text", ShelfItems(NbrShelf).text
	RegWrite "SHelf:NbrSHelf", LTRIM$(RTRIM$(STR$(NbrShelf)))
	Shelf.Draw
END SUB

FUNCTION Shelf.Drag%
	xpos% = 0
	FOR i = 1 TO NbrShelf
		t$ = LTRIM$(RTRIM$(ShelfItems(i).text))
		w% = (LEN(t$) * 8) + 4
		x1% = xpos%
		x2% = x1% + w%
		y1% = 468
		y2% = 479
		xpos% = xpos% + w%
		IF MouseClicRight AND MouseZOne(x1%, y1%, x2%, y2%) THEN
			DO: LOOP UNTIL NOT (MouseClicRight AND MouseZOne(x1%, y1%, x2%, y2%))
			IF MouseZOne(x1%, y1%, x2%, y2%) THEN
				Shelf.Remove (i)
			END IF
			EXIT FUNCTION
		END IF
		IF MouseClicLeft AND MouseZOne(x1%, y1%, x2%, y2%) THEN
			nxpos% = 0: nypos% = 0: t$ = LTRIM$(RTRIM$(ShelfItems(i).text))
			IF DragDrop(x1%, y1%, x2%, y2%, nxpos%, nypos%, t$) THEN
				IF nypos% < 460 THEN
					Shelf.Drag% = -1
					ShelfSelectedIndex = i
				      
				END IF

			END IF
			EXIT FUNCTION
		END IF
	       
	       
	       
		
	NEXT i

END FUNCTION

SUB Shelf.Draw
	MouseHide
	Draw.Frame 0, 468, 639, 479
	xpos% = 0
	FOR i = 1 TO NbrShelf
		t$ = LTRIM$(RTRIM$(ShelfItems(i).text))
		w% = (LEN(t$) * 8) + 4
		x1% = xpos%
		Draw.Text t$, x1%, 470, TextColor, -1
		xpos% = xpos% + w%
	NEXT i
	MouseShow
END SUB

SUB Shelf.Load
	NbrShelf = VAL(RegRead("Shelf:NbrShelf"))
	IF NbrShelf > MaxSHelf THEN NbrShelf = MaxSHelf
	FOR i = 1 TO NbrShelf
		ShelfItems(i).path = LTRIM$(RTRIM$(RegRead("Shelf:Item" + LTRIM$(RTRIM$(STR$(i))) + ":path")))
		ShelfItems(i).text = LTRIM$(RTRIM$(RegRead("Shelf:Item" + LTRIM$(RTRIM$(STR$(i))) + ":text")))
	NEXT i
END SUB

SUB Shelf.Remove (num AS INTEGER)
		RegRemove ("Shelf:Item" + LTRIM$(RTRIM$(STR$(NbrShelf))) + ".path")
		RegRemove ("Shelf:Item" + LTRIM$(RTRIM$(STR$(NbrShelf))) + ".text")

		NbrShelf = NbrShelf - 1
		RegWrite "SHelf:NbrShelf", STR$(NbrShelf)

		FOR i = num TO NbrShelf
		   ShelfItems(i) = ShelfItems(i + 1)
		   RegWrite "Shelf:Item" + LTRIM$(RTRIM$(STR$(i))) + ":path", ShelfItems(i).path
		   RegWrite "Shelf:Item" + LTRIM$(RTRIM$(STR$(i))) + ":text", ShelfItems(i).text
		NEXT i
		Shelf.Draw

END SUB

FUNCTION Shelf.Selected$
	Shelf.Selected$ = LTRIM$(RTRIM$(ShelfItems(ShelfSelectedIndex).path))
END FUNCTION

