DECLARE SUB Manage.Palette ()
DECLARE SUB Draw.Palette ()
'$INCLUDE: 'lib\guilib.bi'
'$INCLUDE: 'lib\mouse.bi'
'$INCLUDE: 'lib\reg.bi'
'$INCLUDE: 'lib\locale.bi'

GUI.Init

DIM SHARED SelectedColor AS INTEGER
DIM SHARED wx1 AS INTEGER, wy1 AS INTEGER, wx2 AS INTEGER, wy2 AS INTEGER
DIM SHARED confirmbutton AS button
DIM SHARED cancelButton AS button

wx = 157
wy = 115
wx1 = (xres - wx) \ 2
wy1 = (yres - wy) \ 2
wx2 = wx1 + wx - 1
wy2 = wy1 + wy - 1

	Initx.Button confirmbutton, Localize("system.str", "txtOk"), wx1 + 5, wy2 - 17, wx1 + 55, wy2 - 5
	Initx.Button cancelButton, Localize("System.str", "txtCancel"), wx2 - 55, wy2 - 17, wx2 - 5, wy2 - 5

Draw.Window wx1, wy1 - 15, wx2, wy2, Localize("color.str", "txtColSelTitle")
Draw.Button confirmbutton
Draw.Button cancelButton
Draw.Palette
MouseShow
DO
     a$ = INKEY$
     ScreenCapture a$
     Manage.Palette
     IF (Click.Button(confirmbutton) OR a$ = CHR$(13)) THEN
	fic = FREEFILE
	OPEN "out.tmp" FOR OUTPUT AS fic
		PRINT #fic, -1
		PRINT #fic, SelectedColor
	CLOSE fic
	EXIT DO
     END IF
     IF Click.Button(cancelButton) OR a$ = CHR$(27) THEN
	fic = FREEFILE
	OPEN "out.tmp" FOR OUTPUT AS fic
	       PRINT #fic, 0
	CLOSE fic
	EXIT DO
     END IF
LOOP
END

SUB Draw.Palette
	MouseHide
	DIM x1 AS INTEGER, y1 AS INTEGER, x2 AS INTEGER, y2 AS INTEGER
	FOR i = 0 TO 16
		x = i MOD 4
		y = i \ 4
		x1 = wx1 + 5 + x * 37
		y1 = wy1 + 5 + y * 17
		x2 = x1 + 35
		y2 = y1 + 15
		IF i < 16 THEN
			LINE (x1, y1)-(x2, y2), i, BF
		ELSE
			LINE (x1, y1)-(x2, y2), 15, BF
			LINE (x1, y1)-(x2, y2), 0, B
			LINE (x1, y1)-(x2, y2), 0
			LINE (x1, y2)-(x2, y1), 0
		END IF
	NEXT i
	IF SelectedColor < 16 THEN
		LINE (confirmbutton.x2 + 2, confirmbutton.y1)-(cancelButton.x1 - 2, confirmbutton.y2), SelectedColor, BF
		LINE (confirmbutton.x2 + 2, confirmbutton.y1)-(cancelButton.x1 - 2, confirmbutton.y2), 0, B
	ELSE
		LINE (confirmbutton.x2 + 2, confirmbutton.y1)-(cancelButton.x1 - 2, confirmbutton.y2), 15, BF
		LINE (confirmbutton.x2 + 2, confirmbutton.y1)-(cancelButton.x1 - 2, confirmbutton.y2), 0, B
		LINE (confirmbutton.x2 + 2, confirmbutton.y1)-(cancelButton.x1 - 2, confirmbutton.y2), 0
		LINE (confirmbutton.x2 + 2, confirmbutton.y2)-(cancelButton.x1 - 2, confirmbutton.y1), 0
	END IF
	MouseShow
END SUB

SUB Manage.Palette
	DIM x1 AS INTEGER, y1 AS INTEGER, x2 AS INTEGER, y2 AS INTEGER
	FOR i = 0 TO 16
		x = i MOD 4
		y = i \ 4
		x1 = wx1 + 5 + x * 37
		y1 = wy1 + 5 + y * 17
		x2 = x1 + 35
		y2 = y1 + 15
	       
		IF MouseZOne(x1, y1, x2, y2) AND MouseClicLeft THEN
			DO: LOOP UNTIL NOT (MouseZOne(x1, y1, x2, y2) AND MouseClicLeft)
			IF MouseZOne(x1, y1, x2, y2) THEN
				SelectedColor = i
				Draw.Palette
				'LINE (confirmbutton.x2 + 2, confirmbutton.y1)-(cancelButton.x1 - 2, confirmbutton.y2), SelectedColor, BF
				'LINE (confirmbutton.x2 + 2, confirmbutton.y1)-(cancelButton.x1 - 2, confirmbutton.y2), 0, B
			END IF
		END IF
	NEXT i
END SUB

