DECLARE FUNCTION DayOfWeek% (Day%, Month%, Year%)
DECLARE FUNCTION NbrDayOfMonth% (Month AS INTEGER, Year AS INTEGER)
DECLARE FUNCTION NbrDayOfYear% (Year AS INTEGER)
'$INCLUDE: 'lib\guilib.bi'
'$INCLUDE: 'lib\mouse.bi'
'$INCLUDE: 'lib\locale.bi'



GUI.Init

DIM SHARED wx1 AS INTEGER, wy1 AS INTEGER, wx2 AS INTEGER, wy2 AS INTEGER
DIM SHARED ConfirmButton AS Button
DIM SHARED CancelButton AS Button
DIM NextMonthBtn AS Button
DIM PrevMonthBtn AS Button
DIM NextYearBtn AS Button
DIM PrevYearBtn AS Button
DIM SHARED DayBtn(1 TO 31) AS Button

DIM SHARED CurrentMonth AS INTEGER
DIM SHARED CurrentYear AS INTEGER
DIM SHARED CurrentDay AS INTEGER
DIM SHARED FirstDayOfMonth AS INTEGER
DIM SHARED MOnthStr(1 TO 12) AS STRING
DIM SHARED DayStr(1 TO 7) AS STRING
MOnthStr(1) = Localize("Calendar.str", "txtMonthJan")
MOnthStr(2) = Localize("Calendar.str", "txtMonthFeb")
MOnthStr(3) = Localize("Calendar.str", "txtMonthMar")
MOnthStr(4) = Localize("Calendar.str", "txtMonthApr")
MOnthStr(5) = Localize("Calendar.str", "txtMonthMay")
MOnthStr(6) = Localize("Calendar.str", "txtMonthJun")
MOnthStr(7) = Localize("Calendar.str", "txtMonthJul")
MOnthStr(8) = Localize("Calendar.str", "txtMonthAug")
MOnthStr(9) = Localize("Calendar.str", "txtMonthSep")
MOnthStr(10) = Localize("Calendar.str", "txtMonthOct")
MOnthStr(11) = Localize("Calendar.str", "txtMonthNov")
MOnthStr(12) = Localize("Calendar.str", "txtMonthDec")
DayStr(1) = Localize("Calendar.str", "txtDayMon")
DayStr(2) = Localize("Calendar.str", "txtDayTue")
DayStr(3) = Localize("Calendar.str", "txtDayWed")
DayStr(4) = Localize("Calendar.str", "txtDayThu")
DayStr(5) = Localize("Calendar.str", "txtDayFri")
DayStr(6) = Localize("Calendar.str", "txtDaySat")
DayStr(7) = Localize("Calendar.str", "txtDaySun")

CurrentMonth = VAL(LEFT$(DATE$, 2))
CurrentDay = VAL(MID$(DATE$, 4, 2))
CurrentYear = VAL(RIGHT$(DATE$, 4))



wx = 260
wy = 260
wx1 = (xres - wx) \ 2
wy1 = (yres - wy) \ 2
wx2 = wx1 + wx - 1
wy2 = wy1 + wy - 1

Initx.Button CancelButton, Localize("System.str", "txtCancel"), wx2 - 75, wy2 - 25, wx2 - 5, wy2 - 5
Initx.Button PrevYearBtn, "<<", wx1 + 5, wy1 + 5, wx1 + 25, wy1 + 25
Initx.Button NextYearBtn, ">>", wx2 - 25, wy1 + 5, wx2 - 5, wy1 + 25
Initx.Button PrevMonthBtn, "<", wx1 + 30, wy1 + 5, wx1 + 50, wy1 + 25
Initx.Button NextMonthBtn, ">", wx2 - 50, wy1 + 5, wx2 - 30, wy1 + 25
GOSUB DrawALl
MouseShow
DO
     a$ = INKEY$
     ScreenCapture a$
     nb = NbrDayOfMonth(CurrentMonth, CurrentYear)
     FOR i% = 1 TO nb
	IF Click.Button(DayBtn(i%)) THEN
	fic = FREEFILE
	OPEN "out.tmp" FOR OUTPUT AS fic
	       PRINT #fic, -1
	       PRINT #fic, i%
	       PRINT #fic, CurrentMonth%
	       PRINT #fic, CurrentYear%
	CLOSE fic
	EXIT DO

	END IF
     NEXT i%
     IF Click.Button(CancelButton) OR a$ = CHR$(27) THEN
	fic = FREEFILE
	OPEN "out.tmp" FOR OUTPUT AS fic
	       PRINT #fic, 0
	CLOSE fic
	EXIT DO
     END IF
     IF (CurrentMonth <> 1) OR (CurrentYear > 1700) THEN
     IF Click.Button(PrevMonthBtn) THEN
	CurrentMonth = CurrentMonth - 1
	IF CurrentMonth < 1 THEN : CurrentMonth = 12: CurrentYear = CurrentYear - 1
	GOSUB DrawALl
     END IF
     END IF
     IF (CurrentMonth <> 12) OR (CurrentYear < 2699) THEN
     IF Click.Button(NextMonthBtn) THEN
	CurrentMonth = CurrentMonth + 1
	IF CurrentMonth > 12 THEN : CurrentMonth = 1: CurrentYear = CurrentYear + 1
	GOSUB DrawALl
     END IF
     END IF
     IF (CurrentYear > 1700) THEN
     IF Click.Button(PrevYearBtn) THEN
	CurrentYear = CurrentYear - 1
	GOSUB DrawALl
     END IF
     END IF
     IF CurrentYear < 2699 THEN
     IF Click.Button(NextYearBtn) THEN
       CurrentYear = CurrentYear + 1
       GOSUB DrawALl
     END IF
     END IF
LOOP
END


DrawALl:
	MouseHide
	amonthstr$ = MOnthStr(CurrentMonth) + STR$(CurrentYear)
	tx1% = (wx1 + wx2 - (LEN(amonthstr$) * 8)) \ 2
	Draw.Window wx1, wy1 - 15, wx2, wy2, Localize("Calendar.str", "txtDateSel")
	Draw.Button ConfirmButton
	Draw.Button CancelButton
	Draw.Button PrevYearBtn
	Draw.Button NextYearBtn
	Draw.Button PrevMonthBtn
	Draw.Button NextMonthBtn
	Draw.Text amonthstr$, tx1%, wy1 + 11, TextColor, BgColor
	FOR i = 1 TO 7
		x% = wx1 + 10 + (i - 1) * 35
		Draw.Text DayStr(i), x%, wy1 + 35, TextColor, BgColor
	NEXT i
	nb = NbrDayOfMonth(CurrentMonth, CurrentYear)
	iy = 0
	ix = DayOfWeek(1, CurrentMonth, CurrentYear)
	FOR i% = 1 TO nb
		ix1% = wx1 + 10 + (ix * 35)
		iy1% = wy1 + 50 + (iy * 30)
		Initx.Button DayBtn(i%), LTRIM$(STR$(i%)), ix1%, iy1%, ix1% + 30, iy1% + 25
		Draw.Button DayBtn(i%)
		ix = ix + 1
		IF ix > 6 THEN ix = 0: iy = iy + 1
		
	NEXT i%

       MouseShow
RETURN:

FUNCTION DayOfWeek% (Day%, Month%, Year%)
	century% = (Year% - (Year% MOD 100)) / 100
	FirstDay% = 6 - (century% MOD 4) * 2
	DIM Mt(1 TO 12)  AS INTEGER
	
	Mt(1) = 0: Mt(2) = 3: Mt(3) = 3: Mt(4) = 6: Mt(5) = 1: Mt(6) = 4
	Mt(7) = 6: Mt(8) = 2: Mt(9) = 5: Mt(10) = 0: Mt(11) = 3: Mt(12) = 5


	iYear% = Year% - (century% * 100)
	iInt% = iYear% \ 4
	iMonth% = Mt(Month%)
	IF (NbrDayOfYear(Year%) = 366) AND (Month% < 3) THEN iMonth% = ((iMonth% + 7) - 1) MOD 7
		
	iAdd% = FirstDay% + iYear% + iInt% + iMonth% + Day%
	iRemainder% = iAdd% MOD 7
	IF iRemainder% = 0 THEN iRemainder% = 7
	DayOfWeek% = iRemainder% - 1
END FUNCTION

FUNCTION NbrDayOfMonth% (Month AS INTEGER, Year AS INTEGER)
	IF ((Month + ABS(Month > 7)) MOD 2) = 1 THEN
		NbrDayOfMonth% = 31
	ELSE
		IF Month <> 2 THEN
		   NbrDayOfMonth% = 30
		ELSE
			IF (((Year MOD 4) = 0) AND (NOT ((Year MOD 100) = 0))) OR ((Year MOD 400) = 0) THEN
				NbrDayOfMonth% = 29
			ELSE
				NbrDayOfMonth% = 28
			END IF
		END IF
	END IF


END FUNCTION

FUNCTION NbrDayOfYear% (Year AS INTEGER)
			IF (((Year MOD 4) = 0) AND (NOT ((Year MOD 100) = 0))) OR ((Year MOD 400) = 0) THEN
				NbrDayOfYear% = 366
			ELSE
				NbrDayOfYear% = 365
			END IF

END FUNCTION

