DECLARE SUB Draw.BoxText (xpos AS INTEGER, ypos AS INTEGER, wid AS INTEGER, hei AS INTEGER, col AS INTEGER)
DECLARE SUB Manage.Chanel ()
DECLARE SUB App.ManageKey (c AS STRING)
DECLARE FUNCTION getval$ (chaine$, num%)
'$INCLUDE: 'lib\guilib.bi'
'$INCLUDE: 'lib\app.bi'
'$INCLUDE: 'lib\mouse.bi'
'$INCLUDE: 'lib\reg.bi'
'$INCLUDE: 'lib\modules.bi'
'$INCLUDE: 'lib\mouse.bi'
'$INCLUDE: 'lib\shelf.bi'
'$INCLUDE: 'qb.bi'
DIM SHARED regs AS RegType



DECLARE SUB stopfms ()
DECLARE SUB InsertTrack ()
DECLARE SUB instrument ()

DECLARE SUB Draw.Chanels ()
DECLARE SUB Draw.Chanel (i AS INTEGER, drawframe AS INTEGER)
DECLARE SUB Draw.ProjInfo ()
DECLARE SUB Draw.ChanelInfo ()
DECLARE SUB Draw.TrackInfo ()

DECLARE SUB deletenote (mess%)
DECLARE SUB biginsertnote ()
DECLARE SUB bigdeletenote ()
DECLARE SUB insertnote (mess%)
DECLARE SUB init ()
DECLARE SUB effacertout ()
DECLARE SUB selectionnertout ()
DECLARE FUNCTION loadfms% (a$)
DECLARE FUNCTION fmsonginit% ()
DECLARE SUB ClearChan (track%, chan%)
DECLARE FUNCTION gettempschannel% ()
DECLARE FUNCTION gettemps% ()
DECLARE SUB myplay (chan%, freq%, oct%, di%)
DECLARE SUB addcurseur (n AS INTEGER)
DECLARE SUB ouvririnstrument (chan%, a$)
DECLARE SUB myNouveau (a$)
DECLARE SUB clearins (buffer AS ANY)
DECLARE SUB stopallchannels ()
DECLARE SUB resetallchannel ()
DECLARE SUB resetchannel (chan%)
DECLARE SUB sendinstrument (buffer AS ANY)
DECLARE SUB resetchan (chan%)
DECLARE SUB playall ()
DECLARE SUB getinstrument (buffer AS ANY)
DECLARE SUB copier ()
DECLARE SUB coller ()
DECLARE SUB Ouvrir ()
DECLARE SUB Interface ()
DECLARE SUB playnote (chan%, note$, octave%)
DECLARE SUB Enregistrer ()
DECLARE SUB Nouveau ()
DECLARE SUB setinstrument ()
DECLARE FUNCTION DetectFM% ()
DECLARE SUB writereg (reg%, info%)
DECLARE FUNCTION getnote% (track%, chan%, num AS INTEGER)
DECLARE SUB setvaleur (track%, chan%, num%, diese%, octave%, note%)
DECLARE SUB getnoteinfo (track%, chan%, num%, diese%, octave%, note%)
DECLARE SUB setnote (track AS INTEGER, chan AS INTEGER, num AS INTEGER, valeur AS INTEGER)
DECLARE FUNCTION exist% (fichier AS STRING)
DECLARE FUNCTION memoire% ()
DECLARE FUNCTION Shift% (n AS INTEGER)

'$DYNAMIC
DEFINT A-Z      'toutes les variables non dclares en INTEGER

'-----------L'entte pour le bon fonctionnement du syntetiseur
'ON ERROR GOTO erreur

DEFINT A-Z
'La table FM
DIM SHARED notef(0 TO 11) AS INTEGER
notef(0) = &H16B: notef(1) = &H181: notef(2) = &H198
notef(3) = &H1B0: notef(4) = &H1CA: notef(5) = &H1E5
notef(6) = &H202: notef(7) = &H220: notef(8) = &H241
notef(9) = &H263: notef(10) = &H287: notef(11) = &H2AE

DIM SHARED V$
DIM SHARED language
V$ = "1.3.2 (Septembre 2001)"



'les buffers
DIM SHARED attack(2) AS INTEGER
DIM SHARED decay(2) AS INTEGER
DIM SHARED sustain(2) AS INTEGER
DIM SHARED released(2) AS INTEGER
DIM SHARED outp(2) AS INTEGER
DIM SHARED scalling(2) AS INTEGER

DIM SHARED pitchvibrato(2) AS INTEGER
DIM SHARED amplitudevibrato(2) AS INTEGER
DIM SHARED frequencymultipler(2) AS INTEGER
DIM SHARED enveloppescalling(2) AS INTEGER
DIM SHARED waveselect(2) AS INTEGER
DIM SHARED sustaininglevel(2) AS INTEGER
DIM SHARED feedback AS INTEGER
DIM SHARED connection AS INTEGER

'le type instrument
TYPE instrument
	attack1 AS INTEGER
	attack2 AS INTEGER

	decay1 AS INTEGER
	decay2 AS INTEGER

	sustain1 AS INTEGER
	sustain2 AS INTEGER

	released1 AS INTEGER
	released2 AS INTEGER

	outp1 AS INTEGER
	outp2 AS INTEGER


	amplitudevibrato1 AS INTEGER
	amplitudevibrato2 AS INTEGER

	scalling1 AS INTEGER
	scalling2 AS INTEGER

	waveselect1 AS INTEGER
	waveselect2 AS INTEGER

	pitchvibrato1 AS INTEGER
	pitchvibrato2 AS INTEGER

	frequencymultipler1 AS INTEGER
	frequencymultipler2 AS INTEGER

	enveloppescalling1 AS INTEGER
	enveloppescalling2 AS INTEGER


	sustaininglevel1 AS INTEGER
	sustaininglevel2 AS INTEGER

	feedback AS INTEGER
	connection AS INTEGER
	iname AS STRING * 8
     
END TYPE

'----- instruments des 8 chanels
DIM SHARED voll AS INTEGER
DIM SHARED volr AS INTEGER

DIM SHARED iname AS STRING * 8
DIM SHARED channel AS INTEGER   'le channel pour l'echange entre les sub
DIM SHARED thechannel AS INTEGER   'le channel de FM lib
DIM SHARED MaxTrack AS INTEGER
MaxTrack = 1           'Au debut on a 1 track
DIM SHARED dimmaxtrack AS INTEGER
dimmaxtrack = 15           'au maximum 30 tracks
DIM SHARED ch.enabled(1 TO dimmaxtrack, 8) AS INTEGER
DIM SHARED TrackActuel AS INTEGER
DIM SHARED trackdelay(1 TO dimmaxtrack) AS INTEGER
DIM SHARED lesnotes AS INTEGER
lesnotes = 256 'notes
DIM SHARED ins(8) AS instrument
FOR i = 1 TO 8: ins(i).iname = "": NEXT
DIM SHARED replay  AS INTEGER
DIM SHARED MaxNotes(1 TO dimmaxtrack) AS INTEGER          'le max de notes dans chaque track
DIM SHARED notes(1 TO dimmaxtrack, 1 TO 8, 0 TO lesnotes) AS INTEGER   ' les notes des channels
DIM SHARED tablecopie(0 TO lesnotes) AS INTEGER      'le buffer pour la copie
DIM SHARED maxcopie AS INTEGER
DIM SHARED Position AS INTEGER      'la position dans le scroll box
DIM SHARED PositionCurseur AS INTEGER      'la position du curseur dans le scrollbox1
DIM SHARED oct AS INTEGER  'l'octave
DIM SHARED pname AS STRING * 20   'le nom de la musique
DIM SHARED Auteur AS STRING * 20   'l'auteur de la musique
DIM SHARED Commentaire AS STRING * 50   'le commentaire de la musique
DIM SHARED fichier AS STRING     'le nom de la musique
DIM SHARED basep AS INTEGER    'le port de base
'---------- les vars de LOOP PLAY
DIM SHARED volactuel AS INTEGER
DIM SHARED panactuel AS INTEGER
DIM SHARED loopnote AS INTEGER
DIM SHARED looptime!
DIM SHARED timefm!
DIM SHARED savetimefm!
'--------------------------------
'ici pour le loop pour viter les conflits
DIM SHARED isplay AS INTEGER   's'il est en play
DIM SHARED ispause AS INTEGER   's'il est en pause

'-----------L'entte pour le bon fonctionnement du syntetiseur
CONST false = 0, true = NOT false
CONST DOS = &H21
CONST SetDTA = &H1A00, FindFirst = &H4E00, FindNext = &H4F00
CONST maxaffiche = 5

CONST shiftd = 1, shiftg = 2, ctrl = 4, alt = 8
CONST scrolllock = 16, numlock = 32, capslock = 64, insert = 128



'charge le fichier INI et les repertoires
'------------------------------------------
DIM SHARED selection AS INTEGER
DIM SHARED debutselection AS INTEGER
DIM SHARED finselection AS INTEGER
'----------- fin de chargement ------------






'SETUP D'ENVIRONNEMENT
'-----------------------------------------------------
DIM SHARED addandscroll AS INTEGER
addandscroll = 1        'quand il add une note la barre scrolle
'-----------------------------------------------------

SCREEN 0
CLS
PRINT STRING$(80, " ")
LOCATE 1, 25: PRINT "FmSong " + V$
COLOR 15, 0
PRINT "Detection de la carte FM";
IF DetectFM% THEN
	COLOR 2: PRINT " [ OK ]"
ELSE
	COLOR 2: SOUND 1000, 3: PRINT " [ Pas de chip FM ]": a$ = INPUT$(1): END
END IF
init
COLOR 15





continue:
'----------- les trucs du prog et l'interface
'----- instruments des 8 chanels
maxn = 256
DIM SHARED EditActuel AS INTEGER        'le channel actuel dit
FOR i = 1 TO dimmaxtrack: trackdelay(i) = 4: NEXT
FOR i = 1 TO dimmaxtrack: MaxNotes(i) = maxn: NEXT
oct = 4
'-----------------


'GOTO ici
'debut du prog
'--------------------- Les string pour initialiser les touches du clavier -----------
DIM piano AS STRING
DIM piano2 AS STRING
piano = "azertyu"
piano2 = "cdefgab"
dstr$ = CHR$(1) + CHR$(26) + CHR$(5) + CHR$(18) + CHR$(20) + CHR$(25) + CHR$(21)

'----------------------------------------------------------------------

'###########################
'#                         #
'#  LA BOUCLE PRINCIPALE   #
'#                         #
'###########################
'------- init FM
FOR n% = 0 TO &HF5
  writereg n%, 0
NEXT n%

Debut:
DIM SHARED PlayBtn AS button
DIM SHARED StopBtn AS button
DIM SHARED FwBtn AS button
DIM SHARED RwBtn AS button

App.AddMenuItem "New"
App.AddMenuItem "Open"
App.AddMenuItem "Save"
App.AddMenuItem "Instrument"
App.AddMenuItem "Exit"
DIM SHARED tc%
DIM SHARED bgc%
tc% = 0
bgc% = 15
SCREEN 12

GUI.Init
Shelf.Load
App.SetTitle "FmSong"
App.DrawGui

Interface
Shelf.Draw
MouseShow
DO
	IF Shelf.Drag THEN GOSUB DragShelf
	c$ = INKEY$
	App.ManageKey c$
	Manage.Chanel

       
	'entre pour play toute musique
	IF Click.Button(PlayBtn) THEN playall
	
	'le REW pour revenir au debut
	IF Click.Button(RwBtn) THEN
		PositionCurseur = 0
		Position = 0
		Draw.Chanels
		R! = TIMER: DO: LOOP UNTIL TIMER - R! > .25
	END IF

	'pour reset tout les channels
	IF Click.Button(StopBtn) THEN
		stopallchannels
		R! = TIMER: DO: LOOP UNTIL TIMER - R! > .25
	END IF

	'Le FF pour aller en avant
	IF Click.Button(FwBtn) THEN
		PositionCurseur = MaxNotes(TrackActuel + 1) - 1
		Position = PositionCurseur - 3
		IF Position < 0 THEN Position = 0
		Draw.Chanels
		R! = TIMER: DO: LOOP UNTIL TIMER - R! > .25
	END IF


	SELECT CASE SelectedMenu
		CASE "New"
			Nouveau
		CASE "Open"
			Ouvrir
		CASE "Save"
			Enregistrer
		CASE "Exit"
			EXIT DO

		CASE "Instrument"
			instrument
			Draw.ChanelInfo
			atime& = INT(TIMER)
			WHILE atime& + 1 > INT(TIMER)
			WEND
			stopfms
	       
		CASE "New Track"
			InsertTrack
			Draw.TrackInfo


		CASE "Insert Note"
			insertnote 0
			Draw.Chanels
			Draw.TrackInfo
	END SELECT

	bouttonselect = false
	IF c$ = CHR$(3) THEN copier 'ctrl+c pour copier
	IF c$ = CHR$(22) THEN coller 'ctrl+v pour coller
	IF c$ = CHR$(12) THEN selectionnertout: bouttonselect = true'tout selectionner
	IF c$ = CHR$(4) THEN effacertout 'tout effacer

	'Selectionner BAS
	IF c$ = CHR$(0) + CHR$(80) AND (Shift(shiftg) OR Shift(shiftd)) THEN 'ctrl+bas
		IF selection = 0 THEN
			selection = true
			debutselection = PositionCurseur
			finselection = PositionCurseur
		ELSE
			addcurseur 1
			finselection = PositionCurseur
		END IF
      
		FOR j = 1 TO 8
			getnoteinfo TrackActuel + 1, j, PositionCurseur, diese, oc%, freq%
			myplay j, freq%, oc%, diese
		NEXT
	      
		bouttonselect = true
		FOR k = 1 TO 8: Draw.Chanel k, 0: NEXT k
		c$ = ""
	END IF

	'Selectionner Haut
	IF c$ = CHR$(0) + CHR$(72) AND (Shift(shiftg) OR Shift(shiftd)) THEN  'ctrl+haut
		IF selection = 0 THEN
			selection = true
			debutselection = PositionCurseur
			finselection = PositionCurseur
		ELSE
			addcurseur -1
			finselection = PositionCurseur
		END IF
		bouttonselect = true
		FOR k = 1 TO 8: Draw.Chanel k, 0: NEXT k
		c$ = ""
	END IF

	's'il n'appuie pas sur la selection mais sur un autre boutton...
	IF bouttonselect = false AND c$ <> "" THEN
		selection = false
	END IF

	'les racourcis clavier
	'-----------------------------------------------------
	IF c$ = CHR$(0) + CHR$(82) AND (Shift(shiftg) OR Shift(shiftd)) THEN
		biginsertnote  'Ins (inserer une note)
		c$ = ""
		Interface
	END IF
	IF c$ = CHR$(0) + CHR$(83) AND (Shift(shiftg) OR Shift(shiftd)) THEN
		bigdeletenote  'Suppr (effacer une note)
		c$ = ""
		Interface
	END IF

	IF c$ = CHR$(0) + CHR$(82) THEN
		insertnote (1) 'Ins (inserer une note)
		Interface
	END IF
	IF c$ = CHR$(0) + CHR$(83) THEN
		deletenote (1) 'Suppr (effacer une note)
		Interface
	END IF
	'-----------------------------------------------------

	'pour augementer le delay
	IF LCASE$(c$) = "n" THEN
		trackdelay(TrackActuel + 1) = trackdelay(TrackActuel + 1) + 1
		Draw.TrackInfo
	END IF
	IF LCASE$(c$) = "b" AND trackdelay(TrackActuel + 1) > 0 THEN
		trackdelay(TrackActuel + 1) = trackdelay(TrackActuel + 1) - 1
		Draw.TrackInfo
	END IF

	'pour changer de track
	IF LCASE$(c$) = "m" THEN
	   IF TrackActuel < MaxTrack - 1 THEN
		TrackActuel = TrackActuel + 1
		Position = 0
		PositionCurseur = 0
		Interface
	   END IF
	END IF


	IF LCASE$(c$) = "l" THEN
		IF TrackActuel > 0 THEN
			TrackActuel = TrackActuel - 1
			Position = 0
			PositionCurseur = 0
			Interface
		END IF
	END IF

	'incrmenter l'octave ou decrementer
	IF c$ = "+" AND oct < 7 THEN
		oct = oct + 1
		Draw.ProjInfo
	END IF
	IF c$ = "-" AND oct > 0 THEN
		oct = oct - 1
		Draw.ProjInfo
	END IF

	'pour changer de channel
	IF c$ = CHR$(0) + CHR$(77) AND EditActuel < 7 THEN
		EditActuel = EditActuel + 1
		Draw.Chanels
		Draw.TrackInfo
		Draw.ChanelInfo
	END IF

	IF c$ = CHR$(0) + CHR$(75) AND EditActuel > 0 THEN
		EditActuel = EditActuel - 1
		Draw.Chanels
		Draw.TrackInfo
		Draw.ChanelInfo
	END IF

	'les F1  F8 pour eteindre un channel
	IF c$ = CHR$(0) + CHR$(59) THEN ch.enabled(TrackActuel + 1, 1) = ch.enabled(TrackActuel + 1, 1) XOR 1: Draw.Chanels
	IF c$ = CHR$(0) + CHR$(60) THEN ch.enabled(TrackActuel + 1, 2) = ch.enabled(TrackActuel + 1, 2) XOR 1: Draw.Chanels
	IF c$ = CHR$(0) + CHR$(61) THEN ch.enabled(TrackActuel + 1, 3) = ch.enabled(TrackActuel + 1, 3) XOR 1: Draw.Chanels
	IF c$ = CHR$(0) + CHR$(62) THEN ch.enabled(TrackActuel + 1, 4) = ch.enabled(TrackActuel + 1, 4) XOR 1: Draw.Chanels
	IF c$ = CHR$(0) + CHR$(63) THEN ch.enabled(TrackActuel + 1, 5) = ch.enabled(TrackActuel + 1, 5) XOR 1: Draw.Chanels
	IF c$ = CHR$(0) + CHR$(64) THEN ch.enabled(TrackActuel + 1, 6) = ch.enabled(TrackActuel + 1, 6) XOR 1: Draw.Chanels
	IF c$ = CHR$(0) + CHR$(65) THEN ch.enabled(TrackActuel + 1, 7) = ch.enabled(TrackActuel + 1, 7) XOR 1: Draw.Chanels
	IF c$ = CHR$(0) + CHR$(66) THEN ch.enabled(TrackActuel + 1, 8) = ch.enabled(TrackActuel + 1, 8) XOR 1: Draw.Chanels


	'les touches bas pour changer la note
	IF c$ = CHR$(0) + CHR$(80) AND PositionCurseur < MaxNotes(TrackActuel + 1) - 1 THEN
	      selection = false 'enlve la selection si elle existe
	      'FOR j = 1 TO 8
	      '  getnoteinfo TrackActuel + 1, j, PositionCurseur, diese, oc%, freq%
	       ' myplay j, freq%, oc%, diese
	      'NEXT
	      addcurseur 1 'le bas
	      Draw.Chanels
	      'atime! = TIMER
	      'WHILE atime! + .5 > TIMER: WEND
	      'stopfms

	END IF
	'la touche haut
	IF c$ = CHR$(0) + CHR$(72) AND PositionCurseur > 0 THEN
	      selection = false 'enlve la selection
	      addcurseur -1 'le haut
	      'FOR j = 1 TO 8
	       ' getnoteinfo TrackActuel + 1, j, PositionCurseur, diese, oc%, freq%
	       ' myplay j, freq%, oc%, diese
	      'NEXT
	      Draw.Chanels
	      'atime! = TIMER
	      'WHILE atime! + .5 > TIMER: WEND
	      'stopfms
	END IF








'si changement de ?
IF LCASE$(c$) <> "" AND (INSTR(dstr$, c$) <> 0 OR INSTR(LCASE$(piano), LCASE$(c$)) <> 0) THEN
		posnote = INSTR(LCASE$(piano), LCASE$(c$))
		IF INSTR(dstr$, c$) <> 0 THEN
				IF INSTR(dstr$, c$) <> 3 AND INSTR(dstr$, c$) <> 7 THEN dis = 1 ELSE dis = 0
				posnote = INSTR(dstr$, c$)
		ELSE
			dis = 0
			getnoteinfo TrackActuel + 1, EditActuel + 1, PositionCurseur, di, oc, no
			setvaleur TrackActuel + 1, EditActuel + 1, PositionCurseur, 0, oc, no
	       
		END IF

		getnoteinfo TrackActuel + 1, EditActuel + 1, PositionCurseur, di, oc, no
		setvaleur TrackActuel + 1, EditActuel + 1, PositionCurseur, dis, oc, no
	       
		getnoteinfo TrackActuel + 1, EditActuel + 1, PositionCurseur, di, oc%, no
		setvaleur TrackActuel + 1, EditActuel + 1, PositionCurseur, di, oct, posnote
	      
		getnoteinfo TrackActuel + 1, EditActuel + 1, PositionCurseur, dis, oc%, freq%
	       
		'myplay EditActuel + 1, freq%, oc%, dis
		dis = 0
		IF addandscroll = 1 THEN addcurseur 1
		Draw.Chanels
		'atime! = TIMER
		'WHILE atime! + .5 > TIMER: WEND
		'stopfms

END IF



's'il doit effacer une note
IF c$ = " " THEN
		setvaleur TrackActuel + 1, EditActuel + 1, PositionCurseur, 0, 0, 0
		IF addandscroll = 1 THEN addcurseur 1
		Draw.Chanels
END IF
's'Pour stopper le son tel qu'il soit
IF LCASE$(c$) = "x" THEN
		setvaleur TrackActuel + 1, EditActuel + 1, PositionCurseur, 0, 0, -1
		IF addandscroll = 1 THEN addcurseur 1
		resetchan EditActuel + 1
		Draw.Chanels
END IF

LOOP UNTIL c$ = CHR$(27)
app.Exit


erreur:
RESUME Debut

DragShelf:
	f$ = Shelf.Selected
	IF LCASE$(RIGHT$(f$, 4)) = ".fmi" THEN
		ouvririnstrument EditActuel + 1, f$
		getinstrument ins(EditActuel + 1)
			playnote EditActuel + 1, "c", 5
			t! = TIMER
			DO: LOOP UNTIL TIMER - t! > .5
			Draw.ChanelInfo
			atime& = INT(TIMER)
			WHILE atime& + 1 > INT(TIMER)
			WEND
			stopfms
       
	END IF
	IF LCASE$(RIGHT$(f$, 4)) = ".fms" THEN
		IF loadfms(f$) THEN RETURN
		fichier = f$
		Interface
       
	END IF

	RETURN

REM $STATIC
SUB addcurseur (n AS INTEGER)
	PositionCurseur = PositionCurseur + n

	IF PositionCurseur > MaxNotes(TrackActuel + 1) - 1 THEN PositionCurseur = MaxNotes(TrackActuel + 1) - 1
	
	IF PositionCurseur < 0 THEN PositionCurseur = 0
	
	IF Position + 3 < PositionCurseur THEN
	       
	    DO
		Position = Position + 1
	    LOOP UNTIL Position + 3 >= PositionCurseur
       
	END IF
       
	IF PositionCurseur < Position THEN
		Position = PositionCurseur
	END IF
END SUB

SUB bigdeletenote
	IF MaxNotes(TrackActuel + 1) <= 1 THEN EXIT SUB
       
	saveedit = EditActuel
	lemax = MaxNotes(TrackActuel + 1)
	FOR k = 1 TO 8
		EditActuel = k - 1
		deletenote (0)
	NEXT
	MaxNotes(TrackActuel + 1) = lemax - 1
	IF lemax < 1 THEN lemax = 1
	MaxNotes(TrackActuel + 1) = lemax
       
	EditActuel = saveedit

	
END SUB

SUB biginsertnote
	saveedit = EditActuel
	lemax = MaxNotes(TrackActuel + 1)

	FOR k = 1 TO 8
		EditActuel = k - 1
		insertnote (0)
	NEXT
	MaxNotes(TrackActuel + 1) = lemax + 1
	IF lemax > lesnotes THEN lemax = lesnotes
	MaxNotes(TrackActuel + 1) = lemax
       
	EditActuel = saveedit

END SUB

SUB ClearChan (track, chan)

FOR i = 1 TO MaxNotes(track)
	setvaleur track, chan, i, 0, 0, 0
NEXT


END SUB

SUB clearins (buffer AS instrument)

buffer.attack1 = 0
buffer.attack2 = 0

buffer.decay1 = 0
buffer.decay2 = 0

buffer.sustain1 = 0
buffer.sustain2 = 0

buffer.released1 = 0
buffer.released2 = 0

buffer.outp1 = 0
buffer.outp2 = 0

buffer.scalling1 = 0
buffer.scalling2 = 0

buffer.amplitudevibrato1 = 0
buffer.amplitudevibrato2 = 0

'buffer.levelscalling1 = 0
'buffer.levelscalling2 = 0

buffer.pitchvibrato1 = 0
buffer.pitchvibrato2 = 0

buffer.frequencymultipler1 = 0
buffer.frequencymultipler2 = 0

buffer.enveloppescalling1 = 0
buffer.enveloppescalling2 = 0

buffer.waveselect1 = 0
buffer.waveselect2 = 0

buffer.feedback = 0
buffer.connection = 0

buffer.sustaininglevel1 = 0
buffer.sustaininglevel2 = 0
buffer.iname = ""
END SUB

SUB coller
'SOUND 1000, 2
	Debut = 0
	fin = maxcopie - 1
       
	FOR i = Debut TO fin
	       
		notes(TrackActuel + 1, EditActuel + 1, PositionCurseur) = tablecopie(d)
		addcurseur 1
		d = d + 1
		IF PositionCurseur + 1 >= MaxNotes(TrackActuel + 1) THEN EXIT SUB
	NEXT
       
END SUB

SUB copier
'        SOUND 100, 2
      IF selection = true THEN
		ds = debutselection
		fs = finselection
		IF fs < ds THEN SWAP ds, fs
		maxcopie = (fs - ds) + 1
      ELSE
		ds = PositionCurseur
		maxcopie = 1
		tablecopie(0) = notes(TrackActuel + 1, EditActuel + 1, ds)
		EXIT SUB
      END IF
       
	'copie dans la table de copie
	FOR i = ds TO fs
		tablecopie(d) = notes(TrackActuel + 1, EditActuel + 1, i)
		d = d + 1
	NEXT



END SUB

SUB copytrack (track1, track2)

trackdelay(track2) = trackdelay(track1)
MaxNotes(track2) = MaxNotes(track1)

FOR k = 1 TO 8  'les channels
	'maxnotes(track2) = maxnotes(track1)
	ClearChan track2, k
	sendinstrument ins(k)
	getinstrument ins(k)
       
	FOR j = 0 TO MaxNotes(track1) - 1         'max de 2 pour copier le track 1

		getnoteinfo track1, k, j, diese, oc, note
	       
		setvaleur track2, k, j, diese, oc, note

	NEXT

NEXT



END SUB

SUB deletenote (mess)
'SOUND 100, .25
IF MaxNotes(TrackActuel + 1) = 0 THEN MaxNotes(TrackActuel + 1) = 1

IF mess = 1 AND MaxNotes(TrackActuel + 1) <= 1 THEN EXIT SUB

fin = MaxNotes(TrackActuel + 1)
notes(TrackActuel + 1, EditActuel + 1, MaxNotes(TrackActuel + 1)) = 0
IF PositionCurseur + 1 < fin THEN
	FOR i = PositionCurseur TO fin
	      IF i + 1 < fin THEN
		  notes(TrackActuel + 1, EditActuel + 1, i) = notes(TrackActuel + 1, EditActuel + 1, i + 1)
		ELSE
		  notes(TrackActuel + 1, EditActuel + 1, i) = 0
		END IF

	NEXT
ELSE
		notes(TrackActuel + 1, EditActuel + 1, fin) = 0
		addcurseur -1
END IF

MaxNotes(TrackActuel + 1) = MaxNotes(TrackActuel + 1) - 1
END SUB

FUNCTION DetectFM%
 writereg 4, &H60
 writereg 4, &H80
 data1% = INP(&H388)
 writereg 2, &HFF
 writereg 4, &H21

FOR d% = 1 TO 150: x% = INP(&H388): NEXT d%

 data2% = INP(&H388)
 writereg 4, &H60
 writereg 4, &H80
 IF (data1% AND &HE0) = 0 AND (data2% AND &HE0) = &HC0 THEN DetectFM% = -1

END FUNCTION

SUB Draw.BoxText (xpos AS INTEGER, ypos AS INTEGER, wid AS INTEGER, hei AS INTEGER, col AS INTEGER)
	lignetop$ = CHR$(218) + STRING$(wid - 2, CHR$(196)) + CHR$(191)
	lignemiddle$ = CHR$(179) + STRING$(wid - 2, " ") + CHR$(179)
	lignebottom$ = CHR$(192) + STRING$(wid - 2, CHR$(196)) + CHR$(217)
	LOCATE ypos, xpos
	COLOR col
	PRINT lignetop$
	FOR i = 2 TO hei - 1
		LOCATE ypos + i - 1, xpos
		PRINT lignemiddle$
	NEXT i
	LOCATE ypos + hei - 1, xpos
	PRINT lignebottom$
	
END SUB

SUB Draw.Chanel (i AS INTEGER, drawframe AS INTEGER)




'----- LES CHAINES
	IF drawframe THEN
	IF EditActuel <> i - 1 THEN
		Draw.BoxText 5 + (i - 1) * 9, 13, 9, 6, 15
	ELSE
		Draw.BoxText 5 + (i - 1) * 9, 13, 9, 6, 14
	END IF
	z$ = "F" + RIGHT$(STR$(i), 1)
	IF ch.enabled(TrackActuel + 1, i) <> 0 THEN
		z$ = z$ + " OO "
	ELSE
		z$ = z$ + " __ "
	END IF
       
	LOCATE 12, 6 + (i - 1) * 9
	COLOR 15
	PRINT z$
	END IF

nstr$ = "CDEFGAB"

Debut = Position
fin = Position + 3
IF fin >= MaxNotes(TrackActuel + 1) THEN fin = MaxNotes(TrackActuel + 1) - 1

FOR P = Debut TO fin
	d$ = ""
	getnoteinfo TrackActuel + 1, i, P, di, oc, no
      
	IF di = 1 THEN
		d$ = d$ + "#"
	ELSE
		d$ = d$ + " "
	END IF
	IF no > 0 THEN
		d$ = d$ + MID$(nstr$, no, 1)
		       
	ELSE
		'si XXX pour stoppper le son
		IF no = -1 THEN d$ = " X ": GOTO db
	      
		d$ = "---"
		GOTO db
	END IF
		d$ = d$ + RIGHT$(STR$(oc), 1)
db:
      
	IF PositionCurseur <> P THEN
			fgcol% = 7
			bgcol% = 0
	ELSE
		    IF EditActuel + 1 = i THEN
				fgcol% = 15
				bgcol% = 0
			ELSE
				fgcol% = 7
				bgcol% = 0
		    END IF
	END IF
      
	'------------ Colorise si selection
      IF i = EditActuel + 1 THEN        'si c'est le channel actuel qui doit tre affich
	IF selection = true THEN
	      
		dselect = debutselection
		fselecte = finselection
		IF fselecte < dselect THEN SWAP fselecte, dselect
	     
		IF P >= dselect AND P <= fselecte THEN
			fgcol% = 8
			bgcol% = 7
		ELSE
			bgcol% = 0
		END IF
	ELSE
		bgcol% = 0
	END IF
      END IF
	'----------- fin de colorize si selection
	a$ = STRING$(2 - LEN(HEX$(P)), "0") + HEX$(P) + " " + d$
	LOCATE 14 + (P - Debut), 6 + (i - 1) * 9
	COLOR fgcol%
	PRINT a$
NEXT




END SUB

SUB Draw.ChanelInfo
	Draw.Frame 220, 30, 420, 150
	Draw.Text "Channel stats", 265, 40, tc%, bgc%
	Draw.Text "Instrument  :", 230, 65, tc%, bgc%
	IF LTRIM$(RTRIM$(ins(EditActuel + 1).iname)) <> "" THEN
		a$ = ins(EditActuel + 1).iname
	ELSE
		a$ = "!NONE"
	END IF
	Draw.Text a$, 335, 65, 4, bgc%
	Draw.Text "Times       :", 230, 81, tc%, bgc%
	a$ = STR$(gettempschannel) + " Sec"
	Draw.Text a$, 335, 81, 4, bgc%
END SUB

SUB Draw.Chanels
	FOR k = 1 TO 8
		Draw.Chanel k, -1
	NEXT k

END SUB

SUB Draw.ProjInfo
	Draw.Frame 430, 30, 630, 150
	Draw.Text "Project stats", 475, 40, tc%, bgc%
	Draw.Text "Octave      :", 440, 65, tc%, bgc%
	Draw.Text STR$(oct), 544, 65, 4, bgc%
	Draw.Text "Time        :", 440, 81, tc%, bgc%
	a$ = STR$(gettemps) + " Sec"
	Draw.Text a$, 544, 81, 4, bgc%
	Draw.Text "File   :", 440, 97, tc%, bgc%
	IF fichier <> "" THEN a$ = fichier ELSE a$ = "!NONE"
	FOR i = LEN(a$) TO 1 STEP -1
		IF MID$(a$, i, 1) = "\" THEN
			a$ = MID$(a$, i + 1)
			EXIT FOR
		END IF
	NEXT i
	Draw.Text a$, 510, 97, 4, bgc%

END SUB

SUB Draw.TrackInfo
	Draw.Frame 10, 30, 210, 150
	Draw.Text "Track", 90, 40, tc%, bgc%
	Draw.Text "Trac n    :", 20, 65, tc%, bgc%
	Draw.Text STR$(TrackActuel + 1), 124, 65, 4, bgc%
	Draw.Text "Trac Delay :", 20, 81, tc%, bgc%
	Draw.Text STR$(trackdelay(TrackActuel + 1)), 124, 81, 4, bgc%
	Draw.Text "Max Notes  :", 20, 97, tc%, bgc%
	Draw.Text STR$(MaxNotes(TrackActuel + 1)), 124, 97, 4, bgc%
	Draw.Text "MaxTrack:" + STR$(MaxTrack), 20, 120, tc%, bgc%
END SUB

SUB effacertout


FOR i = 0 TO MaxNotes(TrackActuel + 1) - 1
	notes(TrackActuel + 1, EditActuel + 1, i) = 0
NEXT
Draw.Chanel (TrackActuel + 1), -1


END SUB

SUB Enregistrer
DIM n1 AS STRING * 1
a$ = FileSelect("save", CurrentDir + "\fmsong\Music", "*")
Shelf.Load
Shelf.Draw
IF a$ = "" THEN EXIT SUB

OPEN a$ FOR BINARY AS #1
fichier = a$

IF LOF(1) <> 0 THEN
	CLOSE #1
	KILL a$
	OPEN a$ FOR BINARY AS #1
END IF
'l'entte
SEEK #1, 1
var$ = "fm-song-project"
PUT #1, , var$


'l'auteur
PUT #1, , pname$
PUT #1, , Auteur
PUT #1, , Commentaire
PUT #1, , MaxTrack

'les instrument
	    'find de put instrument
	    FOR k = 1 TO 8        'les channels
		   PUT #1, , ins(k).iname
		 
		   'ins(i,k)
		   i1$ = CHR$(ins(k).attack1)
		   i2$ = CHR$(ins(k).attack2)
		   PUT #1, , i1$
		   PUT #1, , i2$
		   i1$ = CHR$(ins(k).decay1)
		   i2$ = CHR$(ins(k).decay2)
		   PUT #1, , i1$
		   PUT #1, , i2$
		   i1$ = CHR$(ins(k).sustain1)
		   i2$ = CHR$(ins(k).sustain2)
		   PUT #1, , i1$
		   PUT #1, , i2$
		   i1$ = CHR$(ins(k).released1)
		   i2$ = CHR$(ins(k).released2)
		   PUT #1, , i1$
		   PUT #1, , i2$
		   i1$ = CHR$(ins(k).outp1)
		   i2$ = CHR$(ins(k).outp2)
		   PUT #1, , i1$
		   PUT #1, , i2$
		   i1$ = CHR$(ins(k).scalling1)
		   i2$ = CHR$(ins(k).scalling2)
		   PUT #1, , i1$
		   PUT #1, , i2$
		   i1$ = CHR$(ins(k).amplitudevibrato1)
		   i2$ = CHR$(ins(k).amplitudevibrato2)
		   PUT #1, , i1$
		   PUT #1, , i2$
		   'i1$ = CHR$(ins(k).levelscalling1)
		   'i2$ = CHR$(ins(k).levelscalling2)
		   'PUT #1, , i1$
		   'PUT #1, , i2$
		   i1$ = CHR$(ins(k).pitchvibrato1)
		   i2$ = CHR$(ins(k).pitchvibrato2)
		   PUT #1, , i1$
		   PUT #1, , i2$
		   i1$ = CHR$(ins(k).frequencymultipler1)
		   i2$ = CHR$(ins(k).frequencymultipler2)
		   PUT #1, , i1$
		   PUT #1, , i2$
		   i1$ = CHR$(ins(k).enveloppescalling1)
		   i2$ = CHR$(ins(k).enveloppescalling2)
		   PUT #1, , i1$
		   PUT #1, , i2$
		   i1$ = CHR$(ins(k).waveselect1)
		   i2$ = CHR$(ins(k).waveselect2)
		   PUT #1, , i1$
		   PUT #1, , i2$
		   i1$ = CHR$(ins(k).feedback)
		   i2$ = CHR$(ins(k).connection)
		   PUT #1, , i1$
		   PUT #1, , i2$
		   i1$ = CHR$(ins(k).sustaininglevel1)
		   i2$ = CHR$(ins(k).sustaininglevel2)
		   PUT #1, , i1$
		   PUT #1, , i2$
		   
NEXT


'la track
FOR i = 1 TO MaxTrack
	PUT #1, , MaxNotes(i)       'les max notes
	    'il put l'instrument
	PUT #1, , trackdelay(i)
	
	FOR cn = 1 TO 8: sc$ = CHR$(ch.enabled(i, cn)): PUT #1, , sc$: NEXT


	     FOR k = 1 TO 8
		  
		   FOR j = 0 TO MaxNotes(i) - 1  'les notes
			n1 = CHR$(notes(i, k, j))
			PUT #1, , n1
		    NEXT
	    NEXT

NEXT






CLOSE #1

END SUB

FUNCTION exist (fichier AS STRING)

OPEN fichier FOR BINARY AS #1

IF LOF(1) = 0 THEN
	CLOSE #1
	KILL fichier
	exist = 0
	EXIT FUNCTION

END IF

exist = -1
CLOSE #1

END FUNCTION

FUNCTION fmsonginit
	IF DetectFM% = 0 THEN fmsonginit = -1: EXIT FUNCTION'true si pas de fm
	myNouveau "256"
END FUNCTION

SUB fmsongunload
resetallchannel
writereg &HA0, 0
writereg &HB0, 0
FOR n% = 0 TO 224: writereg n%, 0: NEXT n%


END SUB

SUB getinstrument (buffer AS instrument)

buffer.attack1 = attack(1)
buffer.attack2 = attack(2)

buffer.decay1 = decay(1)
buffer.decay2 = decay(2)

buffer.sustain1 = sustain(1)
buffer.sustain2 = sustain(2)

buffer.released1 = released(1)
buffer.released2 = released(2)

buffer.outp1 = outp(1)
buffer.outp2 = outp(2)

buffer.scalling1 = scalling(1)
buffer.scalling2 = scalling(2)

buffer.amplitudevibrato1 = amplitudevibrato(1)
buffer.amplitudevibrato2 = amplitudevibrato(2)

buffer.pitchvibrato1 = pitchvibrato(1)
buffer.pitchvibrato2 = pitchvibrato(2)

buffer.frequencymultipler1 = frequencymultipler(1)
buffer.frequencymultipler2 = frequencymultipler(2)

buffer.enveloppescalling1 = enveloppescalling(1)
buffer.enveloppescalling2 = enveloppescalling(2)

buffer.waveselect1 = waveselect(1)
buffer.waveselect2 = waveselect(2)

buffer.feedback = feedback
buffer.connection = connection

buffer.sustaininglevel1 = sustaininglevel(1)
buffer.sustaininglevel2 = sustaininglevel(2)

buffer.iname = iname


END SUB

REM $DYNAMIC
FUNCTION getnote (track, chan, num AS INTEGER)
     
offs = VARPTR(notes(track, chan, num))
     
DEF SEG = VARSEG(notes(track, chan, 1))
getnote = PEEK(offs)
DEF SEG

END FUNCTION

SUB getnoteinfo (track, chan, num, diese, octave, note)

var = getnote(track, chan, num)
octave = (var AND 56) / 8
note = var AND 7
diese = (var AND 64) / 64

no = (var AND 128) / 128
IF no = 1 THEN note = -1

END SUB

REM $STATIC
FUNCTION gettemps

FOR i = 1 TO MaxTrack
	temps = temps + ((trackdelay(i) / 20) * MaxNotes(i))
NEXT
gettemps = temps


END FUNCTION

FUNCTION gettempschannel

	gettempschannel = MaxNotes(TrackActuel + 1) * (trackdelay(TrackActuel + 1) / 20)

END FUNCTION

FUNCTION getval$ (chaine$, num)
	a$ = LTRIM$(RTRIM$(chaine$)) + ","
	Retval$ = ""
	currentnum = 1
	curpos = 1
	debutchaine = 1
	FOR i = 1 TO LEN(a$)
		IF MID$(a$, i, 1) = "," THEN
				IF currentnum = num THEN
					Retval$ = MID$(a$, debutchaine, i - debutchaine)
					getval$ = Retval$
					EXIT FUNCTION
				ELSE
					debutchaine = i + 1
					currentnum = currentnum + 1
				END IF
		       
		END IF
	NEXT i

       


END FUNCTION

SUB init

'--------- Il reset les channels
FOR i = k TO 8: resetchan k: NEXT

FOR i = &H0 TO &HF5
	OUT &H388, i
	OUT &H389, 0
NEXT i

resetallchannel
'-------------------------------

END SUB

SUB insertnote (mess)
IF MaxNotes(TrackActuel + 1) = 0 THEN MaxNotes(TrackActuel + 1) = 1


MaxNotes(TrackActuel + 1) = MaxNotes(TrackActuel + 1) + 1

'la dernire note devient 0
notes(TrackActuel + 1, EditActuel + 1, MaxNotes(TrackActuel + 1) - 1) = 0

Debut = MaxNotes(TrackActuel + 1) - 1   'si fin alors 254
fin = PositionCurseur

FOR i = Debut TO fin STEP -1
       IF i < lesnotes THEN notes(TrackActuel + 1, EditActuel + 1, i + 1) = notes(TrackActuel + 1, EditActuel + 1, i)
NEXT


'la note actuelle devient 0
notes(TrackActuel + 1, EditActuel + 1, fin) = 0
IF MaxNotes(TrackActuel + 1) > lesnotes THEN MaxNotes(TrackActuel + 1) = lesnotes

END SUB

SUB InsertTrack

IF MaxTrack >= dimmaxtrack THEN EXIT SUB

	  MaxTrack = MaxTrack + 1
		trackdelay(MaxTrack) = 4
		FOR k = 1 TO 8
			ClearChan MaxTrack, k
		NEXT
		'clear tout les channels
		FOR k = 1 TO 8
			ch.enabled(MaxTrack, k) = 0
		NEXT


     TrackActuel = MaxTrack - 1
     setvaleur TrackActuel + 1, EditActuel + 1, 0, 0, 0, -1



Position = 0
PositionCurseur = 0
END SUB

SUB instrument

a$ = FileSelect("open", CurrentDir + "\fmsong\ins", "*")
Shelf.Load
Shelf.Draw
IF a$ = "" THEN EXIT SUB

ouvririnstrument EditActuel + 1, a$
getinstrument ins(EditActuel + 1)

DO
	playnote EditActuel + 1, "c", 5
	t! = TIMER
	DO: LOOP UNTIL TIMER - t! > .5
d = d + 1
LOOP UNTIL d = 1




END SUB

SUB Interface
	Draw.TrackInfo
	Draw.ChanelInfo
	Draw.ProjInfo
	Draw.Frame 10, 160, 630, 300
	LINE (14, 164)-(626, 296), 0, BF
	Draw.Chanels

	Draw.Frame 10, 390, 630, 450
	Draw.Text "Music Control", 20, 400, tc%, bgc%
	Initx.Button PlayBtn, "< Play >", 20, 420, 150, 440
	Initx.Button StopBtn, "< Stop >", 490, 420, 620, 440
	Initx.Button RwBtn, "To Begin", 170, 420, 280, 440
	Initx.Button FwBtn, "To End", 360, 420, 470, 440
       
	Draw.Button PlayBtn
	Draw.Button StopBtn


	Draw.Button RwBtn
	Draw.Button FwBtn
								
END SUB

SUB jouer




END SUB

FUNCTION loadfms (a$)
f$ = a$
OPEN f$ FOR BINARY AS #1
IF LOF(1) = 0 THEN loadfms = -1: CLOSE 1: EXIT FUNCTION

'l'entte
SEEK #1, 1
var$ = "               "
GET #1, , var$
IF var$ <> "fm-song-project" THEN loadfms = -1:  EXIT FUNCTION

myNouveau STR$(256)

'l'auteur
GET #1, , pname$
GET #1, , Auteur
GET #1, , Commentaire
GET #1, , MaxTrack

'les instruments
FOR k = 1 TO 8        'les channels
	GET #1, , ins(k).iname
		   i1$ = " "
		   i2$ = " "
		   GET #1, , i1$
		   GET #1, , i2$
		   ins(k).attack1 = ASC(i1$)
		   ins(k).attack2 = ASC(i2$)
	    
		   i1$ = " "
		   i2$ = " "
		   GET #1, , i1$
		   GET #1, , i2$
		   ins(k).decay1 = ASC(i1$)
		   ins(k).decay2 = ASC(i2$)
	   
		   i1$ = " "
		   i2$ = " "
		   GET #1, , i1$
		   GET #1, , i2$
		   ins(k).sustain1 = ASC(i1$)
		   ins(k).sustain2 = ASC(i2$)
	    
		   i1$ = " "
		   i2$ = " "
		   GET #1, , i1$
		   GET #1, , i2$
		   ins(k).released1 = ASC(i1$)
		   ins(k).released2 = ASC(i2$)
	    
	    
		   i1$ = " "
		   i2$ = " "
		   GET #1, , i1$
		   GET #1, , i2$
		   ins(k).outp1 = ASC(i1$)
		   ins(k).outp2 = ASC(i2$)
	    
	    
		   i1$ = " "
		   i2$ = " "
		   GET #1, , i1$
		   GET #1, , i2$
		   ins(k).scalling1 = ASC(i1$)
		   ins(k).scalling2 = ASC(i2$)

	    
	    
		   i1$ = " "
		   i2$ = " "
		   GET #1, , i1$
		   GET #1, , i2$
		   ins(k).amplitudevibrato1 = ASC(i1$)
		   ins(k).amplitudevibrato2 = ASC(i2$)

		   i1$ = " "
		   i2$ = " "
		   GET #1, , i1$
		   GET #1, , i2$
		   ins(k).pitchvibrato1 = ASC(i1$)
		   ins(k).pitchvibrato2 = ASC(i2$)
	    
		   i1$ = " "
		   i2$ = " "
		   GET #1, , i1$
		   GET #1, , i2$
		   ins(k).frequencymultipler1 = ASC(i1$)
		   ins(k).frequencymultipler2 = ASC(i2$)
	    
		   i1$ = " "
		   i2$ = " "
		   GET #1, , i1$
		   GET #1, , i2$
		   ins(k).enveloppescalling1 = ASC(i1$)
		   ins(k).enveloppescalling2 = ASC(i2$)
	    
		   i1$ = " "
		   i2$ = " "
		   GET #1, , i1$
		   GET #1, , i2$
		   ins(k).waveselect1 = ASC(i1$)
		   ins(k).waveselect2 = ASC(i2$)
	    
	    
		   i1$ = " "
		   i2$ = " "
		   GET #1, , i1$
		   GET #1, , i2$
		   ins(k).feedback = ASC(i1$)
		   ins(k).connection = ASC(i2$)

		   i1$ = " "
		   i2$ = " "
		   GET #1, , i1$
		   GET #1, , i2$
		   ins(k).sustaininglevel1 = ASC(i1$)
		   ins(k).sustaininglevel2 = ASC(i2$)

'------- fin du chargement de l'instrument
NEXT



'la trac
FOR i = 1 TO MaxTrack
	GET #1, , MaxNotes(i)       'les max notes
	    'il put l'instrument
	GET #1, , trackdelay(i)
	    'find de put instrument
    
	'put les channels dans le fichier
      
	FOR cn = 1 TO 8: sc$ = " ": GET #1, , sc$: ch.enabled(i, cn) = ASC(sc$): NEXT
	
		FOR k = 1 TO 8
		   FOR j = 0 TO MaxNotes(i) - 1     'les notes
			n1$ = " "
			GET #1, , n1$
			notes(i, k, j) = ASC(n1$)
		   
		    NEXT
		NEXT
NEXT

CLOSE #1
TrackActuel = 0
FOR l = 1 TO 8
	channel = l
	sendinstrument ins(channel)
	setinstrument
NEXT

END FUNCTION

REM $DYNAMIC
SUB loopfms
IF isplay = 0 OR ispause = -1 THEN EXIT SUB
  
    sec! = trackdelay(TrackActuel + 1) / 20
   
    IF TIMER - looptime! >= sec! THEN
     
		      
	IF loopnote + 1 > MaxNotes(TrackActuel + 1) THEN
		loopnote = 0
	    IF MaxTrack > 1 THEN
		TrackActuel = TrackActuel + 1
		IF TrackActuel + 1 > MaxTrack THEN
			TrackActuel = 0: resetallchannel
		END IF

			FOR cn = 1 TO 8
				sendinstrument ins(cn)
				channel = cn + 1
				setinstrument
			NEXT
	       
	    END IF

      
	END IF

	FOR j = 1 TO 8
		    '------ REMET L'INSTRUMENT EN PLACE
			'sendinstrument ins(trackactuel + 1, j)
			'channel = j + 1
			'setinstrument
		    '--------------------------
		      
			getnoteinfo TrackActuel + 1, j, loopnote, di, oc%, freq%
		    
		   
			myplay j, freq%, oc%, di
		    
	NEXT
	loopnote = loopnote + 1
     


	looptime! = TIMER
     END IF




END SUB

REM $STATIC
SUB Manage.Chanel
	FOR i = 1 TO 8
		IF EditActuel <> i - 1 THEN
		d% = ((4 + (i - 1) * 9) * 8) - 2
		IF MouseZOne(d%, 210, d% + 60, 290) AND MouseClicLeft THEN
			DO: LOOP UNTIL NOT (MouseZOne(d%, 210, d% + 60, 290) AND MouseClicLeft)
			IF MouseZOne(d%, 210, d% + 60, 290) THEN
				EditActuel = i - 1
				Draw.Chanels
				Draw.ChanelInfo
			END IF
		END IF
		END IF
	NEXT i
END SUB

'# Retourne en KO le max de mmoire disponible
'#
'# Par Achraf cherti 2001
'#
FUNCTION memoire
	DIM reg AS RegType
	INTERRUPT &H12, reg, reg
	memoire = reg.ax
END FUNCTION

SUB myNouveau (a$)
FOR k = 1 TO 8
	clearins ins(k)
NEXT

resetallchannel
'------------- clear all notes
	FOR j = 0 TO MaxNotes(1) - 1
	    FOR k = 1 TO 8
		setvaleur 1, k, j, 0, 0, 0
	    NEXT
	NEXT
pname = ""
Commentaire = ""
Auteur = ""
MaxTrack = 1
TrackActuel = 0
Position = 0
PositionCurseur = 0
EditActuel = 0
MaxNotes(1) = VAL(a$)
END SUB

SUB myplay (chan, freq, oct, di)


IF freq = 0 THEN EXIT SUB
's'il est disabled alors quitter la sub
IF ch.enabled(TrackActuel + 1, chan) = 1 THEN EXIT SUB

SELECT CASE freq
	CASE -1: e$ = "x"
	CASE 1: e$ = "c"
	CASE 2: e$ = "d"
	CASE 3: e$ = "e"
	CASE 4: e$ = "f"
	CASE 5: e$ = "g"
	CASE 6: e$ = "a"
	CASE 7: e$ = "b"
END SELECT
IF di = 1 AND e$ <> "x" THEN e$ = e$ + "#"

sendinstrument ins(chan)
channel = chan
setinstrument    'mise  jour de l'instrument dans le channel actuel


playnote chan, e$, oct




END SUB

SUB Nouveau


myNouveau "256"
fichier = ""
Auteur = ""
Commentaire = ""
pname = ""
FOR i = 1 TO 8  'tout les chaines  ON
	ch.enabled(1, i) = 0
NEXT
trackdelay(1) = 4
Interface
END SUB

SUB Ouvrir
a$ = FileSelect("open", CurrentDir + "\fmsong\music", "*")
Shelf.Load
Shelf.Draw
IF a$ <> "" THEN
	a$ = a$

	IF loadfms(a$) THEN EXIT SUB
	fichier = a$
	Interface
END IF
END SUB

SUB ouvririnstrument (chan, a$)

fichi$ = a$
IF fichi$ = "" THEN EXIT SUB
fichi$ = fichi$



OPEN fichi$ FOR INPUT AS #1
INPUT #1, head$
'modifier avec un message BOX
IF head$ <> "fm-song instrument" THEN EXIT SUB

INPUT #1, iname

INPUT #1, attack(1), attack(2)
INPUT #1, decay(1), decay(2)
INPUT #1, sustain(1), sustain(2)
INPUT #1, released(1), released(2)
INPUT #1, outp(1), outp(2)
INPUT #1, scalling(1), scalling(2)

INPUT #1, amplitudevibrato(1), amplitudevibrato(2)
'INPUT #1, levelscalling(1), levelscalling(2)
INPUT #1, pitchvibrato(1), pitchvibrato(2)
INPUT #1, frequencymultipler(1), frequencymultipler(2)
INPUT #1, enveloppescalling(1), enveloppescalling(2)
INPUT #1, waveselect(1), waveselect(2)
INPUT #1, sustaininglevel(1), sustaininglevel(2)
INPUT #1, feedback, connection


CLOSE #1
channel = chan
setinstrument    'mise  jour de l'instrument dans le channel actuel



END SUB

SUB pausefms
      FOR i = 0 TO 7
	writereg &HA0 + i, 0
	writereg &HB0 + i, 0
	ispause = -1
      NEXT
END SUB

SUB playall


replay:
Debut = TrackActuel + 1
fin = MaxTrack

FOR k = Debut TO fin
	TrackActuel = k - 1
	
	FOR i = PositionCurseur TO MaxNotes(k) - 1
	      
		FOR j = 1 TO 8
			Draw.Chanel j, 0
			getnoteinfo k, j, PositionCurseur, di, oc%, freq%
			myplay j, freq%, oc%, di
		NEXT
		addcurseur 1
	t! = TIMER
	sec! = trackdelay(k) / 20
	DO

			c$ = INKEY$
			IF LCASE$(c$) = "s" OR c$ = CHR$(27) OR Click.Button(StopBtn) THEN
	
				FOR l = 1 TO 8
					Draw.Chanel l, 0
				NEXT l

				R! = TIMER: DO: LOOP UNTIL TIMER - R! > .25
				stopallchannels
				EXIT SUB
			END IF

			'les F1  F8 pour eteindre un channel
			IF c$ = CHR$(0) + CHR$(59) THEN ch.enabled(TrackActuel + 1, 1) = ch.enabled(TrackActuel + 1, 1) XOR 1
			IF c$ = CHR$(0) + CHR$(60) THEN ch.enabled(TrackActuel + 1, 2) = ch.enabled(TrackActuel + 1, 2) XOR 1
			IF c$ = CHR$(0) + CHR$(61) THEN ch.enabled(TrackActuel + 1, 3) = ch.enabled(TrackActuel + 1, 3) XOR 1
			IF c$ = CHR$(0) + CHR$(62) THEN ch.enabled(TrackActuel + 1, 4) = ch.enabled(TrackActuel + 1, 4) XOR 1
			IF c$ = CHR$(0) + CHR$(63) THEN ch.enabled(TrackActuel + 1, 5) = ch.enabled(TrackActuel + 1, 5) XOR 1
			IF c$ = CHR$(0) + CHR$(64) THEN ch.enabled(TrackActuel + 1, 6) = ch.enabled(TrackActuel + 1, 6) XOR 1
			IF c$ = CHR$(0) + CHR$(65) THEN ch.enabled(TrackActuel + 1, 7) = ch.enabled(TrackActuel + 1, 7) XOR 1
			IF c$ = CHR$(0) + CHR$(66) THEN ch.enabled(TrackActuel + 1, 8) = ch.enabled(TrackActuel + 1, 8) XOR 1


	LOOP UNTIL TIMER - t! >= sec!

	NEXT
	PositionCurseur = 0
	Position = 0


NEXT
TrackActuel = 0
GOTO replay

END SUB

SUB playfms
     IF isplay <> -1 THEN
	loopnote = 0
	TrackActuel = 0
      
	isplay = -1
	ispause = 0
     END IF
END SUB

SUB playit

FOR n% = 0 TO &HF5
  writereg n%, 0
NEXT n%

setinstrument

'la frequence et l'octave
freq% = &H16B
octave% = 4
'diffuse le son dans le haut parleur
writereg &HA0 + channel, freq% AND &HFF
writereg &HB0 + channel, INT(freq% / 256) OR 32 OR octave%



END SUB

SUB playnote (chan, note$, octave)


writereg &HA0 + chan - 1, 0
writereg &HB0 + chan - 1, 0

'IF note$ = 0 THEN EXIT SUB

SELECT CASE LCASE$(note$)
	CASE "c": note% = 0
	CASE "c#": note% = 1
	CASE "d": note% = 2
	CASE "d#": note% = 3
	CASE "e": note% = 4
	CASE "f": note% = 5
	CASE "f#": note% = 6
	CASE "g": note% = 7
	CASE "g#": note% = 8
	CASE "a": note% = 9
	CASE "a#": note% = 10
	CASE "b": note% = 11
	CASE "x": resetchan chan: EXIT SUB
	
END SELECT

Octv% = octave
freq% = notef(note% MOD 12)
writereg &HA0 + chan - 1, freq% AND &HFF
writereg &HB0 + chan - 1, INT(freq% / 256) OR 32 OR (Octv% * 4)



END SUB

SUB playwav (wavefile$, watp%)
IF wav = false THEN EXIT SUB
IF INSTR(wavefile$, ".") = 0 THEN wavefile$ = wavefile$ + ".wav"
repeats% = 1
tmp% = 0
blast$ = UCASE$(ENVIRON$("BLASTER"))


IF LEN(blast$) THEN
tmp% = INSTR(blast$, "A")
tmp1$ = MID$(blast$, tmp% + 1, 3)
tmp% = VAL("&H" + tmp1$)
IF tmp% = 203 THEN tmp% = -1
IF tmp% > 0 THEN
tmp2% = INSTR(blast$, "D")
dma% = VAL(MID$(blast$, tmp2% + 1))

IF dma% < 0 OR dma% > 7 THEN tmp% = -2
END IF
END IF
BlasterAddr% = tmp%

sp% = INSTR(Spec$, " ")
IF sp% THEN
wavefile$ = LEFT$(Spec$, sp% - 1)
repeats% = VAL(RIGHT$(Spec$, LEN(Spec$) - sp%))
IF repeats% = 0 THEN repeats% = 1
ELSE
IF LEN(Spec$) THEN
wavefile$ = Spec$
repeats% = 1
END IF
END IF
IF LEN(wavefile$) = 0 THEN
END IF
rID$ = SPACE$(4)
wid$ = SPACE$(4)
fID$ = SPACE$(4)
dat$ = SPACE$(4)
dummy$ = SPACE$(1)
filenum% = FREEFILE
OPEN wavefile$ FOR BINARY AS filenum%
IF LOF(filenum%) = 0 THEN
	CLOSE filenum%
	KILL wavefile$
	EXIT SUB
END IF

IF watp% = -1 THEN watp% = LOF(filenum%)
GET filenum%, , rID$
GET filenum%, , rLen&
GET filenum%, , wid$
GET filenum%, , fID$
GET filenum%, , fLen&
GET filenum%, , wFormatTag%
GET filenum%, , Channels%
GET filenum%, , Sampling&
GET filenum%, , Bytes&
GET filenum%, , nBlockAlign%
GET filenum%, , FormatSpecific%
FOR i% = 1 TO fLen& - 16
GET filenum%, , dummy$
NEXT i%
GET filenum%, , dat$
IF UCASE$(dat$) = "FACT" THEN
GET filenum%, , dummy&
GET filenum%, , dummy&
GET filenum%, , dat$
END IF
GET filenum%, , WavLen&
LenHeader% = LOC(1)
CLOSE filenum%
IF UCASE$(rID$) = "RIFF" THEN
IF UCASE$(wid$) = "WAVE" THEN
IF UCASE$(dat$) = "DATA" THEN
IF UCASE$(fID$) = "FMT " THEN
IF FormatSpecific% = 8 THEN ok% = -1
END IF
END IF
END IF
END IF
SBtempary2 = 0
DO:
 SBtempary2 = SBtempary2 + 1
 IF SBtempary2 > 5 THEN
  SBtempary2 = 0
  EXIT DO
 END IF
LOOP UNTIL (INP(BlasterAddr% + &HC) AND 128) = 0

OUT BlasterAddr% + &HC, &HD1'Speaker ON
filenum% = FREEFILE
OPEN wavefile$ FOR BINARY AS filenum%
num% = 0
SEEK filenum%, LenHeader% + 1
Remaining& = WavLen&
num% = num% + 1
IF Remaining& > watp% THEN
BufferLen% = watp%
ELSE
BufferLen% = Remaining&
END IF
Remaining& = Remaining& - BufferLen%
buffer$ = SPACE$(BufferLen%)
GET filenum%, , buffer$
BufferLen% = BufferLen% - 1
Segment& = VARSEG(buffer$)
offset& = SADD(buffer$)
IF Segment& < 0 THEN Segment& = Segment& + 65536
IF offset& < 0 THEN offset& = offset& + 65536
baseaddr& = Segment& * 16 + offset&
look1% = VARPTR(baseaddr&)
look2% = VARPTR(BufferLen%)
SELECT CASE dma%
CASE 0: dmapage% = &H87: dmaaddr% = 0: dmalen% = 1
CASE 1: dmapage% = &H83: dmaaddr% = 2: dmalen% = 3
CASE 2: dmapage% = &H81: dmaaddr% = 4: dmalen% = 5
CASE 3: dmapage% = &H82: dmaaddr% = 6: dmalen% = 7
CASE 4: dmapage% = &H8F: dmaaddr% = &HC0: dmalen% = &HC2
CASE 5: dmapage% = &H8B: dmaaddr% = &HC4: dmalen% = &HC6
CASE 6: dmapage% = &H89: dmaaddr% = &HC8: dmalen% = &HCA
CASE 7: dmapage% = &H8A: dmaaddr% = &HCC: dmalen% = &HCE
END SELECT
SELECT CASE dma%
CASE 0 TO 3: dmamask% = &HA: dmamode% = &HB: dmaclear% = &HC: dmastatus% = &H8
CASE 4 TO 7: dmamask% = &HD4: dmamode% = &HD6: dmaclear% = &HD8: dmastatus% = &HD0
END SELECT
SELECT CASE dma%
CASE 0, 4: dmaterminal% = 1
CASE 1, 5: dmaterminal% = 2
CASE 2, 6: dmaterminal% = 4
CASE 3, 7: dmaterminal% = 8
END SELECT
OUT dmamask%, dma% + 4
OUT dmaclear%, &H0
OUT dmamode%, 72 + dma%
OUT dmaaddr%, PEEK(look1%)
OUT dmaaddr%, PEEK(look1% + 1)
OUT dmapage%, PEEK(look1% + 2)
OUT dmalen%, PEEK(look2%)
OUT dmalen%, PEEK(look2% + 1)
OUT dmamask%, dma%
IF num% = 1 THEN
timeconst% = 256 - 1000000 / (Sampling& * Channels%)
DO: LOOP UNTIL (INP(BlasterAddr% + &HC) AND 128) = 0
OUT BlasterAddr% + &HC, &H40
DO: LOOP UNTIL (INP(BlasterAddr% + &HC) AND 128) = 0
OUT BlasterAddr% + &HC, timeconst%
OUT BlasterAddr% + &H4, &H0
OUT BlasterAddr% + &H4 + 1, 0
OUT BlasterAddr% + &H4, &H22
OUT BlasterAddr% + &H4 + 1, 255
IF Channels% = 2 THEN
OUT BlasterAddr% + &H4, &HE
OUT BlasterAddr% + &H4 + 1, 34
END IF
END IF
IF Bytes& > 22000 THEN
DO: LOOP UNTIL (INP(BlasterAddr% + &HC) AND 128) = 0
OUT BlasterAddr% + &HC, &H48
ELSE
DO: LOOP UNTIL (INP(BlasterAddr% + &HC) AND 128) = 0
OUT BlasterAddr% + &HC, &H14
END IF
DO: LOOP UNTIL (INP(BlasterAddr% + &HC) AND 128) = 0
OUT BlasterAddr% + &HC, PEEK(look2%)
DO: LOOP UNTIL (INP(BlasterAddr% + &HC) AND 128) = 0
OUT BlasterAddr% + &HC, PEEK(look2% + 1)
IF Bytes& > 22000 THEN
DO: LOOP UNTIL (INP(BlasterAddr% + &HC) AND 128) = 0
OUT BlasterAddr% + &HC, &H91
END IF
dummy% = INP(dmastatus%)
dummy% = INP(BlasterAddr% + &HE)
OUT &H20, &H20
CLOSE filenum%
END SUB

SUB printat (str AS STRING, x AS INTEGER, y AS INTEGER, col AS INTEGER)
LOCATE y, x
COLOR col
PRINT str;
END SUB

SUB printna (char AS STRING, maxc AS INTEGER, px AS INTEGER, py AS INTEGER, col AS INTEGER)

'print sans pcopy sans son et sans delay

DIM str AS STRING
DIM max AS INTEGER
DIM x AS INTEGER
DIM y AS INTEGER
str = char
max = maxc

'x = LEN(str)
y = 0

LOCATE py + y, px + x
COLOR col
FOR i = 1 TO LEN(str)
    
	d = d + 1
	IF d = max THEN
		x = 0
		d = 0
		y = y + 1
	     
		IF MID$(str, i, 1) <> " " THEN
			PRINT "-"
		END IF
		LOCATE py + y, px + x
	END IF
	IF NOT (d = 0 AND MID$(str, i, 1) = " ") THEN
		PRINT MID$(str, i, 1);
	END IF

NEXT


PRINT
END SUB

SUB resetallchannel
FOR i = 1 TO 9
	resetchannel i
NEXT


END SUB

SUB resetchan (chan)
       
	
	writereg &HA0 + chan - 1, 0
	writereg &HB0 + chan - 1, 0

END SUB

SUB resetchannel (chan)

SELECT CASE chan
	CASE 1:
		carplus = 0
		modplus = 3
	CASE 2:
		carplus = 1
		modplus = 4
	CASE 3:
		carplus = 2
		modplus = &H5
	CASE 4:
		carplus = 8
		modplus = &HB
	CASE 5:
		carplus = 9
		modplus = &HC
	CASE 6:
		carplus = 10
		modplus = &HD
	CASE 7:
		carplus = &H10
		modplus = &H13
	CASE 8:
		carplus = &H11
		modplus = &H14
	CASE 9:
		carplus = &H12
		modplus = &H15

END SELECT

r1 = &H20 + carplus       'le carrier
r2 = &H20 + modplus
r3 = &H40 + carplus
r4 = &H40 + modplus
r5 = &H60 + carplus
r6 = &H60 + modplus
r7 = &H80 + carplus
r8 = &H80 + modplus

r9 = 224 + carplus
r10 = 227 + carplus
r11 = 192 + chan - 1

writereg r1, 0
writereg r2, 0
writereg r3, 0
writereg r4, 0
writereg r5, 0
writereg r6, 0
writereg r7, 0
writereg r8, 0
writereg r9, 0
writereg r10, 0
writereg r11, 0


END SUB

SUB resumefms
	ispause = 0
END SUB

SUB selectionnertout
       
	selection = -1
	debutselection = 0
	finselection = MaxNotes(TrackActuel + 1) - 1
	PositionCurseur = finselection
	Position = PositionCurseur - 3
	IF Position < 0 THEN Position = 0

END SUB

SUB sendinstrument (buffer AS instrument)


attack(1) = buffer.attack1
attack(2) = buffer.attack2

decay(1) = buffer.decay1
decay(2) = buffer.decay2

sustain(1) = buffer.sustain1
sustain(2) = buffer.sustain2

released(1) = buffer.released1
released(2) = buffer.released2

outp(1) = buffer.outp1
outp(2) = buffer.outp2

scalling(1) = buffer.scalling1
scalling(2) = buffer.scalling2

amplitudevibrato(1) = buffer.amplitudevibrato1
amplitudevibrato(2) = buffer.amplitudevibrato2

pitchvibrato(1) = buffer.pitchvibrato1
pitchvibrato(2) = buffer.pitchvibrato2

frequencymultipler(1) = buffer.frequencymultipler1
frequencymultipler(2) = buffer.frequencymultipler2


enveloppescalling(1) = buffer.enveloppescalling1
enveloppescalling(2) = buffer.enveloppescalling2

waveselect(1) = buffer.waveselect1
waveselect(2) = buffer.waveselect2

feedback = buffer.feedback
connection = buffer.connection

sustaininglevel(1) = buffer.sustaininglevel1
sustaininglevel(2) = buffer.sustaininglevel2

iname = buffer.iname






END SUB

SUB setinstrument
chan = channel
SELECT CASE chan
	CASE IS = 1:
		carplus = 0
		modplus = 3
	CASE 2:
		carplus = 1
		modplus = 4
      
	CASE 3:
		carplus = 2
		modplus = &H5
      
	CASE 4:
		carplus = 8
		modplus = &HB
      
	CASE 5:
		carplus = 9
		modplus = &HC
      
	CASE 6:
		carplus = 10
		modplus = &HD
      
	CASE 7:
		carplus = &H10
		modplus = &H13
      
	CASE 8:
		carplus = &H11
		modplus = &H14
      
	CASE 9:
		carplus = &H12
		modplus = &H15

END SELECT


r1 = &H20 + carplus       'le carrier
r2 = &H20 + modplus
r3 = &H40 + carplus
r4 = &H40 + modplus
r5 = &H60 + carplus
r6 = &H60 + modplus
r7 = &H80 + carplus
r8 = &H80 + modplus

r9 = 224 + carplus
r10 = 227 + carplus
r11 = 192 + chan - 1

'-------LA VAR 1
IF pitchvibrato(1) = 1 THEN var1 = 128
IF amplitudevibrato(1) = 1 THEN var1 = var1 + 64
IF sustaininglevel(1) = 1 THEN var1 = var1 + 32
IF enveloppescalling(1) = 1 THEN var1 = var1 + 16
var1 = var1 + frequencymultipler(1)

'-------LA VAR 2
IF pitchvibrato(2) = 1 THEN var2 = 128
IF amplitudevibrato(2) = 1 THEN var2 = var2 + 64
IF sustaininglevel(2) = 1 THEN var2 = var2 + 32
IF enveloppescalling(2) = 1 THEN var2 = var2 + 16
var2 = var2 + frequencymultipler(2)

'-------LA VAR 3
var3 = (scalling(1) * 64) + outp(1)

'-------LA VAR 4
var4 = (scalling(2) * 64) + outp(2)

'------- La var 5
var5 = (attack(1) * 16) + decay(1)

'------- La var 5
var6 = (attack(2) * 16) + decay(2)

'--------La var 7
var7 = (sustain(1) * 16) + released(1)

'--------La var 8
var8 = (sustain(2) * 16) + released(2)

'--------La var 9
var9 = waveselect(1)

'--------La var 10
var10 = waveselect(2)

'--------La var 11
var11 = (feedback * 2) + connection

writereg r1, var1
writereg r2, var2
writereg r3, var3
writereg r4, var4
writereg r5, var5

writereg r6, var6
writereg r7, var7

writereg r8, var8

writereg r9, var9
writereg r10, var10
writereg r11, var11



END SUB

REM $DYNAMIC
SUB setnote (track AS INTEGER, chan AS INTEGER, num AS INTEGER, valeur AS INTEGER)

offs = VARPTR(notes(track, chan, num))
    
DEF SEG = VARSEG(notes(track, chan, 1))
POKE offs, valeur
DEF SEG

END SUB

SUB setvaleur (track, chan, num, diese, octave, note)
var = 0
var = (var AND 191) + (diese * 64)
var = (var AND 199) + (octave * 8)

IF note >= 0 THEN

	var = (var AND 248) + (note)

ELSE
	var = (var AND 127) + 128
END IF

setnote track, chan, num, var






END SUB

REM $STATIC
'#########################################################
'#        Fonction de la gestion de la touche Shift
'#########################################################
'# Nombre        Boutton
'#   1             Shift droit
'#   2             Shift gauche
'#   4             Ctrl
'#   8             Alt actif
'#   16            Scroll lock actif
'#   32            Num lock actif
'#   64            Caps lock actif
'#   128           Insert actif
'#########################################################
'# Par achraf cherti 2001 de  - THUNDER SOFTWARE -
'#
'# Email: achrafcherti@hotmail.com
'# url: http://www.qbworld.fr.st
'#########################################################
FUNCTION Shift (n AS INTEGER)
	DIM reg AS RegTypeX
	DEF SEG = VARSEG(reg.ax)
		POKE VARPTR(reg.ax) + 1, 2
	DEF SEG
	INTERRUPTX &H16, reg, reg
	s = reg.ax AND n
	IF s <> 0 THEN Shift = -1
END FUNCTION

SUB son
END SUB

SUB stopallchannels

FOR l = 1 TO 8
	resetchan l
NEXT


END SUB

SUB stopfms
	loopnote = 0
	'trackactuel = 0
	isplay = 0
	FOR i = 0 TO 8
	      writereg &HA0 + i, 0
	      writereg &HB0 + i, 0
	NEXT
	ispause = -1
END SUB

SUB voirprop
'PCOPY 1, 2
'whbox 5, 7, 69, 10, 15, 1
'
'COLOR 15
'LOCATE 7, 9: PRINT "Proprit de la musique "
'LOCATE 9, 7: PRINT "Titre:          "; pname
'LOCATE 10, 7: PRINT "Auteur:         "; auteur
'LOCATE 11, 7: PRINT "Commentaire:    "; commentaire
'LOCATE 14, 36: PRINT "<  OK  >";
'
'
'
'PCOPY 1, 0
'
'a$ = INPUT$(1)
'PCOPY 2, 1
'
'
END SUB

SUB waitmouse
'DO
'bo = MBtn%
'LOOP UNTIL bo = 0

END SUB

SUB writereg (reg%, info%)
 OUT &H388, reg%
 FOR d% = 1 TO 6: x% = INP(&H388): NEXT d%
 OUT &H389, info%
 FOR d% = 1 TO 35: x% = INP(&H388): NEXT d%
END SUB

