'$INCLUDE: 'lib\guilib.bi'
'$INCLUDE: 'lib\mouse.bi'
'$INCLUDE: 'lib\modules.bi'
'$INCLUDE: 'lib\app.bi'
'$INCLUDE: 'lib\xTextBox.bi'
'$INCLUDE: 'lib\itemlist.bi'
'$INCLUDE: 'lib\reg.bi'
'$INCLUDE: 'lib\locale.bi'
'$INCLUDE: 'lib\textbox.bi'

DECLARE SUB DeleteCurrentNote (num AS INTEGER)
DECLARE SUB SaveCurrentNote (num AS INTEGER, title AS STRING, text AS STRING)
DECLARE SUB LoadNoteText (text AS STRING, num AS INTEGER)
DECLARE SUB AddNote ()
DECLARE SUB LoadNotes ()
DECLARE SUB SaveFile (filename AS STRING, txt AS STRING)
DECLARE SUB OpenFile (filename AS STRING, text AS STRING)
TYPE NoteInfo
	title AS STRING * 50
	textlen AS INTEGER
END TYPE
'$DYNAMIC
DIM SHARED rep AS INTEGER
ON ERROR GOTO catch

DIM SHARED wx1 AS INTEGER, wy1 AS INTEGER, wx2 AS INTEGER, wy2 AS INTEGER
DIM SHARED SaveNoteBtn AS button
DIM SHARED DeleteNoteBtn AS button
DIM SHARED AddNoteBtn AS button
DIM SHARED NoteTitleTxt AS TextBox
DIM SHARED NbrNOtes AS INTEGER
DIM SHARED SelectedNote AS INTEGER
DIM ContentText AS STRING

DIM SHARED ListeNotes AS ItemList
DIM SHARED NotesData(1) AS ListItem
DIM SHARED NotesInfo(1) AS NoteInfo

wx = 611
wy = 395
wx1 = (640 - wx) / 2
wy1 = (495 - wy) / 2
wx2 = wx1 + wx - 1
wy2 = wy1 + wy - 1
App.SetTitle (Localize("jotter.str", "txtTitle"))
App.AddMenuItem (Localize("system.str", "txtExit"))
LoadNotes

GUI.Init
App.DrawGui
Draw.Window wx1, wy1 - 15, wx2, wy2, Localize("jotter.str", "txtTitle")
DIM txt AS MultiLine
Init.MultiLine txt, wx1 + 200, wy1 + 22, (wx - 221) \ 8, (wy - 56) \ 8
Init.ItemLIst ListeNotes, wx1 + 10, wy1 + 65, 1, 27
ListeNotes.MaxWidth = 21
ListeNotes.MinWIdth = 21

Initx.Button SaveNoteBtn, Localize("system.str", "txtSave"), wx2 - 150, wy2 - 25, wx2 - 5, wy2 - 5
Initx.Button DeleteNoteBtn, Localize("system.str", "txtDelete"), wx1 + 200, wy2 - 25, wx1 + 345, wy2 - 5
Initx.Button AddNoteBtn, Localize("system.str", "txtNew"), wx1 + 10, wy1 + 10, wx1 + 140, wy1 + 35
Init.TextBox NoteTitleTxt, wx1 + 250, wy1 + 5, 40
OpenedFIle$ = ""



Draw.MUltiLIne txt, ContentText
Draw.Button SaveNoteBtn
Draw.Button AddNoteBtn
Draw.Button DeleteNoteBtn
Draw.Text Localize("jotter.str", "txtNotetitle"), wx1 + 200, wy1 + 8, TextColor, BgColor
Draw.TextBox NoteTitleTxt
IF NbrNOtes > 0 THEN Draw.ItemList ListeNotes, NotesData()
MouseShow
DO
	IF Click.Button(AddNoteBtn) THEN
		IF SelectedNote > 0 THEN
		SaveCurrentNote SelectedNote, LEFT$(NoteTitleTxt.text, NoteTitleTxt.textlen), ContentText
		END IF
		AddNote
		LoadNotes
		IF NbrNOtes > 0 THEN Draw.ItemList ListeNotes, NotesData()
	END IF
	IF SelectedNote > 0 THEN
		IF Click.Button(DeleteNoteBtn) THEN
			DeleteCurrentNote SelectedNote
			LoadNotes
			IF SelectedNote > NbrNOtes THEN SelectedNote = NbrNOtes
			IF NbrNOtes > 0 THEN
				NotesData(SelectedNote).selected = -1
				Draw.ItemList ListeNotes, NotesData()
				NoteTitleTxt.text = NotesInfo(SelectedNote).title
				NoteTitleTxt.textlen = LEN(LTRIM$(RTRIM$(NoteTitleTxt.text)))
				LoadNoteText ContentText, SelectedNote
				Draw.TextBox NoteTitleTxt
				Draw.MUltiLIne txt, ContentText
				NotesData(SelectedNote).selected = -1
				Draw.ItemList ListeNotes, NotesData()
		       
			ELSE
				ContentText = ""
				NoteTitleTxt.text = ""
				NoteTitleTxt.textlen = 0
				Draw.TextBox NoteTitleTxt
				Draw.MUltiLIne txt, ContentText
				LINE (ListeNotes.upbtn.x1 - 1, ListeNotes.upbtn.y1)-(ListeNotes.upbtn.x2 + 1, ListeNotes.downbtn.y2), BgColor, BF
			END IF
			

		END IF
	       
		Manage.TextBox NoteTitleTxt
		Manage.MultiLIne txt, ContentText
		IF Click.Button(SaveNoteBtn) THEN
			SaveCurrentNote SelectedNote, LEFT$(NoteTitleTxt.text, NoteTitleTxt.textlen), ContentText
			LoadNotes
			IF NbrNOtes > 0 THEN
				NotesData(SelectedNote).selected = -1
				Draw.ItemList ListeNotes, NotesData()
			END IF
		END IF
	END IF
	IF NbrNOtes > 0 THEN
		Manage.ItemList ListeNotes, NotesData()
		IF ListeNotes.SelectionChanged THEN
			'SaveCurrentNote SelectedNote, LEFT$(NoteTitleTxt.Text, NoteTitleTxt.TextLen), ContentText
			SelectedNote = ListeNotes.SelectedIndex
			NoteTitleTxt.text = NotesInfo(SelectedNote).title
			NoteTitleTxt.textlen = LEN(LTRIM$(RTRIM$(NoteTitleTxt.text)))
			LoadNoteText ContentText, SelectedNote
			Draw.TextBox NoteTitleTxt
			Draw.MUltiLIne txt, ContentText
		END IF
	END IF

'        IF FreeMem& <> FRE("") THEN
'                FreeMem& = FRE("")
'                Draw.Text "Free mem: " + STR$(FreeMem&) + " B ", 70, 5, 15, 20
'        END IF
	oldfocus = txt.focus
	SelectedMenu = ""
	App.Manage
	IF SelectedMenu <> "" THEN
	SELECT CASE SelectedMenu
		CASE "Exit"
			app.exit
		CASE Localize("system.str", "txtExit")
			app.exit
	END SELECT
	END IF
LOOP





catch:
	rep = 0
	RESUME NEXT

REM $STATIC
SUB AddNote
	DIM N AS INTEGER
	DIM Ninfo AS NoteInfo
	Ninfo.title = Localize("jotter.str", "txtDefaultnotetitle")
	Ninfo.textlen = 1
	fic = FREEFILE
	OPEN "system\jotter.dat" FOR BINARY AS fic
	fic2 = FREEFILE
	OPEN "system\jotter.tmp" FOR BINARY AS fic2
		GET #fic, , N
		N = N + 1
		PUT #fic2, , N
		FOR i = 1 TO NbrNOtes
			GET #fic, , NotesInfo(i)
			PUT #fic2, , NotesInfo(i)
		NEXT i
		PUT #fic2, , Ninfo
		FOR i = 1 TO NbrNOtes
			t$ = ""
			IF NotesInfo(i).textlen > 0 THEN
			   t$ = STRING$(NotesInfo(i).textlen, " ")
			   GET #fic, , t$
			   PUT #fic2, , t$
			END IF
		NEXT i
	CLOSE fic2
	CLOSE fic

	KILL "system\jotter.dat"
	NAME "system\jotter.tmp" AS "system\jotter.dat"
END SUB

SUB DeleteCurrentNote (num AS INTEGER)
	DIM N AS INTEGER
	fic = FREEFILE
	OPEN "system\jotter.dat" FOR BINARY AS fic
	fic2 = FREEFILE
	OPEN "system\jotter.tmp" FOR BINARY AS fic2
		GET #fic, , N
		N = N - 1
		PUT #fic2, , N
		FOR i = 1 TO NbrNOtes
			GET #fic, , NotesInfo(i)
			IF i <> num THEN PUT #fic2, , NotesInfo(i)
		NEXT i
		FOR i = 1 TO NbrNOtes
			t$ = ""
			IF NotesInfo(i).textlen > 0 THEN
			   t$ = STRING$(NotesInfo(i).textlen, " ")
			   GET #fic, , t$
			   IF i <> num THEN PUT #fic2, , t$
			END IF
		NEXT i
	CLOSE fic2
	CLOSE fic

	KILL "system\jotter.dat"
	NAME "system\jotter.tmp" AS "system\jotter.dat"

END SUB

SUB LoadNotes
	fic = FREEFILE
	rep = 0
	DIM Info AS NoteInfo
	OPEN "system\jotter.dat" FOR BINARY AS fic
		IF LOF(fic) = 0 THEN
			NbrNOtes = 0
			NotesData(1).text = ""
			REDIM NotesData(1) AS ListItem
			ERASE NotesInfo
			CLOSE fic
			EXIT SUB
		END IF
		GET #fic, , NbrNOtes
		IF NbrNOtes = 0 THEN
			NotesData(1).text = ""
			REDIM NotesData(1) AS ListItem
			ERASE NotesInfo
			CLOSE fic
			EXIT SUB
		END IF
		REDIM NotesData(1 TO NbrNOtes) AS ListItem
		REDIM NotesInfo(1 TO NbrNOtes) AS NoteInfo
		FOR i = 1 TO NbrNOtes
			GET #fic, , NotesInfo(i)
			NotesData(i).text = NotesInfo(i).title
			NotesData(i).selected = 0
		NEXT i
	CLOSE fic
END SUB

SUB LoadNoteText (text AS STRING, num AS INTEGER)
	fic = FREEFILE
	DIM N AS INTEGER
	OPEN "system\jotter.dat" FOR BINARY AS fic
		GET #fic, , N
		FOR i = 1 TO NbrNOtes
			GET #fic, , NotesInfo(i)
		NEXT i
		FOR i = 1 TO num
			t$ = ""
			IF NotesInfo(i).textlen > 0 THEN
			   t$ = STRING$(NotesInfo(i).textlen, " ")
			   GET #fic, , t$
			END IF
			text = t$
		NEXT i
	CLOSE fic
END SUB

SUB SaveCurrentNote (num AS INTEGER, title AS STRING, text AS STRING)
	DIM N AS INTEGER
	
	fic = FREEFILE
	OPEN "system\jotter.dat" FOR BINARY AS fic
	fic2 = FREEFILE
	OPEN "system\jotter.tmp" FOR BINARY AS fic2
		GET #fic, , N
		PUT #fic2, , NbrNOtes
		FOR i = 1 TO NbrNOtes
			GET #fic, , NotesInfo(i)
			IF i = num THEN
				oldlen = NotesInfo(i).textlen
				NotesInfo(i).title = title
				NotesInfo(i).textlen = LEN(text)
			END IF
			PUT #fic2, , NotesInfo(i)
		NEXT i
		FOR i = 1 TO NbrNOtes
			IF i <> num THEN
				t$ = ""
				IF NotesInfo(i).textlen > 0 THEN
				   t$ = STRING$(NotesInfo(i).textlen, " ")
				   GET #fic, , t$
				   PUT #fic2, , t$
				END IF
			ELSE
				t$ = ""
				IF oldlen > 0 THEN
					t$ = STRING$(oldlen, " ")
					GET #fic, , t$
				END IF
				IF LEN(text) > 0 THEN
					PUT #fic2, , text
				END IF
			END IF
				
		NEXT i
	CLOSE fic2
	CLOSE fic

	KILL "system\jotter.dat"
	NAME "system\jotter.tmp" AS "system\jotter.dat"


END SUB

