'$INCLUDE: 'guilib.bi'

SUB alpha (x1, y1, x2, y2, i)
	c = 72 * i
	FOR x = x1 TO x2
		FOR y = y1 TO y2
			p = POINT(x, y)
			IF p >= 32 THEN
				IF (p + c < 256) THEN
					PSET (x, y), p + c
				ELSE
					PSET (x, y), 0
				END IF
			ELSEIF (p < 16) AND (p > 8) THEN
					PSET (x, y), p - 8
			ELSEIF (p > 24) THEN
					PSET (x, y), p - 8
			END IF
		NEXT y
	NEXT x
END SUB

SUB App.DrawClock
	draw.Text Clock, exitbtn.x1 - 44, 4, 15, 20
	LINE (exitbtn.x1 - 47, 2)-(exitbtn.x1 - 3, 2), 16
	LINE -(exitbtn.x1 - 3, 13), 24
	LINE -(exitbtn.x1 - 47, 13), 24
	LINE -(exitbtn.x1 - 47, 2), 16
END SUB

SUB App.DrawGui
SCREEN 13
load.bsv "wall\bg2.bsv"
load.font ("8x8.fon")
	App.Init
	LINE (0, 0)-(310, 14), 20, BF
	LINE (appbtn.x2 + 1, 14)-(appbtn.x2 + 1, 0), 24
	LINE -(exitbtn.x1 - 1, 0), 24
	LINE -(exitbtn.x1 - 1, 14), 16
	LINE -(appbtn.x2 + 2, 14), 16
	draw.Button appbtn
	draw.Button exitbtn
END SUB

SUB App.Exit
	SCREEN 0
	WIDTH 80, 25
	END
END SUB

SUB App.Init
	Initx.Button exitbtn, "x", 305, 0, 319, 14
END SUB

SUB App.Manage
	IF Click.Button(exitbtn) THEN App.Exit
	IF Click.Button(appbtn) THEN
	END IF
	IF Clock <> LEFT$(TIME$, 5) THEN
		Clock = LEFT$(TIME$, 5)
		App.DrawClock
	END IF
END SUB

SUB App.SetTitle (t AS STRING)
	Initx.Button appbtn, t, 0, 0, 0, 14
END SUB

FUNCTION Click.Button (this AS button)
	IF (MouseZOne(this.x1, this.y1, this.x2, this.y2)) THEN
		this.hover = -1
		draw.Button this
		DO
			IF MouseClicLeft THEN
				this.pressed = -1
				draw.Button this
				DO
				LOOP UNTIL NOT (MouseZOne(this.x1, this.y1, this.x2, this.y2) AND MouseClicLeft)
				IF MouseZOne(this.x1, this.y1, this.x2, this.y2) THEN
					this.hover = 0
					this.pressed = 0
					Click.Button = -1
					draw.Button this
					EXIT FUNCTION
				END IF

			END IF
		LOOP UNTIL NOT MouseZOne(this.x1, this.y1, this.x2, this.y2)
		this.hover = 0
		draw.Button this
	END IF

END FUNCTION

SUB cls.screen (col AS INTEGER)
	LINE (0, 0)-(319, 199), col, BF
END SUB

SUB draw.Button (this AS button)
DIM tx AS INTEGER
DIM ty AS INTEGER
	ty = (this.y2 + this.y1 - 8) / 2
	tx = (this.x2 + this.x1 - (LEN(LTRIM$(RTRIM$(this.text))) * 8)) / 2
	IF (NOT this.hover) THEN
		MouseHide
		LINE (this.x1, this.y1)-(this.x2, this.y2), 20, BF
		IF this.style = 1 THEN
			draw.Gradient this.x1, this.y1, this.x2, this.y2, 24, 16
		END IF
		LINE (this.x1, this.y1)-(this.x2, this.y1), 24
		LINE -(this.x2, this.y2), 16
		LINE -(this.x1, this.y2), 16
		LINE -(this.x1, this.y1), 24
		draw.Text this.text, tx, ty, 15, -1
		MouseShow
		EXIT SUB
	END IF
	IF this.pressed THEN
		MouseHide
		draw.Gradient this.x1, this.y1, this.x2, this.y2, 16, 28
		LINE (this.x1, this.y1)-(this.x2, this.y1), 16
		LINE -(this.x2, this.y2), 28
		LINE -(this.x1, this.y2), 28
		LINE -(this.x1, this.y1), 16

		draw.Text this.text, tx + 1, ty + 1, 15, -1
		MouseShow
		EXIT SUB
	END IF
	IF this.hover THEN
		MouseHide
		draw.Gradient this.x1, this.y1, this.x2, this.y2, 28, 16
		LINE (this.x1, this.y1)-(this.x2, this.y1), 28
		LINE -(this.x2, this.y2), 16
		LINE -(this.x1, this.y2), 16
		LINE -(this.x1, this.y1), 28

		draw.Text this.text, tx, ty, 15, -1
		MouseShow
		EXIT SUB

	END IF
END SUB

SUB draw.Gradient (x1 AS INTEGER, y1 AS INTEGER, x2 AS INTEGER, y2 AS INTEGER, c1 AS INTEGER, c2 AS INTEGER)
	stepc = (c2 - c1) / (y2 - y1)
	
	c = c1
	FOR y = y1 TO y2
		LINE (x1, y)-(x2, y), c
		c = c + stepc
	NEXT y
END SUB

SUB Draw.Pic (picfile AS STRING, x1 AS INTEGER, y1 AS INTEGER, z1 AS SINGLE)
IF LTRIM$(RTRIM$(picfile)) = "" THEN EXIT SUB
DEF SEG = &HA000
MouseHide
fic = FREEFILE
DIM rat AS INTEGER
ratio = z1
IF ratio = 0 THEN ratio = 1
DIM xs AS INTEGER
DIM ys AS INTEGER
DIM zs AS STRING * 1
	OPEN picfile FOR BINARY AS fic
		GET #fic, , xs
		GET #fic, , ys
		  FOR y = ys - 1 TO 0 STEP -1
			FOR x = xs - 1 TO 0 STEP -1
		       
				GET #fic, , zs
				'pour des images grossies
				IF ratio >= 1 THEN
				FOR x2 = 1 TO ratio
					FOR y2 = 1 TO ratio
						IF ASC(zs) <> 255 THEN
						POKE ((y1 + (y * ratio) + y2 - 1) * 320) + (x1 + (x * ratio) + x2 - 1), ASC(zs)
						END IF
					NEXT y2
				NEXT x2
				ELSE
					rat = (rat + 1) MOD (1 / ratio)
					IF rat = 0 THEN PSET (x1 + INT(x * ratio), y1 + INT(y * ratio)), ASC(zs)
				END IF
			NEXT x
		NEXT y
CLOSE fic
MouseShow
DEF SEG
END SUB

SUB Draw.Pic2 (imgfile AS STRING, cx1 AS INTEGER, cy1 AS INTEGER, cx2 AS INTEGER, cy2 AS INTEGER, x1 AS INTEGER, y1 AS INTEGER)
MouseHide
fic = FREEFILE
DIM xs AS INTEGER
DIM ys AS INTEGER
DIM zs AS STRING * 1
	OPEN imgfile FOR BINARY AS fic
		GET #fic, , xs
		GET #fic, , ys
		FOR y = cy2 TO cy1 STEP -1
		 SEEK #fic, ((199 - y) * xs) + ((319) - cx2) + 5
			FOR x = cx2 TO cx1 STEP -1
				GET #fic, , zs
				PSET (x1 + x - cx1, y1 + y - cy1), ASC(zs)
			NEXT x
		NEXT y
	CLOSE fic
MouseShow

END SUB

SUB draw.Text (Texte AS STRING, x1 AS INTEGER, y1 AS INTEGER, fcolor AS INTEGER, bcolor AS INTEGER)
MouseHide
	FOR i = 1 TO LEN(Texte)
	      a = ASC(MID$(Texte, i, 1))
	     FOR y = 0 TO 7
		FOR x = 0 TO 7
		   IF (ASC(fontdata(a, y)) AND (2 ^ (7 - x))) = (2 ^ (7 - x)) THEN
			PSET (x1 + x, y1 + y), fcolor
		   ELSE
			IF bcolor <> -1 THEN PSET (x1 + x, y1 + y), bcolor
		   END IF
		NEXT x
	       
	     NEXT y
	      x1 = x1 + 8
	NEXT i
MouseShow
END SUB

FUNCTION getvar$ (inifile AS STRING, nomdevariable AS STRING)
	 fic = FREEFILE
	 DIM chaine AS STRING
	 OPEN inifile FOR INPUT AS fic
	 DO UNTIL EOF(fic)
	    INPUT #fic, chaine
	    chaine = LTRIM$(RTRIM$(chaine))
	    'si c'est un commentaire, on l'ignore
	    IF LEFT$(chaine, 1) <> "#" THEN

		'on supprime les commentaires dans la ligne
		FOR i = 1 TO LEN(chaine)
			IF MID$(chaine, i, 1) = "#" THEN
				chaine = LTRIM$(RTRIM$(LEFT$(chaine, i - 1)))
				EXIT FOR
			END IF
		NEXT i
		FOR i = 1 TO LEN(chaine)
			IF MID$(chaine, i, 1) = "=" THEN
				variable$ = LTRIM$(RTRIM$(LEFT$(chaine, i - 1)))
				IF variable$ = nomdevariable THEN
				valeur$ = LTRIM$(RTRIM$(MID$(chaine, i + 1)))
				'on cherche d'eventuelles combinaisons
				debut = 1
debutb:
				FOR j = debut TO LEN(valeur$)
					IF MID$(valeur$, j, 1) = "%" THEN
					      FOR k = j + 1 TO LEN(valeur$)
						       IF MID$(valeur$, k, 1) = "%" THEN
						       dd$ = MID$(valeur$, j + 1, k - j - 1)
						       valeur$ = LEFT$(valeur$, j - 1) + getvar$(inifile, dd$) + MID$(valeur$, k + 1)
							GOTO debutb
						      
						       END IF
					      NEXT k
					      valeur$ = ""
					      GOTO suiteb
					END IF
				NEXT j
			       
suiteb:
				IF LCASE$(nomdevariable) = LCASE$(variable$) THEN
					retval$ = valeur$
					GOTO suite
				END IF
				END IF
			END IF
		NEXT i
	    END IF
	 LOOP
	 retval$ = ""
suite:
CLOSE fic
getvar$ = LTRIM$(RTRIM$(retval$))
END FUNCTION

SUB Init.Button (this AS button, t AS STRING, x AS INTEGER, y AS INTEGER)
	this.x1 = x
	this.y1 = y
	this.text = t
	this.hover = 0
	this.pressed = 0
	this.y2 = y + 10
	this.x2 = x + (LEN(t) * 8) + 4

END SUB

SUB Initx.Button (this AS button, t AS STRING, x1 AS INTEGER, y1 AS INTEGER, x2 AS INTEGER, y2 AS INTEGER)
this.x1 = x1
this.y1 = y1
IF x2 <> 0 THEN
	this.x2 = x2
ELSE
	this.x2 = this.x1 + 4 + LEN(t) * 8
END IF
this.y2 = y2
this.text = t
this.hover = 0
this.pressed = 0
END SUB

SUB Load.BMP (bmpfile AS STRING, x1 AS INTEGER, y1 AS INTEGER)
       DIM BmpHeader AS BMPHeaderType
       fic = FREEFILE
       OPEN bmpfile FOR BINARY AS #fic
       GET #fic, , BmpHeader

	DIM Pixel AS STRING * 1
	iHeight% = BmpHeader.hei
	iWidth% = BmpHeader.wid
	FOR y% = iHeight% - 1 TO 0 STEP -1
		FOR x% = iWidth% - 1 TO 0 STEP -1
			GET #fic, , Pixel
			PSET (x1 + x% - 1, y1 + y% - 1), ASC(Pixel)
		NEXT x%
	NEXT y%
	CLOSE fic
END SUB

SUB load.bsv (image AS STRING)
	DEF SEG = &HA000
	BLOAD image
	DEF SEG
END SUB

SUB load.font (fontfile AS STRING)
fic = FREEFILE
OPEN fontfile FOR BINARY AS fic
FOR i = 0 TO 255
	FOR y = 0 TO 7
		GET #fic, , fontdata(i, y)
	NEXT y
NEXT i
CLOSE fic
END SUB

FUNCTION MouseClicLeft
	regs.ax = 3
	CALL INTERRUPT(&H33, regs, regs)
	MouseClicLeft = ((regs.bx AND 1) = 1)
END FUNCTION

FUNCTION MouseClicRight
	regs.ax = 3
	CALL INTERRUPT(&H33, regs, regs)
	MouseClicRight = ((regs.bx AND 2) = 2)
END FUNCTION

SUB MouseHide
	regs.ax = 2
	CALL INTERRUPT(&H33, regs, regs)
END SUB

SUB MouseShow
	regs.ax = 1
	CALL INTERRUPT(&H33, regs, regs)

END SUB

FUNCTION MouseTest
	regs.ax = 0
	CALL INTERRUPT(&H33, regs, regs)
	MouseTest = regs.ax
END FUNCTION

FUNCTION MouseX
	regs.ax = 3
	CALL INTERRUPT(&H33, regs, regs)
	MouseX = (regs.cx) \ 2
END FUNCTION

FUNCTION MouseY
	regs.ax = 3
	CALL INTERRUPT(&H33, regs, regs)
	MouseY = regs.dx
END FUNCTION

FUNCTION MouseZOne (x1 AS INTEGER, y1 AS INTEGER, x2 AS INTEGER, y2 AS INTEGER)
	 IF (MouseX >= x1 AND MouseX <= x2 AND MouseY >= y1 AND MouseY <= y2) THEN
		MouseZOne = -1
	 ELSE
		MouseZOne = 0
	 END IF
END FUNCTION

SUB setvar (inifile AS STRING, variable AS STRING, valeur AS STRING)

DIM chaine AS STRING
DIM nbrvars AS INTEGER
	 fic = FREEFILE
	 rep = -1
	 OPEN inifile FOR INPUT AS fic
	 nbrvars = 0
	 IF rep = -1 THEN
	 DO UNTIL EOF(fic)
	    LINE INPUT #fic, chaine
	    chaine = LTRIM$(RTRIM$(chaine))
	    nbrvars = nbrvars + 1
	 LOOP
	 END IF
	 CLOSE fic

	 DIM vartab(0 TO nbrvars) AS STRING

	IF nbrvars > 0 THEN
	 OPEN inifile FOR INPUT AS fic
	 FOR i = 0 TO nbrvars - 1
	    INPUT #fic, vartab(i)
	 NEXT i
	 CLOSE fic
       


	 FOR a = 0 TO nbrvars - 1
	       chaine = vartab(a)
	       chaine = LTRIM$(RTRIM$(chaine))
	       IF LEFT$(chaine, 1) <> "#" AND chaine <> "" THEN


		'on supprime les commentaires dans la ligne
		FOR i = 1 TO LEN(chaine)
			IF MID$(chaine, i, 1) = "#" THEN
				chaine = LTRIM$(RTRIM$(LEFT$(chaine, i - 1)))
				
				EXIT FOR
			END IF
		NEXT i

		FOR i = 1 TO LEN(chaine)
			IF MID$(chaine, i, 1) = "=" THEN
				variable1$ = LTRIM$(RTRIM$(LEFT$(chaine, i - 1)))
				IF variable1$ = variable THEN
					vartab(a) = variable1$ + " = " + valeur
					GOTO fin
				END IF
       
			END IF
       
		NEXT i
       
		END IF
	NEXT a
	nbrvars = nbrvars + 1
	vartab(nbrvars - 1) = variable + "=" + valeur
	GOTO fin
       ELSE
	nbrvars = 1
	vartab(nbrvars - 1) = variable + "=" + valeur
	GOTO fin
       END IF
fin:

fic = FREEFILE
OPEN inifile FOR OUTPUT AS fic

FOR i = 0 TO nbrvars - 1
	PRINT #fic, vartab(i)
NEXT i
CLOSE fic
END SUB

