'$INCLUDE: 'lib\guilib.bi'
'$INCLUDE: 'lib\mouse.bi'
'$INCLUDE: 'lib\textbox.bi'
'$INCLUDE: 'lib\modules.bi'
'$INCLUDE: 'srcs\addrdv.str'

DECLARE FUNCTION FindOnly! (values AS STRING, search AS STRING)

TYPE RDV
	Day AS INTEGER
	Month AS INTEGER
	Year AS INTEGER
	Hour AS INTEGER
	Minuts AS INTEGER
	Title AS STRING * 100
	Adress AS STRING * 100
	DurationHour AS INTEGER
	DurationMinut AS INTEGER
END TYPE

GUI.Init

DIM SHARED wx1 AS INTEGER, wy1 AS INTEGER, wx2 AS INTEGER, wy2 AS INTEGER
DIM SHARED ConfirmButton AS Button
DIM SHARED CancelButton AS Button
DIM SHARED DateBtn AS Button
DIM SHARED MonthStr(1 TO 12) AS STRING
MonthStr(1) = txtMonthJan
MonthStr(2) = txtMonthFeb
MonthStr(3) = txtMonthMar
MonthStr(4) = txtMonthApr
MonthStr(5) = txtMonthMay
MonthStr(6) = txtMonthJun
MonthStr(7) = txtMonthJul
MonthStr(8) = txtMonthAug
MonthStr(9) = txtMonthSep
MonthStr(10) = txtMonthOct
MonthStr(11) = txtMonthNov
MonthStr(12) = txtMonthDec

d = VAL(opt$("d"))
m = VAL(opt$("m"))
y = VAL(opt$("y"))
IF d > 0 THEN
	CurrentDay = d
ELSE
	CurrentDay = VAL(MID$(DATE$, 4, 2))
END IF
IF m > 0 THEN
	CurrentMonth = m
ELSE
	CurrentMonth = VAL(LEFT$(DATE$, 2))
END IF
IF y > 0 THEN
	CurrentYear = y
ELSE
	CurrentYear = VAL(RIGHT$(DATE$, 4))
END IF



wx = 310
wy = 150
wx1 = (xres - wx) \ 2
wy1 = (yres - wy) \ 2
wx2 = wx1 + wx - 1
wy2 = wy1 + wy - 1
DIM TimeHTxt  AS TextBox
DIM TimeMTxt AS TextBox
DIM DurHTxt AS TextBox
DIM DurMTxt AS TextBox
DIM TitleTxt AS TextBox
DIM AdressTxt AS TextBox

Initx.Button ConfirmButton, "OK", wx1 + 5, wy2 - 25, wx1 + 55, wy2 - 5
Initx.Button CancelButton, "Cancel", wx2 - 55, wy2 - 25, wx2 - 5, wy2 - 5
Initx.Button DateBtn, "Change", wx2 - 55, wy1 + 5, wx2 - 5, wy1 + 25
Init.TextBox TimeHTxt, wx1 + 95, wy1 + 22, 3
Init.TextBox TimeMTxt, wx1 + 135, wy1 + 22, 3
Init.TextBox DurHTxt, wx1 + 95, wy1 + 42, 3
Init.TextBox DurMTxt, wx1 + 175, wy1 + 42, 3
Init.TextBox TitleTxt, wx1 + 95, wy1 + 62, 25
Init.TextBox AdressTxt, wx1 + 95, wy1 + 82, 25
TimeHTxt.text = "0"
TimeHTxt.textlen = 1
TimeMTxt.text = "0"
TimeMTxt.textlen = 1
DurHTxt.text = "0"
DurHTxt.textlen = 1
DurMTxt.text = "0"
DurMTxt.textlen = 1

GOSUB DrawDate
MouseShow
th$ = "0"
tm$ = "0"
dh$ = "0"
dm$ = "0"

DO
     a$ = INKEY$
     ScreenCapture a$
     IF (Click.Button(ConfirmButton) OR a$ = CHR$(13)) THEN
	ok = -1
	IF LEN(th$) = 0 THEN ok = 0
	IF LEN(dh$) = 0 THEN ok = 0
	IF LEN(tm$) = 0 THEN ok = 0
	IF LEN(dm$) = 0 THEN ok = 0
	IF TitleTxt.textlen = O THEN ok = 0
	IF ok THEN
		DIM entry AS RDV
			entry.Day = CurrentDay
			entry.Month = CurrentMonth
			entry.Year = CurrentYear
			entry.Hour = VAL(th$)
			entry.Minuts = VAL(tm$)
			entry.DurationHour = VAL(dh$)
			entry.DurationMinut = VAL(dm$)
			entry.Title = LEFT$(TitleTxt.text, TitleTxt.textlen)
			entry.Adress = LEFT$(AdressTxt.text, AdressTxt.textlen)
	fic = FREEFILE
	OPEN "system\planer.dat" FOR BINARY AS fic
		IF (LOF(fic) > 0) THEN SEEK fic, LOF(fic) + 1
		PUT #fic, , entry
	CLOSE fic
	EXIT DO
	ELSE
		Alert (txtAlertVerify)
	END IF
     END IF
     IF Click.Button(CancelButton) OR a$ = CHR$(27) THEN
	fic = FREEFILE
	OPEN "out.tmp" FOR OUTPUT AS fic
	       PRINT #fic, 0
	CLOSE fic
	EXIT DO
     END IF
     IF Click.Button(DateBtn) THEN
	a$ = SelectDate
	IF VAL(LEFT$(a$, 2)) <> 0 THEN
		CurrentDay = VAL(LEFT$(a$, 2))
		CurrentMonth = VAL(MID$(a$, 4, 2))
		CurrentYear = VAL(RIGHT$(a$, 4))
		GOSUB DrawDate
	END IF
     END IF
    
     Manage.TextBox TimeHTxt
     Manage.TextBox TimeMTxt
   
     Manage.TextBox DurHTxt
     Manage.TextBox DurMTxt

     Manage.TextBox TitleTxt
     Manage.TextBox AdressTxt

     IF TimeHTxt.TextChanged THEN
	ok = 0
	IF FindOnly("0123456789", LTRIM$(RTRIM$(TimeHTxt.text))) THEN
		IF VAL(LTRIM$(RTRIM$(TimeHTxt.text))) >= 0 AND VAL(LTRIM$(RTRIM$(TimeHTxt.text))) < 24 THEN ok = -1
	END IF
	IF ok THEN
		    th$ = LEFT$(TimeHTxt.text, TimeHTxt.textlen)
	ELSE
		TimeHTxt.text = th$
		TimeHTxt.textlen = LEN(th$)
		Draw.TextBox TimeHTxt
	END IF
     END IF
     IF TimeMTxt.TextChanged THEN
	ok = 0
	IF FindOnly("0123456789", LTRIM$(RTRIM$(TimeMTxt.text))) THEN
		IF VAL(LTRIM$(RTRIM$(TimeMTxt.text))) >= 0 AND VAL(LTRIM$(RTRIM$(TimeMTxt.text))) < 60 THEN ok = -1
	END IF
	IF ok THEN
		tm$ = LEFT$(TimeMTxt.text, TimeMTxt.textlen)
	ELSE
		TimeMTxt.text = tm$
		TimeMTxt.textlen = LEN(tm$)
		Draw.TextBox TimeMTxt
	END IF
     END IF

     'Duration COntrol
     IF DurHTxt.TextChanged THEN
	ok = 0
	IF FindOnly("0123456789", LTRIM$(RTRIM$(DurHTxt.text))) THEN
		IF VAL(LTRIM$(RTRIM$(DurHTxt.text))) >= 0 AND VAL(LTRIM$(RTRIM$(DurHTxt.text))) < 24 THEN ok = -1
	END IF
	IF ok THEN
		    dh$ = LEFT$(DurHTxt.text, DurHTxt.textlen)
	ELSE
		DurHTxt.text = dh$
		DurHTxt.textlen = LEN(dh$)
		Draw.TextBox DurHTxt
	END IF
     END IF
     IF DurMTxt.TextChanged THEN
	ok = 0
	IF FindOnly("0123456789", LTRIM$(RTRIM$(DurMTxt.text))) THEN
		IF (VAL(LTRIM$(RTRIM$(DurMTxt.text))) >= 0) AND (VAL(LTRIM$(RTRIM$(DurMTxt.text))) < 60) THEN ok = -1
	END IF
	IF ok THEN
		dm$ = LEFT$(DurMTxt.text, DurMTxt.textlen)
	ELSE

		DurMTxt.text = dm$
		DurMTxt.textlen = LEN(dm$)
		Draw.TextBox DurMTxt
	END IF
     END IF


LOOP
END

DrawDate:
	MouseHide
Draw.Window wx1, wy1 - 15, wx2, wy2, txtButtonNew
Draw.Button ConfirmButton
Draw.Button CancelButton
Draw.Button DateBtn

	DateStr$ = LTRIM$(STR$(CurrentDay)) + " " + MonthStr(CurrentMonth) + STR$(CurrentYear)
	IF LEN(LTRIM$(STR$(CurrentDay))) < 2 THEN DateStr$ = "0" + DateStr$
	LINE (wx1 + 5, wy1 + 11)-(wx2 - 70, wy1 + 21), BgCOlor, BF
	Draw.Text "Date : " + DateStr$, wx1 + 5, wy1 + 11, TextColor, BgCOlor

	Draw.Text "Time     :     :", wx1 + 5, wy1 + 25, TextColor, BgCOlor
	Draw.Text "Duration :     hours     minuts", wx1 + 5, wy1 + 45, TextColor, BgCOlor
	Draw.Text "Title    :", wx1 + 5, wy1 + 65, TextColor, BgCOlor
	Draw.Text "Address  :", wx1 + 5, wy1 + 85, TextColor, BgCOlor
	Draw.TextBox TimeHTxt
	Draw.TextBox TimeMTxt
	Draw.TextBox DurHTxt
	Draw.TextBox DurMTxt
	Draw.TextBox TitleTxt
	Draw.TextBox AdressTxt

MouseShow
RETURN

FUNCTION FindOnly (values AS STRING, search AS STRING)
	ok = 0
	FOR i = 1 TO LEN(search)
		ok = 0
		FOR j = 1 TO LEN(values)
			IF MID$(search, i, 1) = MID$(values, j, 1) THEN ok = 1
		NEXT j
	      
	NEXT i
	FindOnly = ok
END FUNCTION

