DECLARE FUNCTION IsFileName! (text AS STRING)
DECLARE FUNCTION GetPrevDir$ ()
DECLARE SUB LoadDir ()
'$INCLUDE: 'lib\guilib.bi'
'$INCLUDE: 'lib\mouse.bi'
'$INCLUDE: 'lib\modules.bi'
'$INCLUDE: 'lib\itemlist.bi'
'$INCLUDE: 'lib\textbox.bi'
'$INCLUDE: 'lib\shelf.bi'
'$INCLUDE: 'srcs\fselect.str'
'$DYNAMIC

GUI.Init

DIM SHARED mode AS STRING
DIM SHARED ext AS STRING
mode = opt$("mode")
ext = opt$("ext")

DIM SHARED wx1 AS INTEGER, wy1 AS INTEGER, wx2 AS INTEGER, wy2 AS INTEGER
DIM SHARED CurrDir AS STRING
DIM SHARED DirsList AS ItemList
DIM SHARED FilesLIst AS ItemList
DIM SHARED DirsData(1) AS ListItem
DIM SHARED FilesData(1) AS ListItem
DIM SHARED OpenButton AS button
DIM SHARED CancelButton AS button
DIM SHARED NbrDir AS INTEGER
DIM SHARED NbrFiles AS INTEGER
DIM SHARED FIleText AS TextBox
IF opt$("currdir") = "" THEN
	CurrDir = CurrentDir
ELSE
	CurrDir = LCASE$(LTRIM$(RTRIM$(opt$("currdir"))))
	IF LEN(CurrDir) > 3 AND RIGHT$(CurrDir, 1) = "\" THEN CurrDir = LEFT$(CurrDir, LEN(CurrDir) - 1)
	IF LEN(CurrDir) = 2 THEN CurrDir = CurrDir + "\"
	IF LEN(CurrDir) = 0 THEN CurrDir = "c:\"
END IF
wx = 300
wy = 135
wx1 = (xres - wx) \ 2
wy1 = (yres - wy) \ 2
wx2 = wx1 + wx - 1
wy2 = wy1 + wy - 1
	Init.ItemLIst DirsList, wx1 + 5, wy1 + 17, 1, 10
	Init.ItemLIst FilesLIst, wx1 + 90, wy1 + 17, 2, 8
	FilesLIst.Dragable = -1
	DirsList.MaxWidth = 9
	DirsList.MinWIdth = 9
Initx.Button OpenButton, mode, wx1 + 195, wy2 - 17, wx1 + 240, wy2 - 5
Initx.Button CancelButton, txtCancel, wx1 + 245, wy2 - 17, wx2 - 5, wy2 - 5
Init.TextBox FIleText, wx1 + 90, wy2 - 17, 12
Shelf.Load

debut:
LoadDir
MouseShow
Shelf.Draw
DO
     a$ = INKEY$
     ScreenCapture a$
     
     IF NbrDir > 0 THEN Manage.ItemList DirsList, DirsData()
     IF NbrFiles > 0 THEN Manage.ItemList FilesLIst, FilesData()
     IF DirsList.SelectionChanged THEN GOSUB ChangeDIr
     IF mode = "SAVE" THEN Manage.TextBox FIleText
     IF FilesLIst.SelectionChanged THEN
	FIleText.text = LTRIM$(RTRIM$(FilesLIst.SelectedText))
	FIleText.textlen = LEN(LTRIM$(RTRIM$(FilesLIst.SelectedText)))
	Draw.TextBox FIleText
     END IF
     IF FilesLIst.Draged THEN
	IF FilesLIst.DragY >= 470 THEN
		IF LEN(CurrDir) > 3 THEN
			SelectedFile$ = CurrDir + "\" + LTRIM$(RTRIM$(FilesLIst.DragedText))
		ELSE
			SelectedFile$ = CurrDir + LTRIM$(RTRIM$(FilesLIst.DragedText))
		END IF
		Shelf.AddItem SelectedFile$, FilesLIst.DragedText
	END IF
     END IF
     IF (Click.Button(OpenButton) OR a$ = CHR$(13)) AND IsFileName(FIleText.text) THEN
	ok = -1
		IF LEN(CurrDir) > 3 THEN
			SelectedFile$ = CurrDir + "\" + LTRIM$(RTRIM$(FIleText.text))
		ELSE
			SelectedFile$ = CurrDir + LTRIM$(RTRIM$(FIleText.text))
		END IF

	IF mode = "SAVE" THEN
	FOR i = 1 TO NbrFiles
		IF LCASE$(LTRIM$(RTRIM$(FilesData(i).text))) = LCASE$(LTRIM$(RTRIM$(FIleText.text))) THEN
			ok = Confirm(txtOverwrite)
		END IF
	NEXT i
		'if its a document, we will save the wor (indoc.tmp) to the selected file
		IF ok AND (opt$("DOCUMENT") = "YES") THEN
			OPEN SelectedFile$ FOR BINARY AS 1
			CLOSE 1
			KILL SelectedFile$
			NAME "indoc.tmp" AS SelectedFile$
		END IF
	END IF
	IF LCASE$(mode) = "open" THEN
		'if its a document, we will copy the work to the output file
		IF opt$("DOCUMENT") = "YES" THEN SHELL "copy " + SelectedFile$ + " outdoc.tmp>nul"
	END IF
	IF ok THEN
		fic = FREEFILE
		OPEN "out.tmp" FOR OUTPUT AS fic
			PRINT #fic, 1
			IF LEN(CurrDir) > 3 THEN
				PRINT #fic, CurrDir + "\" + LTRIM$(RTRIM$(FIleText.text))
			ELSE
				PRINT #fic, CurrDir + LTRIM$(RTRIM$(FIleText.text))
			END IF
		CLOSE fic
		EXIT DO
	END IF
     END IF
     IF Click.Button(CancelButton) OR a$ = CHR$(27) THEN
	fic = FREEFILE
	OPEN "out.tmp" FOR OUTPUT AS fic
	       PRINT #fic, 0
	CLOSE fic
	IF opt$("DOCUMENT") = "YES" AND LCASE$(mode) = "save" THEN KILL "indoc.tmp"
	EXIT DO
     END IF
LOOP
END

ChangeDIr:
			IF LTRIM$(RTRIM$(DirsList.SelectedText)) = ".." THEN
				CurrDir = GetPrevDir
			ELSEIF LTRIM$(RTRIM$(DirsList.SelectedText)) = "." THEN
				CurrDir = CurrDir
			ELSE
				IF RIGHT$(CurrDir, 1) = "\" THEN
					CurrDir = CurrDir + LTRIM$(RTRIM$(DirsList.SelectedText))
				ELSE
					CurrDir = CurrDir + "\" + LTRIM$(RTRIM$(DirsList.SelectedText))
				END IF
			END IF
			LoadDir
			RETURN
			
RETURN

REM $STATIC
FUNCTION GetPrevDir$
	IF LEN(CurrDir) = 3 THEN
		GetPrevDir$ = CurrDir
	ELSE
	  FOR i = LEN(CurrDir) TO 3 STEP -1
		IF MID$(CurrDir, i, 1) = "\" THEN
			GetPrevDir$ = LEFT$(CurrDir, i - 1)
			IF i = 3 THEN GetPrevDir = LEFT$(CurrDir, 3)
			EXIT FUNCTION
		END IF
	  NEXT i
	END IF
END FUNCTION

FUNCTION IsFileName (text AS STRING)
	IF LEN(LTRIM$(RTRIM$(text))) > 12 THEN
		IsFileName = 0
		EXIT FUNCTION
	ELSEIF LEN(LTRIM$(RTRIM$(text))) < 1 THEN
		IsFileName = 0
		EXIT FUNCTION
	ELSEIF LEN(LTRIM$(RTRIM$(text))) > 8 AND INSTR(text, ".") > 9 THEN
		 IsFileName = 0
		 EXIT FUNCTION
	END IF
	IsFileName = -1
END FUNCTION

SUB LoadDir
	SHELL "dir " + CurrDir + " /b /ad >dirs.tmp"
	IF (ext = "") THEN
		SHELL "dir " + CurrDir + " /b >files.tmp"
	ELSE
		IF RIGHT$(CurrDir, 1) <> "\" THEN
			SHELL "dir " + CurrDir + "\*." + ext + " /b >files.tmp"
		ELSE
			SHELL "dir " + CurrDir + "*." + ext + " /b >files.tmp"
		END IF


	END IF

	DirsList.firstitem = 0
	FilesLIst.firstitem = 0

	fic = FREEFILE
	NbrDir = 0
	OPEN "dirs.tmp" FOR INPUT AS fic
		WHILE NOT EOF(fic)
			NbrDir = NbrDir + 1
			LINE INPUT #fic, ligne$
		WEND
	CLOSE fic

	
		IF LEN(CurrDir) = 3 THEN
			min = 1
			REDIM DirsData(1 TO NbrDir) AS ListItem
		ELSE
			NbrDir = NbrDir + 1
			REDIM DirsData(1 TO NbrDir) AS ListItem
			min = 2
			DirsData(1).text = ".."
			DirsData(1).selected = 0
		END IF
       
	
	OPEN "dirs.tmp" FOR INPUT AS fic
		FOR i = min TO NbrDir
			LINE INPUT #fic, ligne$
			DirsData(i).text = LTRIM$(RTRIM$(ligne$))
			DirsData(i).selected = 0
		NEXT i
	CLOSE fic
	
	KILL "dirs.tmp"
	
	fic = FREEFILE
	NbrFiles = 0
	OPEN "files.tmp" FOR INPUT AS fic
		WHILE NOT EOF(fic)
			
			LINE INPUT #fic, ligne$
			ok = 1
			FOR z = 1 TO NbrDir
				IF LCASE$(LTRIM$(RTRIM$(ligne$))) = LCASE$(LTRIM$(RTRIM$(DirsData(z).text))) THEN ok = 0: EXIT FOR
			NEXT z
			IF LCASE$(RIGHT$(LTRIM$(RTRIM$(ligne$)), 4)) = ".tmp" THEN ok = 0
			IF LCASE$(RIGHT$(LTRIM$(RTRIM$(ligne$)), 3)) = ".sc" THEN ok = 0

			NbrFiles = NbrFiles + ok
		WEND
	CLOSE fic
	IF NbrFiles > 0 THEN
	i = 1
	REDIM FilesData(1 TO NbrFiles)   AS ListItem
	OPEN "files.tmp" FOR INPUT AS fic
		WHILE NOT EOF(fic)
			LINE INPUT #fic, ligne$
			ok = 1
			FOR z = 1 TO NbrDir
				IF LCASE$(LTRIM$(RTRIM$(ligne$))) = LCASE$(LTRIM$(RTRIM$(DirsData(z).text))) THEN ok = 0: EXIT FOR
			NEXT z
			IF LCASE$(RIGHT$(LTRIM$(RTRIM$(ligne$)), 4)) = ".tmp" THEN ok = 0
			IF LCASE$(RIGHT$(LTRIM$(RTRIM$(ligne$)), 3)) = ".sc" THEN ok = 0
		       
			IF ok = 1 THEN
				FilesData(i).text = LTRIM$(RTRIM$(ligne$))
				FilesData(i).selected = 0
				i = i + 1
			END IF
		WEND
	CLOSE fic
	END IF
	KILL "files.tmp"


	MouseHide
	t$ = "file"
	IF opt$("DOCUMENT") = "YES" THEN t$ = "document"
	Draw.Window wx1, wy1 - 15, wx2, wy2, txtSelect + t$
	IF NbrDir > 0 THEN Draw.ItemList DirsList, DirsData()
	IF NbrFiles > 0 THEN Draw.ItemList FilesLIst, FilesData()
	LINE (wx1 + 85, wy1 + 10)-(wx1 + 85, wy2 - 10), 0, B
	Draw.Button OpenButton
	Draw.Button CancelButton
	Draw.TextBox FIleText
	MouseShow

END SUB

