'$INCLUDE: 'lib\guilib.bi'
'$INCLUDE: 'lib\app.bi'
'$INCLUDE: 'lib\mouse.bi'

DIM SHARED menuitems(0 TO 10) AS button
DIM SHARED nbrmenuitem AS INTEGER

SUB App.AddMenuItem (t AS STRING)
	h = 15
	Initx.Button menuitems(nbrmenuitem), t, 0, 15 + nbrmenuitem * h, 50, 15 + (h - 1) + nbrmenuitem * h
	nbrmenuitem = nbrmenuitem + 1
	IF nbrmenuitem = 1 THEN
		menuitems(0).style = 0
	ELSE
		menuitems(0).style = 1
		IF nbrmenuitem > 2 THEN menuitems(nbrmenuitem - 2).style = 2
		menuitems(nbrmenuitem - 1).style = 3
	END IF
	maxlen = 0
	FOR i = 0 TO nbrmenuitem - 1
		IF maxlen < LEN(LTRIM$(RTRIM$(menuitems(i).text))) THEN maxlen = LEN(LTRIM$(RTRIM$(menuitems(i).text)))
	NEXT i
	FOR i = 0 TO nbrmenuitem - 1
		menuitems(i).x2 = maxlen * 8 + 10
	NEXT i
END SUB

SUB App.DrawClock
	Draw.Text Clock, exitbtn.x1 - 44, 4, TextColor, BgColor
END SUB

SUB App.DrawGui
	LINE (0, 0)-(639, 479), BgColor, BF
	LINE (0, 0)-(639, 479), BorderColor2, B
	LINE (0, 0)-(638, 478), BorderColor1, B
	LINE (1, 478)-(1, 1), BorderColor1
	LINE -(638, 1), BorderColor1


	Initx.Button exitbtn, "X", xres - 15, 0, xres - 1, 14
	LINE (appbtn.x2 + 1, 0)-(exitbtn.x1 - 1, 14), BgColor, BF
	LINE (appbtn.x2 + 1, 0)-(exitbtn.x1 - 2, 13), BorderColor1, B
	LINE (exitbtn.x1 - 1, 0)-(exitbtn.x1 - 1, 14), BorderColor2
	LINE -(appbtn.x2 + 1, 14), BorderColor2
	Draw.Button appbtn
	Draw.Button exitbtn
END SUB

SUB App.Exec (cmdline AS STRING)
	DIM cmd AS STRING
	cmd = LTRIM$(RTRIM$(cmdline))
	IF INSTR(cmd, " ") > 0 THEN
		OPEN "cmdline" FOR OUTPUT AS 1
			PRINT #1, , MID$(cmd, INSTR(cmd, " ") + 1)
		CLOSE 1
		CHAIN LEFT$(cmd, INSTR(cmd, " ") - 1)
	ELSE
		CHAIN cmd
	END IF
END SUB

SUB app.Exit
	CHAIN "Bin\Desktop.exe"
	SCREEN 0
	WIDTH 80, 25
	END
END SUB

SUB App.Manage
	App.ManageKey INKEY$
END SUB

SUB App.ManageKey (c AS STRING)
	SelectedMenu = ""
	DIM tx1 AS INTEGER, ty1 AS INTEGER, tx2 AS INTEGER, ty2 AS INTEGER
	tx1 = 0
	tx2 = menuitems(0).x2
	ty1 = 15
	ty2 = 29 + nbrmenuitem * 15
	tx = 76
	ty = (ty2 - ty1) + 1
	DIM bg(tx * ty)
       
	IF Click.Button(exitbtn) THEN SelectedMenu = "Exit"
	IF Click.Button(appbtn) AND nbrmenuitem > 0 THEN
	     MouseHide
	     GET (tx1, ty1)-(tx2, ty2), bg
	     FOR i = 0 TO nbrmenuitem - 1
		Draw.Button menuitems(i)
	     NEXT i
	     MouseShow
	     SelectedMenu = ""
	     DO
		FOR i = 0 TO nbrmenuitem - 1
		       IF Click.Button(menuitems(i)) THEN
			SelectedMenu = LTRIM$(RTRIM$(menuitems(i).text))
			EXIT DO
		       END IF
		NEXT i
		IF Click.Button(appbtn) THEN EXIT DO
	       
	     LOOP UNTIL MouseClicLeft AND (NOT MouseZOne(tx1, ty1, tx2, ty2))
	     MouseHide
	     PUT (tx1, ty1), bg, PSET
	     MouseShow
	END IF
	IF Clock <> LEFT$(TIME$, 5) THEN
		Clock = LEFT$(TIME$, 5)
		App.DrawClock
	END IF
       
      
	ScreenCapture c$

END SUB

SUB App.SetTitle (t AS STRING)
	Initx.Button appbtn, t, 0, 0, 0, 14
END SUB

