'$INCLUDE: 'lib\guilib.bi'
'$INCLUDE: 'lib\mouse.bi'
'$INCLUDE: 'lib\modules.bi'
'$INCLUDE: 'lib\reg.bi'
'$INCLUDE: 'lib\locale.bi'
'$INCLUDE: 'lib\textbox.bi'
'$INCLUDE: 'lib\app.bi'

DECLARE SUB RemoveIcon ()
DECLARE SUB AddIcon ()
DECLARE SUB Store ()
DECLARE SUB clean ()
DECLARE SUB RemoveGroup ()
DECLARE SUB AddGroup ()
DECLARE SUB SaveCurrent ()
DECLARE SUB LoadApps ()
TYPE AppIcon
	IconFIle AS STRING * 25
	AppFile AS STRING * 25
	Descr AS STRING * 50
END TYPE
'$DYNAMIC

DIM SHARED NbrGroup AS INTEGER
DIM SHARED GroupNames(1) AS STRING
DIM SHARED NbrIcons(1) AS INTEGER
DIM SHARED Icons(1, 1) AS AppIcon

DIM SHARED SelectedGroup AS INTEGER
DIM SHARED SelectedIcon AS INTEGER

SelectedGroup = 1
SelectedIcon = 1


DIM SHARED wx1 AS INTEGER, wy1 AS INTEGER, wx2 AS INTEGER, wy2 AS INTEGER
wx = 350
wy = 100
wx1 = (640 - wx) / 2
wy1 = (495 - wy) / 2
wx2 = wx1 + wx - 1
wy2 = wy1 + wy - 1


DIM SHARED NextGroupBtn AS button
DIM SHARED PrevGroupBtn AS button
DIM SHARED AddGroupBtn AS button
DIM SHARED RmGroupBtn AS button
DIM SHARED GroupNameTxt AS TextBox

DIM SHARED AddIconBtn AS button
DIM SHARED RmIconBtn AS button
DIM SHARED NextIconBtn AS button
DIM SHARED PrevIconBtn AS button
DIM SHARED IconDescrTxt AS TextBox
DIM SHARED IconExecTxt AS TextBox
DIM SHARED IconIcoTxt AS TextBox
DIM SHARED SelectExec AS button
DIM SHARED SelectIcon AS button

Initx.Button RmGroupBtn, "-", wx1 + 5, wy2 - 20, wx1 + 20, wy2 - 5
Initx.Button AddGroupBtn, "+", wx2 - 20, wy2 - 20, wx2 - 5, wy2 - 5
Initx.Button PrevGroupBtn, CHR$(17), wx1 + 25, wy2 - 20, wx1 + 40, wy2 - 5
Initx.Button NextGroupBtn, CHR$(16), wx2 - 40, wy2 - 20, wx2 - 25, wy2 - 5
Init.TextBox GroupNameTxt, wx1 + 100, wy2 - 18, 15

Initx.Button RmIconBtn, "-", wx1 + 10, wy2 - 45, wx1 + 25, wy2 - 30
Initx.Button AddIconBtn, "+", wx2 - 25, wy2 - 45, wx2 - 10, wy2 - 30
Initx.Button PrevIconBtn, CHR$(17), wx1 + 30, wy2 - 45, wx1 + 45, wy2 - 30
Initx.Button NextIconBtn, CHR$(16), wx2 - 45, wy2 - 45, wx2 - 30, wy2 - 30
Init.TextBox IconDescrTxt, wx1 + 100, wy2 - 43, 15
Init.TextBox IconExecTxt, wx1 + 100, wy1 + 10, 20
Init.TextBox IconIcoTxt, wx1 + 100, wy1 + 30, 20
Initx.Button SelectExec, "Select", wx2 - 70, wy1 + 10, wx2 - 10, wy1 + 25
Initx.Button SelectIcon, "Select", wx2 - 70, wy1 + 30, wx2 - 10, wy1 + 45

LoadApps
IF NbrGroup = 0 THEN
	SelectedGroup = 0
	SelectedIcon = 0
ELSE
	IF NbrIcons(1) = 0 THEN SelectedIcon = 0
END IF



App.SetTitle ("App Manager")
App.AddMenuItem (Localize("System.str", "txtExit"))
GUI.Init
App.DrawGui

GOSUB DrawFiche
MouseShow
DO
	App.Manage
	IF SelectedMenu <> "" THEN
	SELECT CASE SelectedMenu
		CASE "Exit"
			SaveCurrent
			App.exit
	       
		CASE Localize("System.str", "txtExit"):
		SaveCurrent
		App.exit
	END SELECT
	END IF
	IF NbrGroup < 9 THEN
		IF Click.Button(AddGroupBtn) THEN
			AddGroup
			GOSUB DrawFiche
		END IF
	END IF

	IF SelectedGroup > 1 THEN
		IF Click.Button(PrevGroupBtn) THEN
			SaveCurrent
			SelectedGroup = SelectedGroup - 1
			SelectedIcon = NbrIcons(SelectedGroup)
			GOSUB DrawFiche
		END IF
	END IF
	IF SelectedGroup < NbrGroup THEN
		IF Click.Button(NextGroupBtn) THEN
			SaveCurrent
			SelectedGroup = SelectedGroup + 1
			SelectedIcon = NbrIcons(SelectedGroup)
			GOSUB DrawFiche
		END IF
	END IF
	IF SelectedGroup > 0 THEN
		IF Click.Button(AddIconBtn) THEN
			AddIcon
			GOSUB DrawFiche
		END IF

		IF SelectedIcon > 0 THEN
			IF Click.Button(RmIconBtn) THEN
				RemoveIcon
				GOSUB DrawFiche
			END IF
			IF Click.Button(SelectExec) THEN
				fichier$ = FileSelect("Open", CurrentDir + "\bin", "exe")
				IF fichier$ <> "" THEN
					IF LEFT$(LCASE$(fichier$), LEN(CurrentDir)) = LCASE$(CurrentDir) THEN fichier$ = MID$(fichier$, LEN(CurrentDir) + 2)
					IconExecTxt.Text = fichier$
					IconExecTxt.textlen = LEN(fichier$)
					Draw.TextBox IconExecTxt

				END IF
			END IF
			IF Click.Button(SelectIcon) THEN
				fichier$ = FileSelect("Open", CurrentDir + "\icons", "pic")
				IF fichier$ <> "" THEN
					IF LEFT$(LCASE$(fichier$), LEN(CurrentDir)) = LCASE$(CurrentDir) THEN fichier$ = MID$(fichier$, LEN(CurrentDir) + 2)
					IconIcoTxt.Text = fichier$
					IconIcoTxt.textlen = LEN(fichier$)
					Draw.TextBox IconIcoTxt
			       
				END IF
			END IF
			Manage.TextBox IconIcoTxt
			Manage.TextBox IconExecTxt
			Manage.TextBox IconDescrTxt
		END IF

		IF SelectedIcon > 1 THEN
			IF Click.Button(PrevIconBtn) THEN
				SaveCurrent
				SelectedIcon = SelectedIcon - 1
				GOSUB DrawFiche
			END IF
		END IF
		IF SelectedIcon < NbrIcons(SelectedGroup) THEN
			IF Click.Button(NextIconBtn) THEN
				SaveCurrent
				SelectedIcon = SelectedIcon + 1
				GOSUB DrawFiche
			END IF
		END IF
		Manage.TextBox GroupNameTxt
		IF Click.Button(RmGroupBtn) THEN
			RemoveGroup
			GOSUB DrawFiche
		END IF
	   END IF
LOOP


DrawFiche:
MouseHide
Draw.Window wx1, wy1 - 15, wx2, wy2, Localize("appmgr.str", "txtShelfIcons")


IF NbrGroup > 0 THEN Draw.Button RmGroupBtn
IF NbrGroup < 9 THEN Draw.Button AddGroupBtn
IF SelectedGroup < NbrGroup THEN Draw.Button NextGroupBtn
IF SelectedGroup > 1 THEN Draw.Button PrevGroupBtn
IF SelectedGroup <> 0 THEN
	GroupNameTxt.Text = GroupNames(SelectedGroup)
	GroupNameTxt.textlen = LEN(GroupNames(SelectedGroup))
	Draw.TextBox GroupNameTxt
END IF

LINE (wx1 + 5, wy1 + 5)-(wx2 - 5, wy2 - 25), 0, B
IF SelectedGroup > 0 THEN
	IF SelectedIcon > 0 THEN
		IconDescrTxt.Text = LTRIM$(RTRIM$(Icons(SelectedGroup, SelectedIcon).Descr))
		IconDescrTxt.textlen = LEN(LTRIM$(RTRIM$(Icons(SelectedGroup, SelectedIcon).Descr)))
		IconExecTxt.Text = LTRIM$(RTRIM$(Icons(SelectedGroup, SelectedIcon).AppFile))
		IconExecTxt.textlen = LEN(LTRIM$(RTRIM$(Icons(SelectedGroup, SelectedIcon).AppFile)))
		IconIcoTxt.Text = LTRIM$(RTRIM$(Icons(SelectedGroup, SelectedIcon).IconFIle))
		IconIcoTxt.textlen = LEN(LTRIM$(RTRIM$(Icons(SelectedGroup, SelectedIcon).IconFIle)))



		Draw.TextBox IconDescrTxt
		Draw.Text Localize("appmgr.str", "txtExecutable"), wx1 + 10, wy1 + 12, TextColor, -1
		Draw.Text Localize("appmgr.str", "txtIconFile"), wx1 + 10, wy1 + 32, TextColor, -1
		Draw.TextBox IconExecTxt
		Draw.TextBox IconIcoTxt
		Draw.Button SelectExec
		Draw.Button SelectIcon

	END IF
	IF SelectedIcon > 0 THEN Draw.Button RmIconBtn
	IF SelectedIcon < NbrIcons(SelectedGroup) THEN Draw.Button NextIconBtn
	IF SelectedIcon > 1 THEN Draw.Button PrevIconBtn
	Draw.Button AddIconBtn
END IF
MouseShow
RETURN

REM $STATIC
SUB AddGroup
	SaveCurrent
	NbrGroup = NbrGroup + 1
	RegWrite "Shelf:NbrGroup", LTRIM$(RTRIM$(STR$(NbrGroup)))
	RegWrite "Shelf:NbrIcons" + CHR$(48 + NbrGroup), "0"
	RegWrite "Shelf:GroupName" + CHR$(48 + NbrGroup), "New Group"
	LoadApps
	SelectedGroup = NbrGroup
	SelectedIcon = 0

END SUB

SUB AddIcon
	SaveCurrent
	NbrIcons(SelectedGroup) = NbrIcons(SelectedGroup) + 1
	N = NbrIcons(SelectedGroup)
	Icons(SelectedGroup, N).AppFile = "Exe file"
	Icons(SelectedGroup, N).IconFIle = "Icon File"
	Icons(SelectedGroup, N).Descr = "New icon"
	
	RegWrite "Shelf:NbrIcons" + CHR$(48 + SelectedGroup), LTRIM$(RTRIM$(STR$(N)))
	reg$ = "Shelf:Group" + CHR$(SelectedGroup + 48) + ":Icon" + LTRIM$(RTRIM$(STR$(N)))
	RegWrite reg$ + ":AppFile", Icons(SelectedGroup, N).AppFile
	RegWrite reg$ + ":IconFile", Icons(SelectedGroup, N).IconFIle
	RegWrite reg$ + ":Descr", Icons(SelectedGroup, N).Descr
	LoadApps
	SelectedIcon = N

END SUB

SUB clean
	Ng = VAL(RegRead("Shelf:NbrGroup"))
	FOR i = 1 TO Ng
		ni = VAL(RegRead("Shelf:NbrIcons" + CHR$(i + 48)))
		RegRemove "Shelf:GroupName" + CHR$(i + 48)
		RegRemove "Shelf:NbrIcons" + CHR$(i + 48)
		FOR j = 1 TO ni
			reg$ = "Shelf:Group" + CHR$(i + 48) + ":Icon" + LTRIM$(RTRIM$(STR$(j)))
			RegRemove reg$ + ":AppFile"
			RegRemove reg$ + ":IconFile"
		NEXT j
	NEXT i
END SUB

SUB LoadApps
	NbrGroup = VAL(RegRead("Shelf:NbrGroup"))
	IF NbrGroup > 9 THEN NbrGroup = 9
	REDIM GroupNames(1 TO NbrGroup + 1) AS STRING
	REDIM NbrIcons(1 TO NbrGroup + 1) AS INTEGER
	max = 0
	FOR i = 1 TO NbrGroup
		GroupNames(i) = RegRead("Shelf:GroupName" + CHR$(i + 48))
		NbrIcons(i) = VAL(RegRead("Shelf:NbrIcons" + CHR$(i + 48)))
		IF max < NbrIcons(i) THEN max = NbrIcons(i)
	NEXT i
	ERASE Icons
	REDIM Icons(1 TO NbrGroup + 1, 1 TO max + 1) AS AppIcon
	FOR i = 1 TO NbrGroup
		FOR j = 1 TO NbrIcons(i)
			reg$ = "Shelf:Group" + CHR$(i + 48) + ":Icon" + LTRIM$(RTRIM$(STR$(j)))
			Icons(i, j).AppFile = RegRead(reg$ + ":AppFile")
			Icons(i, j).IconFIle = RegRead(reg$ + ":IconFile")
			Icons(i, j).Descr = RegRead(reg$ + ":Descr")
		NEXT j
	NEXT i
END SUB

SUB RemoveGroup
	NbrGroup = NbrGroup - 1
	FOR i = SelectedGroup TO NbrGroup
		NbrIcons(i) = NbrIcons(i + 1)
		GroupNames(i) = GroupNames(i + 1)
		FOR j = 1 TO NbrIcons(i)
			Icons(i, j) = Icons(i + 1, j)
		NEXT j
	NEXT i
	clean
	Store
	LoadApps
	IF SelectedGroup > NbrGroup THEN SelectedGroup = NbrGroup
	IF SelectedGroup > 0 THEN
		SelectedIcon = NbrIcons(SelectedGroup)
	ELSE
		SelectedIcon = 0
	END IF
END SUB

SUB RemoveIcon
		NbrIcons(SelectedGroup) = NbrIcons(SelectedGroup) - 1
		FOR j = SelectedIcon TO NbrIcons(SelectedGroup)
				Icons(SelectedGroup, j) = Icons(SelectedGroup, j + 1)
		NEXT j

		reg$ = "Shelf:Group" + CHR$(SelectedGroup + 48) + ":Icon" + LTRIM$(RTRIM$(STR$(NbrIcons(SelectedGroup) + 1)))
		RegRemove (reg$ + ":AppFile")
		RegRemove (reg$ + ":IconFile")
		RegRemove (reg$ + ":Descr")
		RegWrite "Shelf:NbrIcons" + CHR$(SelectedGroup + 48), LTRIM$(RTRIM$(STR$(NbrIcons(SelectedGroup))))
		FOR j = SelectedIcon TO NbrIcons(SelectedGroup)
		  reg$ = "Shelf:Group" + CHR$(SelectedGroup + 48) + ":Icon" + LTRIM$(RTRIM$(STR$(j)))
		  RegWrite reg$ + ":AppFIle", Icons(SelectedGroup, j).AppFile
		  RegWrite reg$ + ":IconFile", Icons(SelectedGroup, j).IconFIle
		  RegWrite reg$ + ":Descr", Icons(SelectedGroup, j).Descr
		NEXT j
		LoadApps
		IF SelectedIcon > NbrIcons(SelectedGroup) THEN SelectedIcon = NbrIcons(SelectedGroup)
END SUB

SUB SaveCurrent
	IF SelectedGroup <> 0 THEN
		GroupNames(SelectedGroup) = LEFT$(GroupNameTxt.Text, GroupNameTxt.textlen)
		RegWrite "Shelf:GroupName" + CHR$(48 + SelectedGroup), GroupNames(SelectedGroup)
		IF SelectedIcon <> 0 THEN
			Icons(SelectedGroup, SelectedIcon).Descr = LEFT$(IconDescrTxt.Text, IconDescrTxt.textlen)
			Icons(SelectedGroup, SelectedIcon).IconFIle = LEFT$(IconIcoTxt.Text, IconIcoTxt.textlen)
			Icons(SelectedGroup, SelectedIcon).AppFile = LEFT$(IconExecTxt.Text, IconExecTxt.textlen)
			reg$ = "Shelf:Group" + CHR$(SelectedGroup + 48) + ":Icon" + LTRIM$(RTRIM$(STR$(SelectedIcon)))
			RegWrite reg$ + ":AppFile", Icons(SelectedGroup, SelectedIcon).AppFile
			RegWrite reg$ + ":IconFile", Icons(SelectedGroup, SelectedIcon).IconFIle
			RegWrite reg$ + ":Descr", Icons(SelectedGroup, SelectedIcon).Descr
		END IF
       
	END IF
END SUB

SUB Store
	RegWrite "Shelf:NbrGroup", LTRIM$(RTRIM$(STR$(NbrGroup)))
	FOR i = 1 TO NbrGroup
		RegWrite "Shelf:GroupName" + CHR$(i + 48), GroupNames(i)
		RegWrite "Shelf:NbrIcons" + CHR$(i + 48), LTRIM$(RTRIM$(STR$(NbrIcons(i))))
		FOR j = 1 TO NbrIcons(i)
			reg$ = "Shelf:Group" + CHR$(i + 48) + ":Icon" + LTRIM$(RTRIM$(STR$(j)))
			RegWrite reg$ + ":AppFile", Icons(i, j).AppFile
			RegWrite reg$ + ":IconFile", Icons(i, j).IconFIle
			RegWrite reg$ + ":Descr", Icons(i, j).Descr
		NEXT j
	NEXT i
END SUB

