DECLARE SUB SetFillRectangleBorder (x%, y%, Couleur%, Bord%)
DECLARE SUB SetFillRectangle (x%, y%, Couleur%)
DECLARE SUB SetRectangle (x%, y%, Couleur%)
DECLARE SUB SetLine (x%, y%, Couleur%)
DECLARE SUB SetPoint (x%, y%, Couleur%)
DECLARE SUB Manage.ToolBar ()
DECLARE SUB Draw.ToolBar ()

DECLARE SUB alert (message AS STRING)
DECLARE SUB GUI.Init ()
DECLARE SUB Draw.Window (x1 AS INTEGER, y1 AS INTEGER, x2 AS INTEGER, y2 AS INTEGER, title AS STRING)
DECLARE SUB MouseShow ()
DECLARE SUB MouseHide ()
DECLARE SUB App.SetTitle (t AS STRING)
DECLARE SUB App.AddMenuItem (t AS STRING)
DECLARE SUB App.DrawGui ()
DECLARE SUB App.Manage ()
DECLARE SUB app.Exit ()
DECLARE SUB Shelf.Load ()
DECLARE SUB Shelf.Draw ()
DECLARE SUB Manage.Grid ()
DECLARE SUB Manage.Palette ()
DECLARE SUB Draw.Palette ()
DECLARE SUB New.File ()
DECLARE SUB Open.File (filename AS STRING)
DECLARE SUB Save.File (filename AS STRING)
DECLARE SUB Draw.Grid ()
DECLARE SUB Draw.Point (x AS INTEGER, y AS INTEGER)
'$INCLUDE: 'lib\guilib.bi'
'$INCLUDE: 'lib\mouse.bi'
'$INCLUDE: 'lib\modules.bi'
'$INCLUDE: 'lib\textbox.bi'
'$INCLUDE: 'lib\app.bi'
'$INCLUDE: 'lib\reg.bi'
'$INCLUDE: 'lib\shelf.bi'
'$INCLUDE: 'lib\locale.bi'

DIM SHARED wx1 AS INTEGER, wy1 AS INTEGER, wx2 AS INTEGER, wy2 AS INTEGER
DIM SHARED px1 AS INTEGER, py1 AS INTEGER, px2 AS INTEGER, py2 AS INTEGER
DIM SHARED Couleurs(0 TO 31, 0 TO 31)
DIM SHARED SelectedColor1 AS INTEGER
DIM SHARED SelectedColor2 AS INTEGER
DIM SHARED prx1 AS INTEGER, pry1 AS INTEGER, prx2 AS INTEGER, pry2 AS INTEGER

px = 105
py = 145
wx = 331
wy = 331
prx = 42
pry = 42
wx1 = 50
wy1 = 100
wx2 = wx1 + wx - 1
wy2 = wy1 + wy - 1

px1 = (640 - px) - 50
py1 = 50
px2 = px1 + px - 1
py2 = py1 + py - 1

prx1 = (px1 + px2 - prx) / 2
pry1 = (py2 + wy2 - pry) / 2
prx2 = prx1 + prx - 1
pry2 = pry1 + pry - 1
App.SetTitle (Localize("iconedit.str", "txtTitle"))
App.AddMenuItem (Localize("system.str", "txtNew"))
App.AddMenuItem (Localize("system.str", "txtOpen"))
App.AddMenuItem (Localize("system.str", "txtSave"))
App.AddMenuItem (Localize("system.str", "txtSaveAs"))

IF VAL(RegRead("Network:Enabled")) = 1 THEN
	SessionID$ = RegRead("Live:SessionID")
	IF SessionID$ <> "" THEN
	       App.AddMenuItem (Localize("system.str", "txtLiveOpen"))
	       App.AddMenuItem (Localize("system.str", "txtLiveSave"))
	END IF
END IF
App.AddMenuItem (Localize("system.str", "txtExit"))
DIM SHARED SelectedTool AS INTEGER
SelectedColor1 = 0
SelectedColor2 = 255
SelectedTool = 0
New.File
GUI.Init
App.DrawGui
Draw.Window wx1, wy1 - 15, wx2, wy2, Localize("iconedit.str", "txtTitle")
Draw.Window prx1, pry1 - 15, prx2, pry2, ""
Draw.Grid
Draw.Window px1 - 5, py1 - 15, px2 + 5, py2, Localize("iconedit.str", "txtPaletteTitle")
Draw.Palette
Draw.ToolBar
OpenedFIle$ = ""
Shelf.Load
Shelf.Draw
MouseShow
DO
	SelectedMenu = ""
	App.Manage
	IF SelectedMenu <> "" THEN
	SELECT CASE SelectedMenu
		CASE "Exit"
			app.Exit
		CASE Localize("system.str", "txtExit")
			app.Exit
		CASE Localize("system.str", "txtNew")
				OpenedFIle$ = ""
				New.File
				Draw.Grid
		CASE Localize("system.str", "txtOpen")
			GOSUB OpenSUb
		CASE Localize("system.str", "txtSave")
			GOSUB SaveSub
		CASE Localize("system.str", "txtSaveAs")
			GOSUB SaveAsSub
		CASE Localize("system.str", "txtLiveOpen")
			fichier$ = NetFileSelect("open")
			IF fichier$ <> "" THEN
				Open.File "outdoc.tmp"
				KILL "outdoc.tmp"
				Draw.Grid
			END IF
		CASE Localize("system.str", "txtLiveSave")
			Save.File "indoc.tmp"
			fichier$ = NetFileSelect("save")

       
	END SELECT
	END IF
	Manage.Palette
	Manage.Grid
	Manage.ToolBar
	IF Shelf.Drag% THEN GOSUB OpenDragSub
LOOP



OpenDragSub:
	fichier$ = Shelf.Selected$
	IF LCASE$(RIGHT$(fichier$, 4)) <> ".pic" THEN RETURN
	Open.File fichier$
	Draw.Grid
	OpenedFIle$ = fichier$
RETURN

OpenSUb:
			fichier$ = FileSelect("open", CurrentDir + "\icons", "pic document=yes")
			Shelf.Load
			Shelf.Draw
			IF fichier$ <> "" THEN
				Open.File "outdoc.tmp"
				KILL "outdoc.tmp"
				Draw.Grid
				OpenedFIle$ = fichier$
			END IF

RETURN

SaveSub:
	IF OpenedFIle$ = "" THEN GOTO SaveAsSub
	Save.File OpenedFIle$
RETURN

SaveAsSub:
	Save.File "indoc.tmp"
	fichier$ = FileSelect("save", CurrentDir + "\icons", "pic document=yes")
	Shelf.Load
	Shelf.Draw
	IF fichier$ <> "" THEN OpenedFIle$ = fichier$
RETURN

SUB Draw.Grid
	DIM x AS INTEGER, y AS INTEGER
	FOR x = 0 TO 31
		FOR y = 0 TO 31
			Draw.Point x, y
		NEXT y
	NEXT x

END SUB

SUB Draw.Palette
	MouseHide
	FOR i = 0 TO 16
		x = i MOD 4
		y = i \ 4
		x1 = px1 + 9 + x * 22
		y1 = py1 + 9 + y * 22
			
		x2 = x1 + 20
		y2 = y1 + 20
		IF i < 16 THEN
		LINE (x1, y1)-(x2, y2), i, BF
		LINE (x1, y1)-(x2, y2), 0, B
		ELSE
		LINE (x1, y1)-(x2, y2), 15, BF
		LINE (x1, y1)-(x2, y2), 0, B
		LINE (x1, y1)-(x2, y2), 0
		LINE (x2, y1)-(x1, y2), 0
	       END IF
	NEXT i
	IF SelectedColor1 <> 255 THEN
	LINE (px1 + 25, py2 - 15)-(px1 + 45, py2 - 5), SelectedColor1, BF
	LINE (px1 + 25, py2 - 15)-(px1 + 45, py2 - 5), 0, B
	ELSE
	LINE (px1 + 25, py2 - 15)-(px1 + 45, py2 - 5), 15, BF
	LINE (px1 + 25, py2 - 15)-(px1 + 45, py2 - 5), 0, B
	LINE (px1 + 25, py2 - 15)-(px1 + 45, py2 - 5), 0
	LINE (px1 + 45, py2 - 15)-(px1 + 25, py2 - 5), 0
	END IF
	IF SelectedColor2 <> 255 THEN
	LINE (px2 - 45, py2 - 15)-(px2 - 25, py2 - 5), SelectedColor2, BF
	LINE (px2 - 45, py2 - 15)-(px2 - 25, py2 - 5), 0, B
	ELSE
	LINE (px2 - 45, py2 - 15)-(px2 - 25, py2 - 5), 15, BF
	LINE (px2 - 45, py2 - 15)-(px2 - 25, py2 - 5), 0, B
	LINE (px2 - 45, py2 - 15)-(px2 - 25, py2 - 5), 0
	LINE (px2 - 25, py2 - 15)-(px2 - 45, py2 - 5), 0
	END IF
	MouseShow




END SUB

SUB Draw.Point (x AS INTEGER, y AS INTEGER)
			MouseHide
			x1 = wx1 + 5 + x * 10
			y1 = wy1 + 5 + y * 10
			x2 = x1 + 10
			y2 = y1 + 10
			IF Couleurs(x, y) <> 255 THEN
				LINE (x1, y1)-(x2, y2), Couleurs(x, y), BF
				LINE (x1, y1)-(x2, y2), 0, B
				PSET (prx1 + 5 + x, pry1 + 3 + y), Couleurs(x, y)
			ELSE
				LINE (x1, y1)-(x2, y2), 15, BF
				LINE (x1, y1)-(x2, y2), 0, B
				LINE (x1, y1)-(x2, y2), 0
				c = ABS((x MOD 2) <> (y MOD 2)) * 15
				PSET (prx1 + 5 + x, pry1 + 3 + y), c
			END IF
			MouseShow

			
END SUB

DEFINT A-Z
SUB Draw.ToolBar
	MouseHide
	tx1 = 50
	ty1 = 35
	tx2 = 205
	ty2 = 70
	Draw.Frame tx1, ty1, tx2, ty2
	FOR i = 0 TO 4
	bg% = BGColor
	c% = TextColor
	IF SelectedTool = i THEN
		bg% = SelectBgColor
		c% = SelectTextColor
	END IF
	x1 = tx1 + 5 + (i * 30)
	y1 = ty1 + 5
	x2 = x1 + 25
	y2 = y1 + 25
	LINE (x1, y1)-(x2, y2), bg%, BF
	LINE (x1, y1)-(x2, y2), BorderColor1, B
       
		SELECT CASE i
			CASE 0
				LINE (x1 + 10, y1 + 10)-(x2 - 10, y2 - 10), c%, BF
			CASE 1
				LINE (x1 + 3, y1 + 12)-(x2 - 3, y1 + 13), c%, BF
			CASE 2
				LINE (x1 + 5, y1 + 5)-(x2 - 5, y2 - 5), c%, B
				LINE (x1 + 6, y1 + 6)-(x2 - 6, y2 - 6), c%, B
			CASE 3
				LINE (x1 + 5, y1 + 5)-(x2 - 5, y2 - 5), 8, BF
			CASE 4
				LINE (x1 + 5, y1 + 5)-(x2 - 5, y2 - 5), 8, BF
				LINE (x1 + 5, y1 + 5)-(x2 - 5, y2 - 5), c%, B
				LINE (x1 + 6, y1 + 6)-(x2 - 6, y2 - 6), c%, B
		      
		      
		       
		END SELECT
       
	NEXT i
	MouseShow
END SUB

DEFSNG A-Z
SUB Manage.Grid
	DIM x AS INTEGER, y AS INTEGER
	DIM x1 AS INTEGER, y1 AS INTEGER, x2 AS INTEGER, y2 AS INTEGER
	FOR x = 0 TO 31
		FOR y = 0 TO 31
			x1 = wx1 + 5 + x * 10
			y1 = wy1 + 5 + y * 10
			x2 = x1 + 10
			y2 = y1 + 10
			IF MouseZOne(x1, y1, x2, y2) THEN
				IF SelectedTool = 0 THEN
					IF MouseClicLeft THEN SetPoint x, y, SelectedColor1
					IF MouseClicRight THEN SetPoint x, y, SelectedColor2
				END IF
				IF SelectedTool = 1 THEN
					IF MouseClicLeft THEN SetLine x, y, SelectedColor1
					IF MouseClicRight THEN SetLine x, y, SelectedColor2
				END IF
		       
				IF SelectedTool = 2 THEN
					IF MouseClicLeft THEN SetRectangle x, y, SelectedColor1
					IF MouseClicRight THEN SetRectangle x, y, SelectedColor2
				END IF
				IF SelectedTool = 3 THEN
					IF MouseClicLeft THEN SetFillRectangle x, y, SelectedColor1
					IF MouseClicRight THEN SetFillRectangle x, y, SelectedColor2
				END IF
				IF SelectedTool = 4 THEN
					IF MouseClicLeft THEN SetFillRectangleBorder x, y, SelectedColor1, SelectedColor2
					IF MouseClicRight THEN SetFillRectangleBorder x, y, SelectedColor2, SelectedColor1
				END IF

			END IF
		NEXT y
	NEXT x

END SUB

SUB Manage.Palette
	IF NOT MouseZOne(px1, py1, px2, py2) THEN EXIT SUB
	DIM x1 AS INTEGER, y1 AS INTEGER, x2 AS INTEGER, y2 AS INTEGER
	FOR i = 0 TO 16
		x = i MOD 4
		y = i \ 4
		x1 = px1 + 9 + x * 22
		y1 = py1 + 9 + y * 22
		       
		x2 = x1 + 20
		y2 = y1 + 20

		IF MouseZOne(x1, y1, x2, y2) AND MouseClicLeft THEN
		DO: LOOP UNTIL NOT (MouseZOne(x1, y1, x2, y2) AND MouseClicLeft)
			IF MouseZOne(x1, y1, x2, y2) THEN
				IF i <> 16 THEN
				SelectedColor1 = i
				ELSE
				SelectedColor1 = 255
				END IF
				Draw.Palette
			END IF
		END IF
	       
		IF MouseZOne(x1, y1, x2, y2) AND MouseClicRight THEN
		DO: LOOP UNTIL NOT (MouseZOne(x1, y1, x2, y2) AND MouseClicRight)
			IF MouseZOne(x1, y1, x2, y2) THEN
				IF i <> 16 THEN
				SelectedColor2 = i
				ELSE
				SelectedColor2 = 255
				END IF
			       
				Draw.Palette
			END IF
		END IF

	NEXT i

END SUB

DEFINT A-Z
SUB Manage.ToolBar
	tx1 = 50
	ty1 = 35
	tx2 = 235
	ty2 = 70
	FOR i = 0 TO 5
	x1 = tx1 + 5 + (i * 30)
	y1 = ty1 + 5
	x2 = x1 + 25
	y2 = y1 + 25
	IF MouseClicLeft AND MouseZOne(x1, y1, x2, y2) THEN
		DO: LOOP UNTIL NOT (MouseClicLeft AND MouseZOne(x1, y1, x2, y2))
		IF MouseZOne(x1, y1, x2, y2) THEN
			SelectedTool = i
			Draw.ToolBar
		END IF
	END IF
	NEXT i
END SUB

DEFSNG A-Z
SUB New.File
	FOR x = 0 TO 31
		FOR y = 0 TO 31
			Couleurs(x, y) = 255
		NEXT y
	NEXT x
END SUB

SUB Open.File (filename AS STRING)
	fic = FREEFILE
DIM xs AS INTEGER
DIM ys AS INTEGER
DIM zs AS STRING * 1
       
	OPEN filename FOR BINARY AS fic
		GET #fic, , xs
		GET #fic, , ys
		FOR y = ys - 1 TO 0 STEP -1
			FOR x = xs - 1 TO 0 STEP -1
		      
				GET #fic, , zs
				Couleurs(x, y) = ASC(zs)
			NEXT x
		NEXT y
CLOSE fic

END SUB

SUB Save.File (filename AS STRING)
fic = FREEFILE
DIM xs AS INTEGER
DIM ys AS INTEGER
DIM zs AS STRING * 1
xs = 32
ys = 32
	OPEN filename FOR BINARY AS fic
		PUT #fic, , xs
		PUT #fic, , ys

		  FOR y = ys - 1 TO 0 STEP -1
			FOR x = xs - 1 TO 0 STEP -1
				zs = CHR$(Couleurs(x, y))
				PUT #fic, , zs
			NEXT x
		NEXT y
CLOSE fic


END SUB

SUB SetFillRectangle (x%, y%, Couleur%)
	DIM bgdata(15000)
	MouseHide
	GET (wx1 + 5, wy1 + 5)-(wx1 + 325, wy1 + 325), bgdata
	MouseShow
	DO:
		IF (ax% <> MouseX) OR (ay% <> MouseY) THEN
		      ax% = MouseX
		      ay% = MouseY
		FirstX% = x%
		FirstY% = y%
		LastX% = (MouseX - (wx1 + 5)) \ 10
		LastY% = (MouseY - (wy1 + 5)) \ 10
		IF LastX% < 0 THEN LastX% = 0
		IF LastX% > 31 THEN LastX% = 31
		IF LastY% < 0 THEN LastY% = 0
		IF LastY% > 31 THEN LastY% = 31

		MouseHide
		PUT (wx1 + 5, wy1 + 5), bgdata, PSET
		dx1 = wx1 + 10 + FirstX% * 10
		dy1 = wy1 + 10 + FirstY% * 10
		dx2 = wx1 + 10 + LastX% * 10
		dy2 = wy1 + 10 + LastY% * 10
		LINE (dx1, dy1)-(dx2, dy2), Couleur%, B
		MouseShow

		END IF
	LOOP UNTIL NOT (MouseClicLeft OR MouseClicRight)
	MouseHide
	PUT (wx1 + 5, wy1 + 5), bgdata, PSET
	MouseShow

	IF FirstX% > LastX% THEN SWAP FirstX%, LastX%
	IF FirstY% > LastY% THEN SWAP FirstY%, LastY%
	FOR xcpt% = FirstX% TO LastX%
		FOR ycpt% = FirstY% TO LastY%
			SetPoint xcpt%, ycpt%, Couleur%
		NEXT ycpt%
	NEXT xcpt%


END SUB

SUB SetFillRectangleBorder (x%, y%, Couleur%, Bord%)
	DIM bgdata(15000)
	MouseHide
	GET (wx1 + 5, wy1 + 5)-(wx1 + 325, wy1 + 325), bgdata
	MouseShow
	DO:
		IF (ax% <> MouseX) OR (ay% <> MouseY) THEN
		      ax% = MouseX
		      ay% = MouseY
		FirstX% = x%
		FirstY% = y%
		LastX% = (MouseX - (wx1 + 5)) \ 10
		LastY% = (MouseY - (wy1 + 5)) \ 10
		IF LastX% < 0 THEN LastX% = 0
		IF LastX% > 31 THEN LastX% = 31
		IF LastY% < 0 THEN LastY% = 0
		IF LastY% > 31 THEN LastY% = 31

		MouseHide
		PUT (wx1 + 5, wy1 + 5), bgdata, PSET
		dx1 = wx1 + 10 + FirstX% * 10
		dy1 = wy1 + 10 + FirstY% * 10
		dx2 = wx1 + 10 + LastX% * 10
		dy2 = wy1 + 10 + LastY% * 10
		LINE (dx1, dy1)-(dx2, dy2), Couleur%, B
		MouseShow

		END IF
	LOOP UNTIL NOT (MouseClicLeft OR MouseClicRight)
	MouseHide
	PUT (wx1 + 5, wy1 + 5), bgdata, PSET
	MouseShow

	IF FirstX% > LastX% THEN SWAP FirstX%, LastX%
	IF FirstY% > LastY% THEN SWAP FirstY%, LastY%
       
	FOR xcpt% = FirstX% TO LastX%
		SetPoint xcpt%, FirstY%, Bord%
		SetPoint xcpt%, LastY%, Bord%
	NEXT xcpt%

	FOR ycpt% = FirstY% TO LastY%
		SetPoint FirstX%, ycpt%, Bord%
		SetPoint LastX%, ycpt%, Bord%
	NEXT ycpt%
       
	FOR xcpt% = FirstX% + 1 TO LastX% - 1
		FOR ycpt% = FirstY% + 1 TO LastY% - 1
			SetPoint xcpt%, ycpt%, Couleur%
		NEXT ycpt%
	NEXT xcpt%
       

END SUB

SUB SetLine (x%, y%, Couleur%)
	DIM bgdata(15000)
	MouseHide
	GET (wx1 + 5, wy1 + 5)-(wx1 + 325, wy1 + 325), bgdata
	MouseShow
	DO:
		IF (ax% <> MouseX) OR (ay% <> MouseY) THEN
		      ax% = MouseX
		      ay% = MouseY
		FirstX% = x%
		FirstY% = y%
		LastX% = (MouseX - (wx1 + 5)) \ 10
		LastY% = (MouseY - (wy1 + 5)) \ 10
		IF LastX% < 0 THEN LastX% = 0
		IF LastX% > 31 THEN LastX% = 31
		IF LastY% < 0 THEN LastY% = 0
		IF LastY% > 31 THEN LastY% = 31

		MouseHide
		PUT (wx1 + 5, wy1 + 5), bgdata, PSET
		dx1 = wx1 + 10 + FirstX% * 10
		dy1 = wy1 + 10 + FirstY% * 10
		dx2 = wx1 + 10 + LastX% * 10
		dy2 = wy1 + 10 + LastY% * 10
		LINE (dx1, dy1)-(dx2, dy2), Couleur%
		MouseShow

		END IF
	LOOP UNTIL NOT (MouseClicLeft OR MouseClicRight)
	MouseHide
	PUT (wx1 + 5, wy1 + 5), bgdata, PSET
	MouseShow

	IF (FirstX% = LastX%) AND (FirstY% <> LastY%) THEN
		inc = 1: IF LastY% < FirstY% THEN inc = -1
		FOR ycpt% = FirstY% TO LastY% STEP inc
			SetPoint FirstX%, ycpt%, Couleur%
		NEXT
		EXIT SUB
	END IF

	IF (FirstY% = LastY%) AND (FirstX% <> LastX%) THEN
		inc = 1: IF LastX% < FirstX% THEN inc = -1
		FOR xcpt% = FirstX% TO LastX% STEP inc
			SetPoint xcpt%, FirstY%, Couleur%
		NEXT
		EXIT SUB
	END IF


	IF (FirstX% > LastX%) THEN
		x1% = LastX%: x2% = FirstX%
		y1% = LastY%: y2% = FirstY%
	ELSE
		x2% = LastX%: x1% = FirstX%
		y2% = LastY%: y1% = FirstY%
	END IF



       
	dx = x2% - x1%
	dy = y2% - y1%
	IF (dx = 0) AND (dy = 0) THEN EXIT SUB

	IF dy < 0 THEN
		dy = -dy
		inc1 = -1
		inc2 = 1
	ELSE
		inc1 = 1
		inc2 = 1
	END IF
	IF dx > dy THEN
		asub = dx - dy
		aerror = dy - (dx \ 2)
		remain = (dx + 1) \ 2
		DO
			SetPoint x1%, y1%, Couleur%
			IF (x2% < 32) THEN SetPoint x2%, y2%, Couleur%
			x1% = x1% + inc2: x2% = x2% - inc2
			IF (aerror >= 0) THEN
				y1% = y1% + inc1
				y2% = y2% - inc1
				aerror = aerror - asub
			ELSE
				aerror = aerror + dy
			END IF
			  remain = remain - 1
		LOOP WHILE (remain > 0)
		IF NOT (dx AND 1) THEN SetPoint x1%, y1%, Couleur%
	ELSE
		asub = dy - dx
		aerror = dx - (dy \ 2)
		remain = (dy + 1) \ 2
		DO
			SetPoint x1%, y1%, Couleur%
			IF (y2% < 32) THEN SetPoint x2%, y2%, Couleur%
			IF FirstX% > LastX% THEN
				IF FirstY% > LastY% THEN
				y1% = y1% + inc2: y2% = y2% - inc2
				ELSE
				y1% = y1% - inc2: y2% = y2% + inc2
				END IF
			ELSE
				IF FirstY% > LastY% THEN
				y1% = y1% - inc2: y2% = y2% + inc2
				ELSE
				y1% = y1% + inc2: y2% = y2% - inc2
				END IF
			END IF

			IF (aerror >= 0) THEN
				x1% = x1% + inc2: x2% = x2% - inc2
				aerror = aerror - asub
			ELSE
				aerror = aerror + dx
			END IF
			  remain = remain - 1
		LOOP WHILE (remain > 0)
		IF NOT (dy AND 1) THEN SetPoint x1%, y1%, Couleur%
	END IF
END SUB

SUB SetPoint (x%, y%, Couleur%)
     IF y% < 0 THEN EXIT SUB
     IF x% < 0 THEN EXIT SUB
     IF x% > 31 THEN EXIT SUB
     IF y% > 31 THEN EXIT SUB
					Couleurs(x%, y%) = Couleur%
					Draw.Point x%, y%

END SUB

SUB SetRectangle (x%, y%, Couleur%)
	DIM bgdata(15000)
	MouseHide
	GET (wx1 + 5, wy1 + 5)-(wx1 + 325, wy1 + 325), bgdata
	MouseShow
	DO:
		IF (ax% <> MouseX) OR (ay% <> MouseY) THEN
		      ax% = MouseX
		      ay% = MouseY
		FirstX% = x%
		FirstY% = y%
		LastX% = (MouseX - (wx1 + 5)) \ 10
		LastY% = (MouseY - (wy1 + 5)) \ 10
		IF LastX% < 0 THEN LastX% = 0
		IF LastX% > 31 THEN LastX% = 31
		IF LastY% < 0 THEN LastY% = 0
		IF LastY% > 31 THEN LastY% = 31

		MouseHide
		PUT (wx1 + 5, wy1 + 5), bgdata, PSET
		dx1 = wx1 + 10 + FirstX% * 10
		dy1 = wy1 + 10 + FirstY% * 10
		dx2 = wx1 + 10 + LastX% * 10
		dy2 = wy1 + 10 + LastY% * 10
		LINE (dx1, dy1)-(dx2, dy2), Couleur%, B
		MouseShow

		END IF
	LOOP UNTIL NOT (MouseClicLeft OR MouseClicRight)
	MouseHide
	PUT (wx1 + 5, wy1 + 5), bgdata, PSET
	MouseShow

	IF FirstX% > LastX% THEN SWAP FirstX%, LastX%
	IF FirstY% > LastY% THEN SWAP FirstY%, LastY%
	FOR xcpt% = FirstX% TO LastX%
		SetPoint xcpt%, FirstY%, Couleur%
		SetPoint xcpt%, LastY%, Couleur%
	NEXT xcpt%

	FOR ycpt% = FirstY% TO LastY%
		SetPoint FirstX%, ycpt%, Couleur%
		SetPoint LastX%, ycpt%, Couleur%
	NEXT ycpt%
END SUB

