DECLARE SUB Load.Reg ()
'$INCLUDE: 'lib\guilib.bi'
'$INCLUDE: 'lib\mouse.bi'
'$INCLUDE: 'lib\modules.bi'
'$INCLUDE: 'lib\app.bi'
'$INCLUDE: 'lib\multline.bi'
'$INCLUDE: 'lib\itemlist.bi'
'$INCLUDE: 'lib\reg.bi'
'$INCLUDE: 'lib\textbox.bi'

'$INCLUDE: 'lib\locale.bi'
'$DYNAMIC
DIM SHARED wx1 AS INTEGER, wy1 AS INTEGER, wx2 AS INTEGER, wy2 AS INTEGER
DIM SHARED NbrReg  AS INTEGER
DIM SHARED ItemData(1) AS ListItem
DIM SHARED Liste AS ItemList
DIM txtKey AS TextBox
DIM TxtVal AS TextBox
DIM UpdateBtn AS button
DIM NewKeyBtn AS button
DIM RemoveBtn AS button

wx = 315
wy = 180
wx1 = (640 - wx) / 2
wy1 = (495 - wy) / 2
wx2 = wx1 + wx - 1
wy2 = wy1 + wy - 1
Init.Button NewKeyBtn, Localize("regedit.str", "txtButtonNew"), wx1 + 5, wy1 + 5
Init.ItemLIst Liste, wx1 + 7, wy1 + 35, 1, 9
Liste.MinWIdth = 37
Liste.MaxWidth = 37
Init.TextBox txtKey, wx1 + 60, wy2 - 32, 20
Init.TextBox TxtVal, wx1 + 60, wy2 - 17, 20
Initx.Button RemoveBtn, Localize("regedit.str", "txtButtonRemove"), wx2 - 60, wy2 - 32, wx2 - 5, wy2 - 20
Initx.Button UpdateBtn, Localize("regedit.str", "txtButtonUpdate"), wx2 - 60, wy2 - 17, wx2 - 5, wy2 - 5

App.SetTitle (Localize("regedit.str", "txtTitle"))
App.AddMenuItem (Localize("system.str", "txtExit"))
SelectedKey$ = ""
Load.Reg
GUI.Init
App.DrawGui
Draw.Window wx1, wy1 - 15, wx2, wy2, Localize("regedit.str", "txtTitle")
Draw.Button NewKeyBtn
LINE (wx1 + 5, wy2 - 40)-(wx2 - 5, wy2 - 39), BorderColor2, B

GOSUB DrawVal
GOSUB DrawREg
MouseShow
DO
	IF Click.Button(NewKeyBtn) THEN

	    RegWrite "NewKey:" + LTRIM$(STR$(TIMER)), Localize("regedit.str", "txtNovalue")
	    Load.Reg
	    GOSUB DrawREg
	END IF
	IF SelectedKey$ <> "" THEN
		IF Click.Button(UpdateBtn) THEN
		   RegWrite SelectedKey$, LTRIM$(RTRIM$(TxtVal.text))
		   IF LTRIM$(RTRIM$(txtKey.text)) <> SelectedKey$ THEN
			RegRename SelectedKey$, LTRIM$(RTRIM$(txtKey.text))
			Load.Reg
			GOSUB DrawREg
			SelectedKey$ = ""
			GOSUB DrawVal
		   END IF
		END IF
		IF Click.Button(RemoveBtn) THEN
		  RegRemove SelectedKey$
		  Load.Reg
		  GOSUB DrawREg
		  SelectedKey$ = ""
		  GOSUB DrawVal
		END IF
		Manage.TextBox TxtVal
		Manage.TextBox txtKey
	END IF
	SelectedMenu = ""
	App.Manage
	Manage.ItemList Liste, ItemData()
	IF Liste.SelectionChanged THEN
		SelectedKey$ = LTRIM$(RTRIM$(Liste.SelectedText))
		GOSUB DrawVal
	END IF
	IF SelectedMenu <> "" THEN
	SELECT CASE SelectedMenu
		CASE "Exit"
			app.Exit
		CASE Localize("system.str", "txtExit")
			app.Exit
	END SELECT
	END IF
LOOP

DrawVal:
	MouseHide
	LINE (wx1 + 5, wy2 - 35)-(wx2 - 5, wy2 - 5), BGColor, BF
	IF SelectedKey$ = "" THEN MouseShow: RETURN
	k$ = LTRIM$(RTRIM$(SelectedKey$))
	v$ = LTRIM$(RTRIM$(RegRead$(k$)))
	txtKey.text = k$
	TxtVal.text = v$
	txtKey.textlen = LEN(k$)
	TxtVal.textlen = LEN(v$)
	
	Draw.Text Localize("regedit.str", "txtKey"), wx1 + 5, wy2 - 30, TextColor, -1
	Draw.Text Localize("regedit.str", "txtValue"), wx1 + 5, wy2 - 15, TextColor, -1
       
	Draw.TextBox txtKey
	Draw.TextBox TxtVal
	Draw.Button UpdateBtn
	Draw.Button RemoveBtn
	MouseShow
RETURN

DrawREg:
	MouseHide
	LINE (wx1 + 5, wy1 + 20)-(wx2 - 5, wy2 - 43), BGColor, BF
	IF NbrReg = 0 THEN MouseShow: RETURN
	Draw.ItemList Liste, ItemData()
	MouseShow
	RETURN

REM $STATIC
SUB Load.Reg
	fic = FREEFILE
	DIM areg AS RegKey
	OPEN "system\reg.dat" FOR BINARY AS fic
	      NbrReg = LOF(fic) \ LEN(areg)
	     IF NbrReg > 0 THEN
		REDIM ItemData(1 TO NbrReg) AS ListItem
		FOR i = 1 TO NbrReg
			GET #fic, , areg
			ItemData(i).selected = 0
			ItemData(i).text = areg.RegKey
		NEXT i
	     END IF
	CLOSE fic
END SUB

